<?php

/**
 *
 * 
 *
 * Generated by <a href="http://enunciate.webcohesion.com">Enunciate</a>.
 *
 */
 

namespace Org\Apache\Ranger\Common\View;

/**
 * (no documentation provided)
 */
class ViewBaseBean
{

    /**
     * Constructs a ViewBaseBean from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }


    /**
     * Initializes this ViewBaseBean from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ViewBaseBean from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of ViewBaseBean from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this ViewBaseBean to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerBaseModelObject
{

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $updateTime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $version;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $guid;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $id;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $isEnabled;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $createdBy;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $createTime;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $updatedBy;

    /**
     * Constructs a RangerBaseModelObject from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getUpdateTime()
    {
        return $this->updateTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $updateTime
     */
    public function setUpdateTime($updateTime)
    {
        $this->updateTime = $updateTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $version
     */
    public function setVersion($version)
    {
        $this->version = $version;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getGuid()
    {
        return $this->guid;
    }

    /**
     * (no documentation provided)
     *
     * @param string $guid
     */
    public function setGuid($guid)
    {
        $this->guid = $guid;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getIsEnabled()
    {
        return $this->isEnabled;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $isEnabled
     */
    public function setIsEnabled($isEnabled)
    {
        $this->isEnabled = $isEnabled;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getCreatedBy()
    {
        return $this->createdBy;
    }

    /**
     * (no documentation provided)
     *
     * @param string $createdBy
     */
    public function setCreatedBy($createdBy)
    {
        $this->createdBy = $createdBy;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getCreateTime()
    {
        return $this->createTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $createTime
     */
    public function setCreateTime($createTime)
    {
        $this->createTime = $createTime;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUpdatedBy()
    {
        return $this->updatedBy;
    }

    /**
     * (no documentation provided)
     *
     * @param string $updatedBy
     */
    public function setUpdatedBy($updatedBy)
    {
        $this->updatedBy = $updatedBy;
    }

    /**
     * Initializes this RangerBaseModelObject from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerBaseModelObject from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'updateTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->updateTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'version') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->version = $child;
            $happened = true;
        }
        else if (($xml->localName == 'guid') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->guid = $child;
            $happened = true;
        }
        else if (($xml->localName == 'id') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->id = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isEnabled') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isEnabled = $child;
            $happened = true;
        }
        else if (($xml->localName == 'createdBy') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->createdBy = $child;
            $happened = true;
        }
        else if (($xml->localName == 'createTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->createTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'updatedBy') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->updatedBy = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerBaseModelObject from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerBaseModelObject to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerBaseModelObject', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerBaseModelObject to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->updateTime) {
            $writer->startElementNs(null, 'updateTime', null);
            $writer->text($this->updateTime);
            $writer->endElement();
        }
        if ($this->version) {
            $writer->startElementNs(null, 'version', null);
            $writer->text($this->version);
            $writer->endElement();
        }
        if ($this->guid) {
            $writer->startElementNs(null, 'guid', null);
            $writer->text($this->guid);
            $writer->endElement();
        }
        if ($this->id) {
            $writer->startElementNs(null, 'id', null);
            $writer->text($this->id);
            $writer->endElement();
        }
        if ($this->isEnabled) {
            $writer->startElementNs(null, 'isEnabled', null);
            $writer->text($this->isEnabled);
            $writer->endElement();
        }
        if ($this->createdBy) {
            $writer->startElementNs(null, 'createdBy', null);
            $writer->text($this->createdBy);
            $writer->endElement();
        }
        if ($this->createTime) {
            $writer->startElementNs(null, 'createTime', null);
            $writer->text($this->createTime);
            $writer->endElement();
        }
        if ($this->updatedBy) {
            $writer->startElementNs(null, 'updatedBy', null);
            $writer->text($this->updatedBy);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerPolicyItem
{

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $groups;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $delegateAdmin;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemAccess[]
     */
    private $accesses;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemCondition[]
     */
    private $conditions;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $users;

    /**
     * Constructs a RangerPolicyItem from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getGroups()
    {
        return $this->groups;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $groups
     */
    public function setGroups($groups)
    {
        $this->groups = $groups;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getDelegateAdmin()
    {
        return $this->delegateAdmin;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $delegateAdmin
     */
    public function setDelegateAdmin($delegateAdmin)
    {
        $this->delegateAdmin = $delegateAdmin;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemAccess[]
     */
    public function getAccesses()
    {
        return $this->accesses;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemAccess[] $accesses
     */
    public function setAccesses($accesses)
    {
        $this->accesses = $accesses;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemCondition[]
     */
    public function getConditions()
    {
        return $this->conditions;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemCondition[] $conditions
     */
    public function setConditions($conditions)
    {
        $this->conditions = $conditions;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getUsers()
    {
        return $this->users;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $users
     */
    public function setUsers($users)
    {
        $this->users = $users;
    }

    /**
     * Initializes this RangerPolicyItem from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerPolicyItem from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'groups') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->groups)) {
                $this->groups = array();
            }
            array_push($this->groups, $child);
            $happened = true;
        }
        else if (($xml->localName == 'delegateAdmin') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->delegateAdmin = $child;
            $happened = true;
        }
        else if (($xml->localName == 'accesses') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemAccess($xml);
            if (!isset($this->accesses)) {
                $this->accesses = array();
            }
            array_push($this->accesses, $child);
            $happened = true;
        }
        else if (($xml->localName == 'conditions') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemCondition($xml);
            if (!isset($this->conditions)) {
                $this->conditions = array();
            }
            array_push($this->conditions, $child);
            $happened = true;
        }
        else if (($xml->localName == 'users') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->users)) {
                $this->users = array();
            }
            array_push($this->users, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPolicyItem from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerPolicyItem to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPolicyItem', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPolicyItem to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->groups) {
            foreach ($this->groups as $i => $x) {
                $writer->startElementNs(null, 'groups', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->delegateAdmin) {
            $writer->startElementNs(null, 'delegateAdmin', null);
            $writer->text($this->delegateAdmin);
            $writer->endElement();
        }
        if ($this->accesses) {
            foreach ($this->accesses as $i => $x) {
                $writer->startElementNs(null, 'accesses', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->conditions) {
            foreach ($this->conditions as $i => $x) {
                $writer->startElementNs(null, 'conditions', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->users) {
            foreach ($this->users as $i => $x) {
                $writer->startElementNs(null, 'users', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\Admin\Client\Datatype;

/**
 * (no documentation provided)
 */
class Message
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $fieldName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $message;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKey;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $objectId;

    /**
     * Constructs a Message from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getFieldName()
    {
        return $this->fieldName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $fieldName
     */
    public function setFieldName($fieldName)
    {
        $this->fieldName = $fieldName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * (no documentation provided)
     *
     * @param string $message
     */
    public function setMessage($message)
    {
        $this->message = $message;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKey()
    {
        return $this->rbKey;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKey
     */
    public function setRbKey($rbKey)
    {
        $this->rbKey = $rbKey;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getObjectId()
    {
        return $this->objectId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $objectId
     */
    public function setObjectId($objectId)
    {
        $this->objectId = $objectId;
    }

    /**
     * Initializes this Message from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of Message from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'fieldName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->fieldName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'message') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->message = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKey') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKey = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'objectId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->objectId = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of Message from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this Message to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->fieldName) {
            $writer->startElementNs(null, 'fieldName', null);
            $writer->text($this->fieldName);
            $writer->endElement();
        }
        if ($this->message) {
            $writer->startElementNs(null, 'message', null);
            $writer->text($this->message);
            $writer->endElement();
        }
        if ($this->rbKey) {
            $writer->startElementNs(null, 'rbKey', null);
            $writer->text($this->rbKey);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->objectId) {
            $writer->startElementNs(null, 'objectId', null);
            $writer->text($this->objectId);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerPluginInfo
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $hostName;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $createTime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $updateTime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $id;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $serviceName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $ipAddress;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $info;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $appType;

    /**
     * Constructs a RangerPluginInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getHostName()
    {
        return $this->hostName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $hostName
     */
    public function setHostName($hostName)
    {
        $this->hostName = $hostName;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getCreateTime()
    {
        return $this->createTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $createTime
     */
    public function setCreateTime($createTime)
    {
        $this->createTime = $createTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getUpdateTime()
    {
        return $this->updateTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $updateTime
     */
    public function setUpdateTime($updateTime)
    {
        $this->updateTime = $updateTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getServiceName()
    {
        return $this->serviceName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $serviceName
     */
    public function setServiceName($serviceName)
    {
        $this->serviceName = $serviceName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getIpAddress()
    {
        return $this->ipAddress;
    }

    /**
     * (no documentation provided)
     *
     * @param string $ipAddress
     */
    public function setIpAddress($ipAddress)
    {
        $this->ipAddress = $ipAddress;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getInfo()
    {
        return $this->info;
    }

    /**
     * (no documentation provided)
     *
     * @param array $info
     */
    public function setInfo($info)
    {
        $this->info = $info;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getAppType()
    {
        return $this->appType;
    }

    /**
     * (no documentation provided)
     *
     * @param string $appType
     */
    public function setAppType($appType)
    {
        $this->appType = $appType;
    }

    /**
     * Initializes this RangerPluginInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerPluginInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'hostName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->hostName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'createTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->createTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'updateTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->updateTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'id') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->id = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serviceName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->serviceName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'ipAddress') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->ipAddress = $child;
            $happened = true;
        }
        else if (($xml->localName == 'info') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->info = $child;
            $happened = true;
        }
        else if (($xml->localName == 'appType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->appType = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPluginInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerPluginInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPluginInfo', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPluginInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->hostName) {
            $writer->startElementNs(null, 'hostName', null);
            $writer->text($this->hostName);
            $writer->endElement();
        }
        if ($this->createTime) {
            $writer->startElementNs(null, 'createTime', null);
            $writer->text($this->createTime);
            $writer->endElement();
        }
        if ($this->updateTime) {
            $writer->startElementNs(null, 'updateTime', null);
            $writer->text($this->updateTime);
            $writer->endElement();
        }
        if ($this->id) {
            $writer->startElementNs(null, 'id', null);
            $writer->text($this->id);
            $writer->endElement();
        }
        if ($this->serviceName) {
            $writer->startElementNs(null, 'serviceName', null);
            $writer->text($this->serviceName);
            $writer->endElement();
        }
        if ($this->ipAddress) {
            $writer->startElementNs(null, 'ipAddress', null);
            $writer->text($this->ipAddress);
            $writer->endElement();
        }
        if ($this->info) {
            $writer->startElementNs(null, 'info', null);
            $writer->text($this->info);
            $writer->endElement();
        }
        if ($this->appType) {
            $writer->startElementNs(null, 'appType', null);
            $writer->text($this->appType);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerPolicyItemAccess
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $isAllowed;

    /**
     * Constructs a RangerPolicyItemAccess from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getIsAllowed()
    {
        return $this->isAllowed;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $isAllowed
     */
    public function setIsAllowed($isAllowed)
    {
        $this->isAllowed = $isAllowed;
    }

    /**
     * Initializes this RangerPolicyItemAccess from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerPolicyItemAccess from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'type') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->type = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isAllowed') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isAllowed = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPolicyItemAccess from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerPolicyItemAccess to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPolicyItemAccess', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPolicyItemAccess to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->type) {
            $writer->startElementNs(null, 'type', null);
            $writer->text($this->type);
            $writer->endElement();
        }
        if ($this->isAllowed) {
            $writer->startElementNs(null, 'isAllowed', null);
            $writer->text($this->isAllowed);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerPolicyItemDataMaskInfo
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $valueExpr;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $conditionExpr;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $dataMaskType;

    /**
     * Constructs a RangerPolicyItemDataMaskInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getValueExpr()
    {
        return $this->valueExpr;
    }

    /**
     * (no documentation provided)
     *
     * @param string $valueExpr
     */
    public function setValueExpr($valueExpr)
    {
        $this->valueExpr = $valueExpr;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getConditionExpr()
    {
        return $this->conditionExpr;
    }

    /**
     * (no documentation provided)
     *
     * @param string $conditionExpr
     */
    public function setConditionExpr($conditionExpr)
    {
        $this->conditionExpr = $conditionExpr;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDataMaskType()
    {
        return $this->dataMaskType;
    }

    /**
     * (no documentation provided)
     *
     * @param string $dataMaskType
     */
    public function setDataMaskType($dataMaskType)
    {
        $this->dataMaskType = $dataMaskType;
    }

    /**
     * Initializes this RangerPolicyItemDataMaskInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerPolicyItemDataMaskInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'valueExpr') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->valueExpr = $child;
            $happened = true;
        }
        else if (($xml->localName == 'conditionExpr') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->conditionExpr = $child;
            $happened = true;
        }
        else if (($xml->localName == 'dataMaskType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->dataMaskType = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPolicyItemDataMaskInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerPolicyItemDataMaskInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPolicyItemDataMaskInfo', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPolicyItemDataMaskInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->valueExpr) {
            $writer->startElementNs(null, 'valueExpr', null);
            $writer->text($this->valueExpr);
            $writer->endElement();
        }
        if ($this->conditionExpr) {
            $writer->startElementNs(null, 'conditionExpr', null);
            $writer->text($this->conditionExpr);
            $writer->endElement();
        }
        if ($this->dataMaskType) {
            $writer->startElementNs(null, 'dataMaskType', null);
            $writer->text($this->dataMaskType);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerPolicyResource
{

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $values;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $isExcludes;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $isRecursive;

    /**
     * Constructs a RangerPolicyResource from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getValues()
    {
        return $this->values;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $values
     */
    public function setValues($values)
    {
        $this->values = $values;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getIsExcludes()
    {
        return $this->isExcludes;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $isExcludes
     */
    public function setIsExcludes($isExcludes)
    {
        $this->isExcludes = $isExcludes;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getIsRecursive()
    {
        return $this->isRecursive;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $isRecursive
     */
    public function setIsRecursive($isRecursive)
    {
        $this->isRecursive = $isRecursive;
    }

    /**
     * Initializes this RangerPolicyResource from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerPolicyResource from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'values') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->values)) {
                $this->values = array();
            }
            array_push($this->values, $child);
            $happened = true;
        }
        else if (($xml->localName == 'isExcludes') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isExcludes = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isRecursive') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isRecursive = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPolicyResource from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerPolicyResource to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPolicyResource', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPolicyResource to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->values) {
            foreach ($this->values as $i => $x) {
                $writer->startElementNs(null, 'values', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->isExcludes) {
            $writer->startElementNs(null, 'isExcludes', null);
            $writer->text($this->isExcludes);
            $writer->endElement();
        }
        if ($this->isRecursive) {
            $writer->startElementNs(null, 'isRecursive', null);
            $writer->text($this->isRecursive);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerPolicyDelta
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicy
     */
    private $policy;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $id;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $changeType;

    /**
     * Constructs a RangerPolicyDelta from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicy
     */
    public function getPolicy()
    {
        return $this->policy;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicy $policy
     */
    public function setPolicy($policy)
    {
        $this->policy = $policy;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getChangeType()
    {
        return $this->changeType;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $changeType
     */
    public function setChangeType($changeType)
    {
        $this->changeType = $changeType;
    }

    /**
     * Initializes this RangerPolicyDelta from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerPolicyDelta from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'policy') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicy($xml);
            $this->policy = $child;
            $happened = true;
        }
        else if (($xml->localName == 'id') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->id = $child;
            $happened = true;
        }
        else if (($xml->localName == 'changeType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->changeType = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPolicyDelta from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerPolicyDelta to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPolicyDelta', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPolicyDelta to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->policy) {
            $writer->startElementNs(null, 'policy', null);
            $this->policy->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->id) {
            $writer->startElementNs(null, 'id', null);
            $writer->text($this->id);
            $writer->endElement();
        }
        if ($this->changeType) {
            $writer->startElementNs(null, 'changeType', null);
            $writer->text($this->changeType);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerSecurityZoneService
{

    /**
     * (no documentation provided)
     *
     * @var array[]
     */
    private $resources;

    /**
     * Constructs a RangerSecurityZoneService from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return array[]
     */
    public function getResources()
    {
        return $this->resources;
    }

    /**
     * (no documentation provided)
     *
     * @param array[] $resources
     */
    public function setResources($resources)
    {
        $this->resources = $resources;
    }

    /**
     * Initializes this RangerSecurityZoneService from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerSecurityZoneService from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'resources') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->resources)) {
                $this->resources = array();
            }
            array_push($this->resources, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerSecurityZoneService from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerSecurityZoneService to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerSecurityZoneService', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerSecurityZoneService to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->resources) {
            foreach ($this->resources as $i => $x) {
                $writer->startElementNs(null, 'resources', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerPolicyItemRowFilterInfo
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $filterExpr;

    /**
     * Constructs a RangerPolicyItemRowFilterInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getFilterExpr()
    {
        return $this->filterExpr;
    }

    /**
     * (no documentation provided)
     *
     * @param string $filterExpr
     */
    public function setFilterExpr($filterExpr)
    {
        $this->filterExpr = $filterExpr;
    }

    /**
     * Initializes this RangerPolicyItemRowFilterInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerPolicyItemRowFilterInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'filterExpr') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->filterExpr = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPolicyItemRowFilterInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerPolicyItemRowFilterInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPolicyItemRowFilterInfo', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPolicyItemRowFilterInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->filterExpr) {
            $writer->startElementNs(null, 'filterExpr', null);
            $writer->text($this->filterExpr);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerContextEnricherDef
{

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $itemId;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $enricher;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $enricherOptions;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * Constructs a RangerContextEnricherDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getItemId()
    {
        return $this->itemId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $itemId
     */
    public function setItemId($itemId)
    {
        $this->itemId = $itemId;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getEnricher()
    {
        return $this->enricher;
    }

    /**
     * (no documentation provided)
     *
     * @param string $enricher
     */
    public function setEnricher($enricher)
    {
        $this->enricher = $enricher;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getEnricherOptions()
    {
        return $this->enricherOptions;
    }

    /**
     * (no documentation provided)
     *
     * @param array $enricherOptions
     */
    public function setEnricherOptions($enricherOptions)
    {
        $this->enricherOptions = $enricherOptions;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * Initializes this RangerContextEnricherDef from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerContextEnricherDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'itemId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->itemId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'enricher') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->enricher = $child;
            $happened = true;
        }
        else if (($xml->localName == 'enricherOptions') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->enricherOptions = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerContextEnricherDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerContextEnricherDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerContextEnricherDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerContextEnricherDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->itemId) {
            $writer->startElementNs(null, 'itemId', null);
            $writer->text($this->itemId);
            $writer->endElement();
        }
        if ($this->enricher) {
            $writer->startElementNs(null, 'enricher', null);
            $writer->text($this->enricher);
            $writer->endElement();
        }
        if ($this->enricherOptions) {
            $writer->startElementNs(null, 'enricherOptions', null);
            $writer->text($this->enricherOptions);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerDataMaskTypeDef
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $label;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyLabel;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyDescription;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $dataMaskOptions;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $itemId;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $transformer;

    /**
     * Constructs a RangerDataMaskTypeDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLabel()
    {
        return $this->label;
    }

    /**
     * (no documentation provided)
     *
     * @param string $label
     */
    public function setLabel($label)
    {
        $this->label = $label;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyLabel()
    {
        return $this->rbKeyLabel;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyLabel
     */
    public function setRbKeyLabel($rbKeyLabel)
    {
        $this->rbKeyLabel = $rbKeyLabel;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyDescription()
    {
        return $this->rbKeyDescription;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyDescription
     */
    public function setRbKeyDescription($rbKeyDescription)
    {
        $this->rbKeyDescription = $rbKeyDescription;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getDataMaskOptions()
    {
        return $this->dataMaskOptions;
    }

    /**
     * (no documentation provided)
     *
     * @param array $dataMaskOptions
     */
    public function setDataMaskOptions($dataMaskOptions)
    {
        $this->dataMaskOptions = $dataMaskOptions;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getItemId()
    {
        return $this->itemId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $itemId
     */
    public function setItemId($itemId)
    {
        $this->itemId = $itemId;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getTransformer()
    {
        return $this->transformer;
    }

    /**
     * (no documentation provided)
     *
     * @param string $transformer
     */
    public function setTransformer($transformer)
    {
        $this->transformer = $transformer;
    }

    /**
     * Initializes this RangerDataMaskTypeDef from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerDataMaskTypeDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'label') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->label = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyLabel') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyLabel = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyDescription') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyDescription = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'dataMaskOptions') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->dataMaskOptions = $child;
            $happened = true;
        }
        else if (($xml->localName == 'itemId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->itemId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'transformer') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->transformer = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerDataMaskTypeDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerDataMaskTypeDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerDataMaskTypeDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerDataMaskTypeDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->label) {
            $writer->startElementNs(null, 'label', null);
            $writer->text($this->label);
            $writer->endElement();
        }
        if ($this->rbKeyLabel) {
            $writer->startElementNs(null, 'rbKeyLabel', null);
            $writer->text($this->rbKeyLabel);
            $writer->endElement();
        }
        if ($this->rbKeyDescription) {
            $writer->startElementNs(null, 'rbKeyDescription', null);
            $writer->text($this->rbKeyDescription);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->dataMaskOptions) {
            $writer->startElementNs(null, 'dataMaskOptions', null);
            $writer->text($this->dataMaskOptions);
            $writer->endElement();
        }
        if ($this->itemId) {
            $writer->startElementNs(null, 'itemId', null);
            $writer->text($this->itemId);
            $writer->endElement();
        }
        if ($this->transformer) {
            $writer->startElementNs(null, 'transformer', null);
            $writer->text($this->transformer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerEnumElementDef
{

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $itemId;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $label;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyLabel;

    /**
     * Constructs a RangerEnumElementDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getItemId()
    {
        return $this->itemId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $itemId
     */
    public function setItemId($itemId)
    {
        $this->itemId = $itemId;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLabel()
    {
        return $this->label;
    }

    /**
     * (no documentation provided)
     *
     * @param string $label
     */
    public function setLabel($label)
    {
        $this->label = $label;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyLabel()
    {
        return $this->rbKeyLabel;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyLabel
     */
    public function setRbKeyLabel($rbKeyLabel)
    {
        $this->rbKeyLabel = $rbKeyLabel;
    }

    /**
     * Initializes this RangerEnumElementDef from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerEnumElementDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'itemId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->itemId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'label') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->label = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyLabel') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyLabel = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerEnumElementDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerEnumElementDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerEnumElementDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerEnumElementDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->itemId) {
            $writer->startElementNs(null, 'itemId', null);
            $writer->text($this->itemId);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->label) {
            $writer->startElementNs(null, 'label', null);
            $writer->text($this->label);
            $writer->endElement();
        }
        if ($this->rbKeyLabel) {
            $writer->startElementNs(null, 'rbKeyLabel', null);
            $writer->text($this->rbKeyLabel);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerResourceDef
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $validationMessage;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $itemId;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $matcher;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyValidationMessage;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $matcherOptions;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $validationRegEx;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $uiHint;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyLabel;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $level;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $recursiveSupported;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $lookupSupported;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $mandatory;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $label;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $excludesSupported;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $accessTypeRestrictions;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $isValidLeaf;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $parent;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyDescription;

    /**
     * Constructs a RangerResourceDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getValidationMessage()
    {
        return $this->validationMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string $validationMessage
     */
    public function setValidationMessage($validationMessage)
    {
        $this->validationMessage = $validationMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getItemId()
    {
        return $this->itemId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $itemId
     */
    public function setItemId($itemId)
    {
        $this->itemId = $itemId;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getMatcher()
    {
        return $this->matcher;
    }

    /**
     * (no documentation provided)
     *
     * @param string $matcher
     */
    public function setMatcher($matcher)
    {
        $this->matcher = $matcher;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyValidationMessage()
    {
        return $this->rbKeyValidationMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyValidationMessage
     */
    public function setRbKeyValidationMessage($rbKeyValidationMessage)
    {
        $this->rbKeyValidationMessage = $rbKeyValidationMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getMatcherOptions()
    {
        return $this->matcherOptions;
    }

    /**
     * (no documentation provided)
     *
     * @param array $matcherOptions
     */
    public function setMatcherOptions($matcherOptions)
    {
        $this->matcherOptions = $matcherOptions;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getValidationRegEx()
    {
        return $this->validationRegEx;
    }

    /**
     * (no documentation provided)
     *
     * @param string $validationRegEx
     */
    public function setValidationRegEx($validationRegEx)
    {
        $this->validationRegEx = $validationRegEx;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUiHint()
    {
        return $this->uiHint;
    }

    /**
     * (no documentation provided)
     *
     * @param string $uiHint
     */
    public function setUiHint($uiHint)
    {
        $this->uiHint = $uiHint;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyLabel()
    {
        return $this->rbKeyLabel;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyLabel
     */
    public function setRbKeyLabel($rbKeyLabel)
    {
        $this->rbKeyLabel = $rbKeyLabel;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getLevel()
    {
        return $this->level;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $level
     */
    public function setLevel($level)
    {
        $this->level = $level;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getRecursiveSupported()
    {
        return $this->recursiveSupported;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $recursiveSupported
     */
    public function setRecursiveSupported($recursiveSupported)
    {
        $this->recursiveSupported = $recursiveSupported;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getLookupSupported()
    {
        return $this->lookupSupported;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $lookupSupported
     */
    public function setLookupSupported($lookupSupported)
    {
        $this->lookupSupported = $lookupSupported;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getMandatory()
    {
        return $this->mandatory;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $mandatory
     */
    public function setMandatory($mandatory)
    {
        $this->mandatory = $mandatory;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLabel()
    {
        return $this->label;
    }

    /**
     * (no documentation provided)
     *
     * @param string $label
     */
    public function setLabel($label)
    {
        $this->label = $label;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getExcludesSupported()
    {
        return $this->excludesSupported;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $excludesSupported
     */
    public function setExcludesSupported($excludesSupported)
    {
        $this->excludesSupported = $excludesSupported;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getAccessTypeRestrictions()
    {
        return $this->accessTypeRestrictions;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $accessTypeRestrictions
     */
    public function setAccessTypeRestrictions($accessTypeRestrictions)
    {
        $this->accessTypeRestrictions = $accessTypeRestrictions;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getIsValidLeaf()
    {
        return $this->isValidLeaf;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $isValidLeaf
     */
    public function setIsValidLeaf($isValidLeaf)
    {
        $this->isValidLeaf = $isValidLeaf;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getParent()
    {
        return $this->parent;
    }

    /**
     * (no documentation provided)
     *
     * @param string $parent
     */
    public function setParent($parent)
    {
        $this->parent = $parent;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyDescription()
    {
        return $this->rbKeyDescription;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyDescription
     */
    public function setRbKeyDescription($rbKeyDescription)
    {
        $this->rbKeyDescription = $rbKeyDescription;
    }

    /**
     * Initializes this RangerResourceDef from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerResourceDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'validationMessage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->validationMessage = $child;
            $happened = true;
        }
        else if (($xml->localName == 'itemId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->itemId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'matcher') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->matcher = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyValidationMessage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyValidationMessage = $child;
            $happened = true;
        }
        else if (($xml->localName == 'matcherOptions') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->matcherOptions = $child;
            $happened = true;
        }
        else if (($xml->localName == 'validationRegEx') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->validationRegEx = $child;
            $happened = true;
        }
        else if (($xml->localName == 'uiHint') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->uiHint = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyLabel') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyLabel = $child;
            $happened = true;
        }
        else if (($xml->localName == 'level') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->level = $child;
            $happened = true;
        }
        else if (($xml->localName == 'recursiveSupported') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->recursiveSupported = $child;
            $happened = true;
        }
        else if (($xml->localName == 'lookupSupported') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->lookupSupported = $child;
            $happened = true;
        }
        else if (($xml->localName == 'mandatory') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->mandatory = $child;
            $happened = true;
        }
        else if (($xml->localName == 'label') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->label = $child;
            $happened = true;
        }
        else if (($xml->localName == 'excludesSupported') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->excludesSupported = $child;
            $happened = true;
        }
        else if (($xml->localName == 'accessTypeRestrictions') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->accessTypeRestrictions)) {
                $this->accessTypeRestrictions = array();
            }
            array_push($this->accessTypeRestrictions, $child);
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isValidLeaf') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isValidLeaf = $child;
            $happened = true;
        }
        else if (($xml->localName == 'parent') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->parent = $child;
            $happened = true;
        }
        else if (($xml->localName == 'type') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->type = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyDescription') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyDescription = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerResourceDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerResourceDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerResourceDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerResourceDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->validationMessage) {
            $writer->startElementNs(null, 'validationMessage', null);
            $writer->text($this->validationMessage);
            $writer->endElement();
        }
        if ($this->itemId) {
            $writer->startElementNs(null, 'itemId', null);
            $writer->text($this->itemId);
            $writer->endElement();
        }
        if ($this->matcher) {
            $writer->startElementNs(null, 'matcher', null);
            $writer->text($this->matcher);
            $writer->endElement();
        }
        if ($this->rbKeyValidationMessage) {
            $writer->startElementNs(null, 'rbKeyValidationMessage', null);
            $writer->text($this->rbKeyValidationMessage);
            $writer->endElement();
        }
        if ($this->matcherOptions) {
            $writer->startElementNs(null, 'matcherOptions', null);
            $writer->text($this->matcherOptions);
            $writer->endElement();
        }
        if ($this->validationRegEx) {
            $writer->startElementNs(null, 'validationRegEx', null);
            $writer->text($this->validationRegEx);
            $writer->endElement();
        }
        if ($this->uiHint) {
            $writer->startElementNs(null, 'uiHint', null);
            $writer->text($this->uiHint);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->rbKeyLabel) {
            $writer->startElementNs(null, 'rbKeyLabel', null);
            $writer->text($this->rbKeyLabel);
            $writer->endElement();
        }
        if ($this->level) {
            $writer->startElementNs(null, 'level', null);
            $writer->text($this->level);
            $writer->endElement();
        }
        if ($this->recursiveSupported) {
            $writer->startElementNs(null, 'recursiveSupported', null);
            $writer->text($this->recursiveSupported);
            $writer->endElement();
        }
        if ($this->lookupSupported) {
            $writer->startElementNs(null, 'lookupSupported', null);
            $writer->text($this->lookupSupported);
            $writer->endElement();
        }
        if ($this->mandatory) {
            $writer->startElementNs(null, 'mandatory', null);
            $writer->text($this->mandatory);
            $writer->endElement();
        }
        if ($this->label) {
            $writer->startElementNs(null, 'label', null);
            $writer->text($this->label);
            $writer->endElement();
        }
        if ($this->excludesSupported) {
            $writer->startElementNs(null, 'excludesSupported', null);
            $writer->text($this->excludesSupported);
            $writer->endElement();
        }
        if ($this->accessTypeRestrictions) {
            foreach ($this->accessTypeRestrictions as $i => $x) {
                $writer->startElementNs(null, 'accessTypeRestrictions', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->isValidLeaf) {
            $writer->startElementNs(null, 'isValidLeaf', null);
            $writer->text($this->isValidLeaf);
            $writer->endElement();
        }
        if ($this->parent) {
            $writer->startElementNs(null, 'parent', null);
            $writer->text($this->parent);
            $writer->endElement();
        }
        if ($this->type) {
            $writer->startElementNs(null, 'type', null);
            $writer->text($this->type);
            $writer->endElement();
        }
        if ($this->rbKeyDescription) {
            $writer->startElementNs(null, 'rbKeyDescription', null);
            $writer->text($this->rbKeyDescription);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerServiceConfigDef
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $subType;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $itemId;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyDescription;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $defaultValue;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $validationRegEx;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $validationMessage;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyLabel;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $label;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $mandatory;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyValidationMessage;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $uiHint;

    /**
     * Constructs a RangerServiceConfigDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSubType()
    {
        return $this->subType;
    }

    /**
     * (no documentation provided)
     *
     * @param string $subType
     */
    public function setSubType($subType)
    {
        $this->subType = $subType;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getItemId()
    {
        return $this->itemId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $itemId
     */
    public function setItemId($itemId)
    {
        $this->itemId = $itemId;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyDescription()
    {
        return $this->rbKeyDescription;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyDescription
     */
    public function setRbKeyDescription($rbKeyDescription)
    {
        $this->rbKeyDescription = $rbKeyDescription;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDefaultValue()
    {
        return $this->defaultValue;
    }

    /**
     * (no documentation provided)
     *
     * @param string $defaultValue
     */
    public function setDefaultValue($defaultValue)
    {
        $this->defaultValue = $defaultValue;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getValidationRegEx()
    {
        return $this->validationRegEx;
    }

    /**
     * (no documentation provided)
     *
     * @param string $validationRegEx
     */
    public function setValidationRegEx($validationRegEx)
    {
        $this->validationRegEx = $validationRegEx;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getValidationMessage()
    {
        return $this->validationMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string $validationMessage
     */
    public function setValidationMessage($validationMessage)
    {
        $this->validationMessage = $validationMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyLabel()
    {
        return $this->rbKeyLabel;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyLabel
     */
    public function setRbKeyLabel($rbKeyLabel)
    {
        $this->rbKeyLabel = $rbKeyLabel;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLabel()
    {
        return $this->label;
    }

    /**
     * (no documentation provided)
     *
     * @param string $label
     */
    public function setLabel($label)
    {
        $this->label = $label;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getMandatory()
    {
        return $this->mandatory;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $mandatory
     */
    public function setMandatory($mandatory)
    {
        $this->mandatory = $mandatory;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyValidationMessage()
    {
        return $this->rbKeyValidationMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyValidationMessage
     */
    public function setRbKeyValidationMessage($rbKeyValidationMessage)
    {
        $this->rbKeyValidationMessage = $rbKeyValidationMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUiHint()
    {
        return $this->uiHint;
    }

    /**
     * (no documentation provided)
     *
     * @param string $uiHint
     */
    public function setUiHint($uiHint)
    {
        $this->uiHint = $uiHint;
    }

    /**
     * Initializes this RangerServiceConfigDef from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerServiceConfigDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'subType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->subType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'itemId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->itemId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyDescription') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyDescription = $child;
            $happened = true;
        }
        else if (($xml->localName == 'defaultValue') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->defaultValue = $child;
            $happened = true;
        }
        else if (($xml->localName == 'validationRegEx') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->validationRegEx = $child;
            $happened = true;
        }
        else if (($xml->localName == 'type') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->type = $child;
            $happened = true;
        }
        else if (($xml->localName == 'validationMessage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->validationMessage = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyLabel') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyLabel = $child;
            $happened = true;
        }
        else if (($xml->localName == 'label') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->label = $child;
            $happened = true;
        }
        else if (($xml->localName == 'mandatory') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->mandatory = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyValidationMessage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyValidationMessage = $child;
            $happened = true;
        }
        else if (($xml->localName == 'uiHint') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->uiHint = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerServiceConfigDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerServiceConfigDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerServiceConfigDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerServiceConfigDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->subType) {
            $writer->startElementNs(null, 'subType', null);
            $writer->text($this->subType);
            $writer->endElement();
        }
        if ($this->itemId) {
            $writer->startElementNs(null, 'itemId', null);
            $writer->text($this->itemId);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->rbKeyDescription) {
            $writer->startElementNs(null, 'rbKeyDescription', null);
            $writer->text($this->rbKeyDescription);
            $writer->endElement();
        }
        if ($this->defaultValue) {
            $writer->startElementNs(null, 'defaultValue', null);
            $writer->text($this->defaultValue);
            $writer->endElement();
        }
        if ($this->validationRegEx) {
            $writer->startElementNs(null, 'validationRegEx', null);
            $writer->text($this->validationRegEx);
            $writer->endElement();
        }
        if ($this->type) {
            $writer->startElementNs(null, 'type', null);
            $writer->text($this->type);
            $writer->endElement();
        }
        if ($this->validationMessage) {
            $writer->startElementNs(null, 'validationMessage', null);
            $writer->text($this->validationMessage);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->rbKeyLabel) {
            $writer->startElementNs(null, 'rbKeyLabel', null);
            $writer->text($this->rbKeyLabel);
            $writer->endElement();
        }
        if ($this->label) {
            $writer->startElementNs(null, 'label', null);
            $writer->text($this->label);
            $writer->endElement();
        }
        if ($this->mandatory) {
            $writer->startElementNs(null, 'mandatory', null);
            $writer->text($this->mandatory);
            $writer->endElement();
        }
        if ($this->rbKeyValidationMessage) {
            $writer->startElementNs(null, 'rbKeyValidationMessage', null);
            $writer->text($this->rbKeyValidationMessage);
            $writer->endElement();
        }
        if ($this->uiHint) {
            $writer->startElementNs(null, 'uiHint', null);
            $writer->text($this->uiHint);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerRowFilterDef
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerResourceDef[]
     */
    private $resources;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef[]
     */
    private $accessTypes;

    /**
     * Constructs a RangerRowFilterDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerResourceDef[]
     */
    public function getResources()
    {
        return $this->resources;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerResourceDef[] $resources
     */
    public function setResources($resources)
    {
        $this->resources = $resources;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef[]
     */
    public function getAccessTypes()
    {
        return $this->accessTypes;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef[] $accessTypes
     */
    public function setAccessTypes($accessTypes)
    {
        $this->accessTypes = $accessTypes;
    }

    /**
     * Initializes this RangerRowFilterDef from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerRowFilterDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'resources') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerResourceDef($xml);
            if (!isset($this->resources)) {
                $this->resources = array();
            }
            array_push($this->resources, $child);
            $happened = true;
        }
        else if (($xml->localName == 'accessTypes') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef($xml);
            if (!isset($this->accessTypes)) {
                $this->accessTypes = array();
            }
            array_push($this->accessTypes, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerRowFilterDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerRowFilterDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerRowFilterDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerRowFilterDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->resources) {
            foreach ($this->resources as $i => $x) {
                $writer->startElementNs(null, 'resources', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->accessTypes) {
            foreach ($this->accessTypes as $i => $x) {
                $writer->startElementNs(null, 'accessTypes', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerTagAttributeDef
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * Constructs a RangerTagAttributeDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }

    /**
     * Initializes this RangerTagAttributeDef from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerTagAttributeDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'type') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->type = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerTagAttributeDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerTagAttributeDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerTagAttributeDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerTagAttributeDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->type) {
            $writer->startElementNs(null, 'type', null);
            $writer->text($this->type);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXLdapSyncSourceInfo
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $ldapUrl;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $userSearchFilter;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $groupSearchFilter;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $groupHierarchyLevel;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $totalUsersSynced;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $totalGroupsSynced;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $groupSearchFirstEnabled;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $groupSearchEnabled;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $userSearchEnabled;

    /**
     * Constructs a VXLdapSyncSourceInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLdapUrl()
    {
        return $this->ldapUrl;
    }

    /**
     * (no documentation provided)
     *
     * @param string $ldapUrl
     */
    public function setLdapUrl($ldapUrl)
    {
        $this->ldapUrl = $ldapUrl;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUserSearchFilter()
    {
        return $this->userSearchFilter;
    }

    /**
     * (no documentation provided)
     *
     * @param string $userSearchFilter
     */
    public function setUserSearchFilter($userSearchFilter)
    {
        $this->userSearchFilter = $userSearchFilter;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getGroupSearchFilter()
    {
        return $this->groupSearchFilter;
    }

    /**
     * (no documentation provided)
     *
     * @param string $groupSearchFilter
     */
    public function setGroupSearchFilter($groupSearchFilter)
    {
        $this->groupSearchFilter = $groupSearchFilter;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getGroupHierarchyLevel()
    {
        return $this->groupHierarchyLevel;
    }

    /**
     * (no documentation provided)
     *
     * @param string $groupHierarchyLevel
     */
    public function setGroupHierarchyLevel($groupHierarchyLevel)
    {
        $this->groupHierarchyLevel = $groupHierarchyLevel;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTotalUsersSynced()
    {
        return $this->totalUsersSynced;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $totalUsersSynced
     */
    public function setTotalUsersSynced($totalUsersSynced)
    {
        $this->totalUsersSynced = $totalUsersSynced;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTotalGroupsSynced()
    {
        return $this->totalGroupsSynced;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $totalGroupsSynced
     */
    public function setTotalGroupsSynced($totalGroupsSynced)
    {
        $this->totalGroupsSynced = $totalGroupsSynced;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getGroupSearchFirstEnabled()
    {
        return $this->groupSearchFirstEnabled;
    }

    /**
     * (no documentation provided)
     *
     * @param string $groupSearchFirstEnabled
     */
    public function setGroupSearchFirstEnabled($groupSearchFirstEnabled)
    {
        $this->groupSearchFirstEnabled = $groupSearchFirstEnabled;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getGroupSearchEnabled()
    {
        return $this->groupSearchEnabled;
    }

    /**
     * (no documentation provided)
     *
     * @param string $groupSearchEnabled
     */
    public function setGroupSearchEnabled($groupSearchEnabled)
    {
        $this->groupSearchEnabled = $groupSearchEnabled;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUserSearchEnabled()
    {
        return $this->userSearchEnabled;
    }

    /**
     * (no documentation provided)
     *
     * @param string $userSearchEnabled
     */
    public function setUserSearchEnabled($userSearchEnabled)
    {
        $this->userSearchEnabled = $userSearchEnabled;
    }

    /**
     * Initializes this VXLdapSyncSourceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of VXLdapSyncSourceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'ldapUrl') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->ldapUrl = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userSearchFilter') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userSearchFilter = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupSearchFilter') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupSearchFilter = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupHierarchyLevel') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupHierarchyLevel = $child;
            $happened = true;
        }
        else if (($xml->localName == 'totalUsersSynced') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->totalUsersSynced = $child;
            $happened = true;
        }
        else if (($xml->localName == 'totalGroupsSynced') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->totalGroupsSynced = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupSearchFirstEnabled') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupSearchFirstEnabled = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupSearchEnabled') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupSearchEnabled = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userSearchEnabled') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userSearchEnabled = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXLdapSyncSourceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this VXLdapSyncSourceInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXLdapSyncSourceInfo', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXLdapSyncSourceInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->ldapUrl) {
            $writer->startElementNs(null, 'ldapUrl', null);
            $writer->text($this->ldapUrl);
            $writer->endElement();
        }
        if ($this->userSearchFilter) {
            $writer->startElementNs(null, 'userSearchFilter', null);
            $writer->text($this->userSearchFilter);
            $writer->endElement();
        }
        if ($this->groupSearchFilter) {
            $writer->startElementNs(null, 'groupSearchFilter', null);
            $writer->text($this->groupSearchFilter);
            $writer->endElement();
        }
        if ($this->groupHierarchyLevel) {
            $writer->startElementNs(null, 'groupHierarchyLevel', null);
            $writer->text($this->groupHierarchyLevel);
            $writer->endElement();
        }
        if ($this->totalUsersSynced) {
            $writer->startElementNs(null, 'totalUsersSynced', null);
            $writer->text($this->totalUsersSynced);
            $writer->endElement();
        }
        if ($this->totalGroupsSynced) {
            $writer->startElementNs(null, 'totalGroupsSynced', null);
            $writer->text($this->totalGroupsSynced);
            $writer->endElement();
        }
        if ($this->groupSearchFirstEnabled) {
            $writer->startElementNs(null, 'groupSearchFirstEnabled', null);
            $writer->text($this->groupSearchFirstEnabled);
            $writer->endElement();
        }
        if ($this->groupSearchEnabled) {
            $writer->startElementNs(null, 'groupSearchEnabled', null);
            $writer->text($this->groupSearchEnabled);
            $writer->endElement();
        }
        if ($this->userSearchEnabled) {
            $writer->startElementNs(null, 'userSearchEnabled', null);
            $writer->text($this->userSearchEnabled);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerValidityRecurrence
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RecurrenceSchedule
     */
    private $schedule;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\ValidityInterval
     */
    private $interval;

    /**
     * Constructs a RangerValidityRecurrence from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RecurrenceSchedule
     */
    public function getSchedule()
    {
        return $this->schedule;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RecurrenceSchedule $schedule
     */
    public function setSchedule($schedule)
    {
        $this->schedule = $schedule;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\ValidityInterval
     */
    public function getInterval()
    {
        return $this->interval;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\ValidityInterval $interval
     */
    public function setInterval($interval)
    {
        $this->interval = $interval;
    }

    /**
     * Initializes this RangerValidityRecurrence from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerValidityRecurrence from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'schedule') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RecurrenceSchedule($xml);
            $this->schedule = $child;
            $happened = true;
        }
        else if (($xml->localName == 'interval') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\ValidityInterval($xml);
            $this->interval = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerValidityRecurrence from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerValidityRecurrence to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerValidityRecurrence', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerValidityRecurrence to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->schedule) {
            $writer->startElementNs(null, 'schedule', null);
            $this->schedule->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->interval) {
            $writer->startElementNs(null, 'interval', null);
            $this->interval->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPermObj
{

    /**
     * the userList
     *
     * @var string[]
     */
    private $userList;

    /**
     * the groupList
     *
     * @var string[]
     */
    private $groupList;

    /**
     * the permList
     *
     * @var string[]
     */
    private $permList;

    /**
     * the ipAddress
     *
     * @var string
     */
    private $ipAddress;

    /**
     * Constructs a VXPermObj from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * the userList
     *
     * @return string[]
     */
    public function getUserList()
    {
        return $this->userList;
    }

    /**
     * the userList
     *
     * @param string[] $userList
     */
    public function setUserList($userList)
    {
        $this->userList = $userList;
    }
    /**
     * the groupList
     *
     * @return string[]
     */
    public function getGroupList()
    {
        return $this->groupList;
    }

    /**
     * the groupList
     *
     * @param string[] $groupList
     */
    public function setGroupList($groupList)
    {
        $this->groupList = $groupList;
    }
    /**
     * the permList
     *
     * @return string[]
     */
    public function getPermList()
    {
        return $this->permList;
    }

    /**
     * the permList
     *
     * @param string[] $permList
     */
    public function setPermList($permList)
    {
        $this->permList = $permList;
    }
    /**
     * the ipAddress
     *
     * @return string
     */
    public function getIpAddress()
    {
        return $this->ipAddress;
    }

    /**
     * the ipAddress
     *
     * @param string $ipAddress
     */
    public function setIpAddress($ipAddress)
    {
        $this->ipAddress = $ipAddress;
    }

    /**
     * Initializes this VXPermObj from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of VXPermObj from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'userList') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->userList)) {
                $this->userList = array();
            }
            array_push($this->userList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'groupList') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->groupList)) {
                $this->groupList = array();
            }
            array_push($this->groupList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'permList') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->permList)) {
                $this->permList = array();
            }
            array_push($this->permList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'ipAddress') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->ipAddress = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPermObj from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this VXPermObj to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPermObj', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPermObj to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->userList) {
            foreach ($this->userList as $i => $x) {
                $writer->startElementNs(null, 'userList', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->groupList) {
            foreach ($this->groupList as $i => $x) {
                $writer->startElementNs(null, 'groupList', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->permList) {
            foreach ($this->permList as $i => $x) {
                $writer->startElementNs(null, 'permList', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->ipAddress) {
            $writer->startElementNs(null, 'ipAddress', null);
            $writer->text($this->ipAddress);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class ValidityInterval
{

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $days;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $minutes;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $hours;

    /**
     * Constructs a ValidityInterval from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getDays()
    {
        return $this->days;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $days
     */
    public function setDays($days)
    {
        $this->days = $days;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getMinutes()
    {
        return $this->minutes;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $minutes
     */
    public function setMinutes($minutes)
    {
        $this->minutes = $minutes;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getHours()
    {
        return $this->hours;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $hours
     */
    public function setHours($hours)
    {
        $this->hours = $hours;
    }

    /**
     * Initializes this ValidityInterval from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ValidityInterval from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'days') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->days = $child;
            $happened = true;
        }
        else if (($xml->localName == 'minutes') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->minutes = $child;
            $happened = true;
        }
        else if (($xml->localName == 'hours') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->hours = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of ValidityInterval from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this ValidityInterval to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'validityInterval', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this ValidityInterval to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->days) {
            $writer->startElementNs(null, 'days', null);
            $writer->text($this->days);
            $writer->endElement();
        }
        if ($this->minutes) {
            $writer->startElementNs(null, 'minutes', null);
            $writer->text($this->minutes);
            $writer->endElement();
        }
        if ($this->hours) {
            $writer->startElementNs(null, 'hours', null);
            $writer->text($this->hours);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Service;

/**
 * (no documentation provided)
 */
class ResourceLookupContext
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $userInput;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $resourceName;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $resources;

    /**
     * Constructs a ResourceLookupContext from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUserInput()
    {
        return $this->userInput;
    }

    /**
     * (no documentation provided)
     *
     * @param string $userInput
     */
    public function setUserInput($userInput)
    {
        $this->userInput = $userInput;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getResourceName()
    {
        return $this->resourceName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $resourceName
     */
    public function setResourceName($resourceName)
    {
        $this->resourceName = $resourceName;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getResources()
    {
        return $this->resources;
    }

    /**
     * (no documentation provided)
     *
     * @param array $resources
     */
    public function setResources($resources)
    {
        $this->resources = $resources;
    }

    /**
     * Initializes this ResourceLookupContext from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ResourceLookupContext from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'userInput') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userInput = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourceName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resources') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resources = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of ResourceLookupContext from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this ResourceLookupContext to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'resourceLookupContext', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this ResourceLookupContext to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->userInput) {
            $writer->startElementNs(null, 'userInput', null);
            $writer->text($this->userInput);
            $writer->endElement();
        }
        if ($this->resourceName) {
            $writer->startElementNs(null, 'resourceName', null);
            $writer->text($this->resourceName);
            $writer->endElement();
        }
        if ($this->resources) {
            $writer->startElementNs(null, 'resources', null);
            $writer->text($this->resources);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Util;

/**
 * (no documentation provided)
 */
class ServicePolicies
{

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $policyVersion;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $serviceId;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $auditMode;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicyDelta[]
     */
    private $policyDeltas;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicy[]
     */
    private $policies;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $policyUpdateTime;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerServiceDef
     */
    private $serviceDef;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $serviceName;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $securityZones;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Util\TagPolicies
     */
    private $tagPolicies;

    /**
     * Constructs a ServicePolicies from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getPolicyVersion()
    {
        return $this->policyVersion;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $policyVersion
     */
    public function setPolicyVersion($policyVersion)
    {
        $this->policyVersion = $policyVersion;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getServiceId()
    {
        return $this->serviceId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $serviceId
     */
    public function setServiceId($serviceId)
    {
        $this->serviceId = $serviceId;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getAuditMode()
    {
        return $this->auditMode;
    }

    /**
     * (no documentation provided)
     *
     * @param string $auditMode
     */
    public function setAuditMode($auditMode)
    {
        $this->auditMode = $auditMode;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicyDelta[]
     */
    public function getPolicyDeltas()
    {
        return $this->policyDeltas;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicyDelta[] $policyDeltas
     */
    public function setPolicyDeltas($policyDeltas)
    {
        $this->policyDeltas = $policyDeltas;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicy[]
     */
    public function getPolicies()
    {
        return $this->policies;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicy[] $policies
     */
    public function setPolicies($policies)
    {
        $this->policies = $policies;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getPolicyUpdateTime()
    {
        return $this->policyUpdateTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $policyUpdateTime
     */
    public function setPolicyUpdateTime($policyUpdateTime)
    {
        $this->policyUpdateTime = $policyUpdateTime;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerServiceDef
     */
    public function getServiceDef()
    {
        return $this->serviceDef;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerServiceDef $serviceDef
     */
    public function setServiceDef($serviceDef)
    {
        $this->serviceDef = $serviceDef;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getServiceName()
    {
        return $this->serviceName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $serviceName
     */
    public function setServiceName($serviceName)
    {
        $this->serviceName = $serviceName;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getSecurityZones()
    {
        return $this->securityZones;
    }

    /**
     * (no documentation provided)
     *
     * @param array $securityZones
     */
    public function setSecurityZones($securityZones)
    {
        $this->securityZones = $securityZones;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Util\TagPolicies
     */
    public function getTagPolicies()
    {
        return $this->tagPolicies;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Util\TagPolicies $tagPolicies
     */
    public function setTagPolicies($tagPolicies)
    {
        $this->tagPolicies = $tagPolicies;
    }

    /**
     * Initializes this ServicePolicies from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ServicePolicies from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'policyVersion') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyVersion = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serviceId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->serviceId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'auditMode') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->auditMode = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policyDeltas') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicyDelta($xml);
            if (!isset($this->policyDeltas)) {
                $this->policyDeltas = array();
            }
            array_push($this->policyDeltas, $child);
            $happened = true;
        }
        else if (($xml->localName == 'policies') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicy($xml);
            if (!isset($this->policies)) {
                $this->policies = array();
            }
            array_push($this->policies, $child);
            $happened = true;
        }
        else if (($xml->localName == 'policyUpdateTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyUpdateTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serviceDef') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerServiceDef($xml);
            $this->serviceDef = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serviceName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->serviceName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'securityZones') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->securityZones = $child;
            $happened = true;
        }
        else if (($xml->localName == 'tagPolicies') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Util\TagPolicies($xml);
            $this->tagPolicies = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of ServicePolicies from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this ServicePolicies to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'servicePolicies', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this ServicePolicies to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->policyVersion) {
            $writer->startElementNs(null, 'policyVersion', null);
            $writer->text($this->policyVersion);
            $writer->endElement();
        }
        if ($this->serviceId) {
            $writer->startElementNs(null, 'serviceId', null);
            $writer->text($this->serviceId);
            $writer->endElement();
        }
        if ($this->auditMode) {
            $writer->startElementNs(null, 'auditMode', null);
            $writer->text($this->auditMode);
            $writer->endElement();
        }
        if ($this->policyDeltas) {
            foreach ($this->policyDeltas as $i => $x) {
                $writer->startElementNs(null, 'policyDeltas', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->policies) {
            foreach ($this->policies as $i => $x) {
                $writer->startElementNs(null, 'policies', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->policyUpdateTime) {
            $writer->startElementNs(null, 'policyUpdateTime', null);
            $writer->text($this->policyUpdateTime);
            $writer->endElement();
        }
        if ($this->serviceDef) {
            $writer->startElementNs(null, 'serviceDef', null);
            $this->serviceDef->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->serviceName) {
            $writer->startElementNs(null, 'serviceName', null);
            $writer->text($this->serviceName);
            $writer->endElement();
        }
        if ($this->securityZones) {
            $writer->startElementNs(null, 'securityZones', null);
            $writer->text($this->securityZones);
            $writer->endElement();
        }
        if ($this->tagPolicies) {
            $writer->startElementNs(null, 'tagPolicies', null);
            $this->tagPolicies->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Util;

/**
 * (no documentation provided)
 */
class TagPolicies
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $serviceName;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerServiceDef
     */
    private $serviceDef;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $auditMode;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $policyVersion;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $serviceId;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicy[]
     */
    private $policies;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $policyUpdateTime;

    /**
     * Constructs a TagPolicies from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getServiceName()
    {
        return $this->serviceName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $serviceName
     */
    public function setServiceName($serviceName)
    {
        $this->serviceName = $serviceName;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerServiceDef
     */
    public function getServiceDef()
    {
        return $this->serviceDef;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerServiceDef $serviceDef
     */
    public function setServiceDef($serviceDef)
    {
        $this->serviceDef = $serviceDef;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getAuditMode()
    {
        return $this->auditMode;
    }

    /**
     * (no documentation provided)
     *
     * @param string $auditMode
     */
    public function setAuditMode($auditMode)
    {
        $this->auditMode = $auditMode;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getPolicyVersion()
    {
        return $this->policyVersion;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $policyVersion
     */
    public function setPolicyVersion($policyVersion)
    {
        $this->policyVersion = $policyVersion;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getServiceId()
    {
        return $this->serviceId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $serviceId
     */
    public function setServiceId($serviceId)
    {
        $this->serviceId = $serviceId;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicy[]
     */
    public function getPolicies()
    {
        return $this->policies;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicy[] $policies
     */
    public function setPolicies($policies)
    {
        $this->policies = $policies;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getPolicyUpdateTime()
    {
        return $this->policyUpdateTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $policyUpdateTime
     */
    public function setPolicyUpdateTime($policyUpdateTime)
    {
        $this->policyUpdateTime = $policyUpdateTime;
    }

    /**
     * Initializes this TagPolicies from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of TagPolicies from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'serviceName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->serviceName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serviceDef') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerServiceDef($xml);
            $this->serviceDef = $child;
            $happened = true;
        }
        else if (($xml->localName == 'auditMode') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->auditMode = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policyVersion') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyVersion = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serviceId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->serviceId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policies') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicy($xml);
            if (!isset($this->policies)) {
                $this->policies = array();
            }
            array_push($this->policies, $child);
            $happened = true;
        }
        else if (($xml->localName == 'policyUpdateTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyUpdateTime = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of TagPolicies from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this TagPolicies to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'tagPolicies', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this TagPolicies to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->serviceName) {
            $writer->startElementNs(null, 'serviceName', null);
            $writer->text($this->serviceName);
            $writer->endElement();
        }
        if ($this->serviceDef) {
            $writer->startElementNs(null, 'serviceDef', null);
            $this->serviceDef->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->auditMode) {
            $writer->startElementNs(null, 'auditMode', null);
            $writer->text($this->auditMode);
            $writer->endElement();
        }
        if ($this->policyVersion) {
            $writer->startElementNs(null, 'policyVersion', null);
            $writer->text($this->policyVersion);
            $writer->endElement();
        }
        if ($this->serviceId) {
            $writer->startElementNs(null, 'serviceId', null);
            $writer->text($this->serviceId);
            $writer->endElement();
        }
        if ($this->policies) {
            foreach ($this->policies as $i => $x) {
                $writer->startElementNs(null, 'policies', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->policyUpdateTime) {
            $writer->startElementNs(null, 'policyUpdateTime', null);
            $writer->text($this->policyUpdateTime);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Util;

/**
 * (no documentation provided)
 */
class ServiceTags
{

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $resourceToTagIds;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $tags;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $tagVersion;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $op;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerServiceResource[]
     */
    private $serviceResources;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $tagDefinitions;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $tagUpdateTime;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $serviceName;

    /**
     * Constructs a ServiceTags from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getResourceToTagIds()
    {
        return $this->resourceToTagIds;
    }

    /**
     * (no documentation provided)
     *
     * @param array $resourceToTagIds
     */
    public function setResourceToTagIds($resourceToTagIds)
    {
        $this->resourceToTagIds = $resourceToTagIds;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getTags()
    {
        return $this->tags;
    }

    /**
     * (no documentation provided)
     *
     * @param array $tags
     */
    public function setTags($tags)
    {
        $this->tags = $tags;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTagVersion()
    {
        return $this->tagVersion;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $tagVersion
     */
    public function setTagVersion($tagVersion)
    {
        $this->tagVersion = $tagVersion;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getOp()
    {
        return $this->op;
    }

    /**
     * (no documentation provided)
     *
     * @param string $op
     */
    public function setOp($op)
    {
        $this->op = $op;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerServiceResource[]
     */
    public function getServiceResources()
    {
        return $this->serviceResources;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerServiceResource[] $serviceResources
     */
    public function setServiceResources($serviceResources)
    {
        $this->serviceResources = $serviceResources;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getTagDefinitions()
    {
        return $this->tagDefinitions;
    }

    /**
     * (no documentation provided)
     *
     * @param array $tagDefinitions
     */
    public function setTagDefinitions($tagDefinitions)
    {
        $this->tagDefinitions = $tagDefinitions;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTagUpdateTime()
    {
        return $this->tagUpdateTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $tagUpdateTime
     */
    public function setTagUpdateTime($tagUpdateTime)
    {
        $this->tagUpdateTime = $tagUpdateTime;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getServiceName()
    {
        return $this->serviceName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $serviceName
     */
    public function setServiceName($serviceName)
    {
        $this->serviceName = $serviceName;
    }

    /**
     * Initializes this ServiceTags from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of ServiceTags from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'resourceToTagIds') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceToTagIds = $child;
            $happened = true;
        }
        else if (($xml->localName == 'tags') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tags = $child;
            $happened = true;
        }
        else if (($xml->localName == 'tagVersion') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tagVersion = $child;
            $happened = true;
        }
        else if (($xml->localName == 'op') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->op = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serviceResources') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerServiceResource($xml);
            if (!isset($this->serviceResources)) {
                $this->serviceResources = array();
            }
            array_push($this->serviceResources, $child);
            $happened = true;
        }
        else if (($xml->localName == 'tagDefinitions') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tagDefinitions = $child;
            $happened = true;
        }
        else if (($xml->localName == 'tagUpdateTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tagUpdateTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serviceName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->serviceName = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of ServiceTags from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this ServiceTags to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'serviceTags', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this ServiceTags to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->resourceToTagIds) {
            $writer->startElementNs(null, 'resourceToTagIds', null);
            $writer->text($this->resourceToTagIds);
            $writer->endElement();
        }
        if ($this->tags) {
            $writer->startElementNs(null, 'tags', null);
            $writer->text($this->tags);
            $writer->endElement();
        }
        if ($this->tagVersion) {
            $writer->startElementNs(null, 'tagVersion', null);
            $writer->text($this->tagVersion);
            $writer->endElement();
        }
        if ($this->op) {
            $writer->startElementNs(null, 'op', null);
            $writer->text($this->op);
            $writer->endElement();
        }
        if ($this->serviceResources) {
            foreach ($this->serviceResources as $i => $x) {
                $writer->startElementNs(null, 'serviceResources', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->tagDefinitions) {
            $writer->startElementNs(null, 'tagDefinitions', null);
            $writer->text($this->tagDefinitions);
            $writer->endElement();
        }
        if ($this->tagUpdateTime) {
            $writer->startElementNs(null, 'tagUpdateTime', null);
            $writer->text($this->tagUpdateTime);
            $writer->endElement();
        }
        if ($this->serviceName) {
            $writer->startElementNs(null, 'serviceName', null);
            $writer->text($this->serviceName);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXUnixSyncSourceInfo
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $fileName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $syncTime;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $lastModified;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $unixBackend;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $minUserId;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $minGroupId;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $totalUsersSynced;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $totalGroupsSynced;

    /**
     * Constructs a VXUnixSyncSourceInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getFileName()
    {
        return $this->fileName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $fileName
     */
    public function setFileName($fileName)
    {
        $this->fileName = $fileName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSyncTime()
    {
        return $this->syncTime;
    }

    /**
     * (no documentation provided)
     *
     * @param string $syncTime
     */
    public function setSyncTime($syncTime)
    {
        $this->syncTime = $syncTime;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLastModified()
    {
        return $this->lastModified;
    }

    /**
     * (no documentation provided)
     *
     * @param string $lastModified
     */
    public function setLastModified($lastModified)
    {
        $this->lastModified = $lastModified;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUnixBackend()
    {
        return $this->unixBackend;
    }

    /**
     * (no documentation provided)
     *
     * @param string $unixBackend
     */
    public function setUnixBackend($unixBackend)
    {
        $this->unixBackend = $unixBackend;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getMinUserId()
    {
        return $this->minUserId;
    }

    /**
     * (no documentation provided)
     *
     * @param string $minUserId
     */
    public function setMinUserId($minUserId)
    {
        $this->minUserId = $minUserId;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getMinGroupId()
    {
        return $this->minGroupId;
    }

    /**
     * (no documentation provided)
     *
     * @param string $minGroupId
     */
    public function setMinGroupId($minGroupId)
    {
        $this->minGroupId = $minGroupId;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTotalUsersSynced()
    {
        return $this->totalUsersSynced;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $totalUsersSynced
     */
    public function setTotalUsersSynced($totalUsersSynced)
    {
        $this->totalUsersSynced = $totalUsersSynced;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTotalGroupsSynced()
    {
        return $this->totalGroupsSynced;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $totalGroupsSynced
     */
    public function setTotalGroupsSynced($totalGroupsSynced)
    {
        $this->totalGroupsSynced = $totalGroupsSynced;
    }

    /**
     * Initializes this VXUnixSyncSourceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of VXUnixSyncSourceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'fileName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->fileName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'syncTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->syncTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'lastModified') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->lastModified = $child;
            $happened = true;
        }
        else if (($xml->localName == 'unixBackend') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->unixBackend = $child;
            $happened = true;
        }
        else if (($xml->localName == 'minUserId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->minUserId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'minGroupId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->minGroupId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'totalUsersSynced') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->totalUsersSynced = $child;
            $happened = true;
        }
        else if (($xml->localName == 'totalGroupsSynced') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->totalGroupsSynced = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXUnixSyncSourceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this VXUnixSyncSourceInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXUnixSyncSourceInfo', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXUnixSyncSourceInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->fileName) {
            $writer->startElementNs(null, 'fileName', null);
            $writer->text($this->fileName);
            $writer->endElement();
        }
        if ($this->syncTime) {
            $writer->startElementNs(null, 'syncTime', null);
            $writer->text($this->syncTime);
            $writer->endElement();
        }
        if ($this->lastModified) {
            $writer->startElementNs(null, 'lastModified', null);
            $writer->text($this->lastModified);
            $writer->endElement();
        }
        if ($this->unixBackend) {
            $writer->startElementNs(null, 'unixBackend', null);
            $writer->text($this->unixBackend);
            $writer->endElement();
        }
        if ($this->minUserId) {
            $writer->startElementNs(null, 'minUserId', null);
            $writer->text($this->minUserId);
            $writer->endElement();
        }
        if ($this->minGroupId) {
            $writer->startElementNs(null, 'minGroupId', null);
            $writer->text($this->minGroupId);
            $writer->endElement();
        }
        if ($this->totalUsersSynced) {
            $writer->startElementNs(null, 'totalUsersSynced', null);
            $writer->text($this->totalUsersSynced);
            $writer->endElement();
        }
        if ($this->totalGroupsSynced) {
            $writer->startElementNs(null, 'totalGroupsSynced', null);
            $writer->text($this->totalGroupsSynced);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Util;

/**
 * (no documentation provided)
 */
class SecurityZoneInfo
{

    /**
     * (no documentation provided)
     *
     * @var array[]
     */
    private $resources;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicyDelta[]
     */
    private $policyDeltas;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicy[]
     */
    private $policies;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $zoneName;

    /**
     * Constructs a SecurityZoneInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return array[]
     */
    public function getResources()
    {
        return $this->resources;
    }

    /**
     * (no documentation provided)
     *
     * @param array[] $resources
     */
    public function setResources($resources)
    {
        $this->resources = $resources;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicyDelta[]
     */
    public function getPolicyDeltas()
    {
        return $this->policyDeltas;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicyDelta[] $policyDeltas
     */
    public function setPolicyDeltas($policyDeltas)
    {
        $this->policyDeltas = $policyDeltas;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicy[]
     */
    public function getPolicies()
    {
        return $this->policies;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicy[] $policies
     */
    public function setPolicies($policies)
    {
        $this->policies = $policies;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getZoneName()
    {
        return $this->zoneName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $zoneName
     */
    public function setZoneName($zoneName)
    {
        $this->zoneName = $zoneName;
    }

    /**
     * Initializes this SecurityZoneInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of SecurityZoneInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'resources') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->resources)) {
                $this->resources = array();
            }
            array_push($this->resources, $child);
            $happened = true;
        }
        else if (($xml->localName == 'policyDeltas') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicyDelta($xml);
            if (!isset($this->policyDeltas)) {
                $this->policyDeltas = array();
            }
            array_push($this->policyDeltas, $child);
            $happened = true;
        }
        else if (($xml->localName == 'policies') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicy($xml);
            if (!isset($this->policies)) {
                $this->policies = array();
            }
            array_push($this->policies, $child);
            $happened = true;
        }
        else if (($xml->localName == 'zoneName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->zoneName = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of SecurityZoneInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this SecurityZoneInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'securityZoneInfo', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this SecurityZoneInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->resources) {
            foreach ($this->resources as $i => $x) {
                $writer->startElementNs(null, 'resources', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->policyDeltas) {
            foreach ($this->policyDeltas as $i => $x) {
                $writer->startElementNs(null, 'policyDeltas', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->policies) {
            foreach ($this->policies as $i => $x) {
                $writer->startElementNs(null, 'policies', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->zoneName) {
            $writer->startElementNs(null, 'zoneName', null);
            $writer->text($this->zoneName);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Util;

/**
 * (no documentation provided)
 */
class GrantRevokeRequest
{

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $accessTypes;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $groups;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $clientType;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $resource;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $clientIPAddress;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $sessionId;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $clusterName;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $delegateAdmin;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $requestData;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $replaceExistingPermissions;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $enableAudit;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $zoneName;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $grantorGroups;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $grantor;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $users;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $isRecursive;

    /**
     * Constructs a GrantRevokeRequest from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getAccessTypes()
    {
        return $this->accessTypes;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $accessTypes
     */
    public function setAccessTypes($accessTypes)
    {
        $this->accessTypes = $accessTypes;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getGroups()
    {
        return $this->groups;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $groups
     */
    public function setGroups($groups)
    {
        $this->groups = $groups;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getClientType()
    {
        return $this->clientType;
    }

    /**
     * (no documentation provided)
     *
     * @param string $clientType
     */
    public function setClientType($clientType)
    {
        $this->clientType = $clientType;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getResource()
    {
        return $this->resource;
    }

    /**
     * (no documentation provided)
     *
     * @param array $resource
     */
    public function setResource($resource)
    {
        $this->resource = $resource;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getClientIPAddress()
    {
        return $this->clientIPAddress;
    }

    /**
     * (no documentation provided)
     *
     * @param string $clientIPAddress
     */
    public function setClientIPAddress($clientIPAddress)
    {
        $this->clientIPAddress = $clientIPAddress;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSessionId()
    {
        return $this->sessionId;
    }

    /**
     * (no documentation provided)
     *
     * @param string $sessionId
     */
    public function setSessionId($sessionId)
    {
        $this->sessionId = $sessionId;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getClusterName()
    {
        return $this->clusterName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $clusterName
     */
    public function setClusterName($clusterName)
    {
        $this->clusterName = $clusterName;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getDelegateAdmin()
    {
        return $this->delegateAdmin;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $delegateAdmin
     */
    public function setDelegateAdmin($delegateAdmin)
    {
        $this->delegateAdmin = $delegateAdmin;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRequestData()
    {
        return $this->requestData;
    }

    /**
     * (no documentation provided)
     *
     * @param string $requestData
     */
    public function setRequestData($requestData)
    {
        $this->requestData = $requestData;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getReplaceExistingPermissions()
    {
        return $this->replaceExistingPermissions;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $replaceExistingPermissions
     */
    public function setReplaceExistingPermissions($replaceExistingPermissions)
    {
        $this->replaceExistingPermissions = $replaceExistingPermissions;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getEnableAudit()
    {
        return $this->enableAudit;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $enableAudit
     */
    public function setEnableAudit($enableAudit)
    {
        $this->enableAudit = $enableAudit;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getZoneName()
    {
        return $this->zoneName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $zoneName
     */
    public function setZoneName($zoneName)
    {
        $this->zoneName = $zoneName;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getGrantorGroups()
    {
        return $this->grantorGroups;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $grantorGroups
     */
    public function setGrantorGroups($grantorGroups)
    {
        $this->grantorGroups = $grantorGroups;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getGrantor()
    {
        return $this->grantor;
    }

    /**
     * (no documentation provided)
     *
     * @param string $grantor
     */
    public function setGrantor($grantor)
    {
        $this->grantor = $grantor;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getUsers()
    {
        return $this->users;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $users
     */
    public function setUsers($users)
    {
        $this->users = $users;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getIsRecursive()
    {
        return $this->isRecursive;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $isRecursive
     */
    public function setIsRecursive($isRecursive)
    {
        $this->isRecursive = $isRecursive;
    }

    /**
     * Initializes this GrantRevokeRequest from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of GrantRevokeRequest from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'accessTypes') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->accessTypes)) {
                $this->accessTypes = array();
            }
            array_push($this->accessTypes, $child);
            $happened = true;
        }
        else if (($xml->localName == 'groups') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->groups)) {
                $this->groups = array();
            }
            array_push($this->groups, $child);
            $happened = true;
        }
        else if (($xml->localName == 'clientType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->clientType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resource') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resource = $child;
            $happened = true;
        }
        else if (($xml->localName == 'clientIPAddress') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->clientIPAddress = $child;
            $happened = true;
        }
        else if (($xml->localName == 'sessionId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->sessionId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'clusterName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->clusterName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'delegateAdmin') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->delegateAdmin = $child;
            $happened = true;
        }
        else if (($xml->localName == 'requestData') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->requestData = $child;
            $happened = true;
        }
        else if (($xml->localName == 'replaceExistingPermissions') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->replaceExistingPermissions = $child;
            $happened = true;
        }
        else if (($xml->localName == 'enableAudit') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->enableAudit = $child;
            $happened = true;
        }
        else if (($xml->localName == 'zoneName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->zoneName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'grantorGroups') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->grantorGroups)) {
                $this->grantorGroups = array();
            }
            array_push($this->grantorGroups, $child);
            $happened = true;
        }
        else if (($xml->localName == 'grantor') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->grantor = $child;
            $happened = true;
        }
        else if (($xml->localName == 'users') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->users)) {
                $this->users = array();
            }
            array_push($this->users, $child);
            $happened = true;
        }
        else if (($xml->localName == 'isRecursive') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isRecursive = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of GrantRevokeRequest from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this GrantRevokeRequest to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'grantRevokeRequest', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this GrantRevokeRequest to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->accessTypes) {
            foreach ($this->accessTypes as $i => $x) {
                $writer->startElementNs(null, 'accessTypes', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->groups) {
            foreach ($this->groups as $i => $x) {
                $writer->startElementNs(null, 'groups', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->clientType) {
            $writer->startElementNs(null, 'clientType', null);
            $writer->text($this->clientType);
            $writer->endElement();
        }
        if ($this->resource) {
            $writer->startElementNs(null, 'resource', null);
            $writer->text($this->resource);
            $writer->endElement();
        }
        if ($this->clientIPAddress) {
            $writer->startElementNs(null, 'clientIPAddress', null);
            $writer->text($this->clientIPAddress);
            $writer->endElement();
        }
        if ($this->sessionId) {
            $writer->startElementNs(null, 'sessionId', null);
            $writer->text($this->sessionId);
            $writer->endElement();
        }
        if ($this->clusterName) {
            $writer->startElementNs(null, 'clusterName', null);
            $writer->text($this->clusterName);
            $writer->endElement();
        }
        if ($this->delegateAdmin) {
            $writer->startElementNs(null, 'delegateAdmin', null);
            $writer->text($this->delegateAdmin);
            $writer->endElement();
        }
        if ($this->requestData) {
            $writer->startElementNs(null, 'requestData', null);
            $writer->text($this->requestData);
            $writer->endElement();
        }
        if ($this->replaceExistingPermissions) {
            $writer->startElementNs(null, 'replaceExistingPermissions', null);
            $writer->text($this->replaceExistingPermissions);
            $writer->endElement();
        }
        if ($this->enableAudit) {
            $writer->startElementNs(null, 'enableAudit', null);
            $writer->text($this->enableAudit);
            $writer->endElement();
        }
        if ($this->zoneName) {
            $writer->startElementNs(null, 'zoneName', null);
            $writer->text($this->zoneName);
            $writer->endElement();
        }
        if ($this->grantorGroups) {
            foreach ($this->grantorGroups as $i => $x) {
                $writer->startElementNs(null, 'grantorGroups', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->grantor) {
            $writer->startElementNs(null, 'grantor', null);
            $writer->text($this->grantor);
            $writer->endElement();
        }
        if ($this->users) {
            foreach ($this->users as $i => $x) {
                $writer->startElementNs(null, 'users', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->isRecursive) {
            $writer->startElementNs(null, 'isRecursive', null);
            $writer->text($this->isRecursive);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerValiditySchedule
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $timeZone;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $startTime;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $endTime;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerValidityRecurrence[]
     */
    private $recurrences;

    /**
     * Constructs a RangerValiditySchedule from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getTimeZone()
    {
        return $this->timeZone;
    }

    /**
     * (no documentation provided)
     *
     * @param string $timeZone
     */
    public function setTimeZone($timeZone)
    {
        $this->timeZone = $timeZone;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getStartTime()
    {
        return $this->startTime;
    }

    /**
     * (no documentation provided)
     *
     * @param string $startTime
     */
    public function setStartTime($startTime)
    {
        $this->startTime = $startTime;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getEndTime()
    {
        return $this->endTime;
    }

    /**
     * (no documentation provided)
     *
     * @param string $endTime
     */
    public function setEndTime($endTime)
    {
        $this->endTime = $endTime;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerValidityRecurrence[]
     */
    public function getRecurrences()
    {
        return $this->recurrences;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerValidityRecurrence[] $recurrences
     */
    public function setRecurrences($recurrences)
    {
        $this->recurrences = $recurrences;
    }

    /**
     * Initializes this RangerValiditySchedule from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerValiditySchedule from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'timeZone') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->timeZone = $child;
            $happened = true;
        }
        else if (($xml->localName == 'startTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->startTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'endTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->endTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'recurrences') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerValidityRecurrence($xml);
            if (!isset($this->recurrences)) {
                $this->recurrences = array();
            }
            array_push($this->recurrences, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerValiditySchedule from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerValiditySchedule to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerValiditySchedule', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerValiditySchedule to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->timeZone) {
            $writer->startElementNs(null, 'timeZone', null);
            $writer->text($this->timeZone);
            $writer->endElement();
        }
        if ($this->startTime) {
            $writer->startElementNs(null, 'startTime', null);
            $writer->text($this->startTime);
            $writer->endElement();
        }
        if ($this->endTime) {
            $writer->startElementNs(null, 'endTime', null);
            $writer->text($this->endTime);
            $writer->endElement();
        }
        if ($this->recurrences) {
            foreach ($this->recurrences as $i => $x) {
                $writer->startElementNs(null, 'recurrences', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RecurrenceSchedule
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $hour;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $year;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $minute;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $dayOfWeek;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $dayOfMonth;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $month;

    /**
     * Constructs a RecurrenceSchedule from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getHour()
    {
        return $this->hour;
    }

    /**
     * (no documentation provided)
     *
     * @param string $hour
     */
    public function setHour($hour)
    {
        $this->hour = $hour;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getYear()
    {
        return $this->year;
    }

    /**
     * (no documentation provided)
     *
     * @param string $year
     */
    public function setYear($year)
    {
        $this->year = $year;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getMinute()
    {
        return $this->minute;
    }

    /**
     * (no documentation provided)
     *
     * @param string $minute
     */
    public function setMinute($minute)
    {
        $this->minute = $minute;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDayOfWeek()
    {
        return $this->dayOfWeek;
    }

    /**
     * (no documentation provided)
     *
     * @param string $dayOfWeek
     */
    public function setDayOfWeek($dayOfWeek)
    {
        $this->dayOfWeek = $dayOfWeek;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDayOfMonth()
    {
        return $this->dayOfMonth;
    }

    /**
     * (no documentation provided)
     *
     * @param string $dayOfMonth
     */
    public function setDayOfMonth($dayOfMonth)
    {
        $this->dayOfMonth = $dayOfMonth;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getMonth()
    {
        return $this->month;
    }

    /**
     * (no documentation provided)
     *
     * @param string $month
     */
    public function setMonth($month)
    {
        $this->month = $month;
    }

    /**
     * Initializes this RecurrenceSchedule from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RecurrenceSchedule from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'hour') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->hour = $child;
            $happened = true;
        }
        else if (($xml->localName == 'year') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->year = $child;
            $happened = true;
        }
        else if (($xml->localName == 'minute') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->minute = $child;
            $happened = true;
        }
        else if (($xml->localName == 'dayOfWeek') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->dayOfWeek = $child;
            $happened = true;
        }
        else if (($xml->localName == 'dayOfMonth') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->dayOfMonth = $child;
            $happened = true;
        }
        else if (($xml->localName == 'month') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->month = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RecurrenceSchedule from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RecurrenceSchedule to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'recurrenceSchedule', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RecurrenceSchedule to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->hour) {
            $writer->startElementNs(null, 'hour', null);
            $writer->text($this->hour);
            $writer->endElement();
        }
        if ($this->year) {
            $writer->startElementNs(null, 'year', null);
            $writer->text($this->year);
            $writer->endElement();
        }
        if ($this->minute) {
            $writer->startElementNs(null, 'minute', null);
            $writer->text($this->minute);
            $writer->endElement();
        }
        if ($this->dayOfWeek) {
            $writer->startElementNs(null, 'dayOfWeek', null);
            $writer->text($this->dayOfWeek);
            $writer->endElement();
        }
        if ($this->dayOfMonth) {
            $writer->startElementNs(null, 'dayOfMonth', null);
            $writer->text($this->dayOfMonth);
            $writer->endElement();
        }
        if ($this->month) {
            $writer->startElementNs(null, 'month', null);
            $writer->text($this->month);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerPolicyConditionDef
{

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $evaluatorOptions;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $uiHint;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $validationRegEx;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $validationMessage;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyValidationMessage;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $label;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyLabel;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyDescription;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $evaluator;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $itemId;

    /**
     * Constructs a RangerPolicyConditionDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getEvaluatorOptions()
    {
        return $this->evaluatorOptions;
    }

    /**
     * (no documentation provided)
     *
     * @param array $evaluatorOptions
     */
    public function setEvaluatorOptions($evaluatorOptions)
    {
        $this->evaluatorOptions = $evaluatorOptions;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUiHint()
    {
        return $this->uiHint;
    }

    /**
     * (no documentation provided)
     *
     * @param string $uiHint
     */
    public function setUiHint($uiHint)
    {
        $this->uiHint = $uiHint;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getValidationRegEx()
    {
        return $this->validationRegEx;
    }

    /**
     * (no documentation provided)
     *
     * @param string $validationRegEx
     */
    public function setValidationRegEx($validationRegEx)
    {
        $this->validationRegEx = $validationRegEx;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getValidationMessage()
    {
        return $this->validationMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string $validationMessage
     */
    public function setValidationMessage($validationMessage)
    {
        $this->validationMessage = $validationMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyValidationMessage()
    {
        return $this->rbKeyValidationMessage;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyValidationMessage
     */
    public function setRbKeyValidationMessage($rbKeyValidationMessage)
    {
        $this->rbKeyValidationMessage = $rbKeyValidationMessage;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLabel()
    {
        return $this->label;
    }

    /**
     * (no documentation provided)
     *
     * @param string $label
     */
    public function setLabel($label)
    {
        $this->label = $label;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyLabel()
    {
        return $this->rbKeyLabel;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyLabel
     */
    public function setRbKeyLabel($rbKeyLabel)
    {
        $this->rbKeyLabel = $rbKeyLabel;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyDescription()
    {
        return $this->rbKeyDescription;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyDescription
     */
    public function setRbKeyDescription($rbKeyDescription)
    {
        $this->rbKeyDescription = $rbKeyDescription;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getEvaluator()
    {
        return $this->evaluator;
    }

    /**
     * (no documentation provided)
     *
     * @param string $evaluator
     */
    public function setEvaluator($evaluator)
    {
        $this->evaluator = $evaluator;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getItemId()
    {
        return $this->itemId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $itemId
     */
    public function setItemId($itemId)
    {
        $this->itemId = $itemId;
    }

    /**
     * Initializes this RangerPolicyConditionDef from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerPolicyConditionDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'evaluatorOptions') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->evaluatorOptions = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'uiHint') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->uiHint = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'validationRegEx') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->validationRegEx = $child;
            $happened = true;
        }
        else if (($xml->localName == 'validationMessage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->validationMessage = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyValidationMessage') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyValidationMessage = $child;
            $happened = true;
        }
        else if (($xml->localName == 'label') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->label = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyLabel') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyLabel = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyDescription') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyDescription = $child;
            $happened = true;
        }
        else if (($xml->localName == 'evaluator') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->evaluator = $child;
            $happened = true;
        }
        else if (($xml->localName == 'itemId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->itemId = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPolicyConditionDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerPolicyConditionDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPolicyConditionDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPolicyConditionDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->evaluatorOptions) {
            $writer->startElementNs(null, 'evaluatorOptions', null);
            $writer->text($this->evaluatorOptions);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->uiHint) {
            $writer->startElementNs(null, 'uiHint', null);
            $writer->text($this->uiHint);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->validationRegEx) {
            $writer->startElementNs(null, 'validationRegEx', null);
            $writer->text($this->validationRegEx);
            $writer->endElement();
        }
        if ($this->validationMessage) {
            $writer->startElementNs(null, 'validationMessage', null);
            $writer->text($this->validationMessage);
            $writer->endElement();
        }
        if ($this->rbKeyValidationMessage) {
            $writer->startElementNs(null, 'rbKeyValidationMessage', null);
            $writer->text($this->rbKeyValidationMessage);
            $writer->endElement();
        }
        if ($this->label) {
            $writer->startElementNs(null, 'label', null);
            $writer->text($this->label);
            $writer->endElement();
        }
        if ($this->rbKeyLabel) {
            $writer->startElementNs(null, 'rbKeyLabel', null);
            $writer->text($this->rbKeyLabel);
            $writer->endElement();
        }
        if ($this->rbKeyDescription) {
            $writer->startElementNs(null, 'rbKeyDescription', null);
            $writer->text($this->rbKeyDescription);
            $writer->endElement();
        }
        if ($this->evaluator) {
            $writer->startElementNs(null, 'evaluator', null);
            $writer->text($this->evaluator);
            $writer->endElement();
        }
        if ($this->itemId) {
            $writer->startElementNs(null, 'itemId', null);
            $writer->text($this->itemId);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXAuditRecord
{

    /**
     * Date - value of member attribute &lt;b&gt;date&lt;/b&gt;.
     *
     * @var integer
     */
    private $date;

    /**
     * String - value of member attribute &lt;b&gt;resource&lt;/b&gt;.
     *
     * @var string
     */
    private $resource;

    /**
     * String - value of member attribute &lt;b&gt;action&lt;/b&gt;.
     *
     * @var string
     */
    private $action;

    /**
     * String - value of member attribute &lt;b&gt;result&lt;/b&gt;.
     *
     * @var string
     */
    private $result;

    /**
     * String - value of member attribute &lt;b&gt;user&lt;/b&gt;.
     *
     * @var string
     */
    private $user;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $enforcer;

    /**
     * int - value of member attribute &lt;b&gt;resourceType&lt;/b&gt;.
     *
     * @var integer
     */
    private $resourceType;

    /**
     * int - value of member attribute &lt;b&gt;assetType&lt;/b&gt;.
     *
     * @var integer
     */
    private $assetType;

    /**
     * Constructs a VXAuditRecord from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * Date - value of member attribute &lt;b&gt;date&lt;/b&gt;.
     *
     * @return integer
     */
    public function getDate()
    {
        return $this->date;
    }

    /**
     * Date - value of member attribute &lt;b&gt;date&lt;/b&gt;.
     *
     * @param integer $date
     */
    public function setDate($date)
    {
        $this->date = $date;
    }
    /**
     * String - value of member attribute &lt;b&gt;resource&lt;/b&gt;.
     *
     * @return string
     */
    public function getResource()
    {
        return $this->resource;
    }

    /**
     * String - value of member attribute &lt;b&gt;resource&lt;/b&gt;.
     *
     * @param string $resource
     */
    public function setResource($resource)
    {
        $this->resource = $resource;
    }
    /**
     * String - value of member attribute &lt;b&gt;action&lt;/b&gt;.
     *
     * @return string
     */
    public function getAction()
    {
        return $this->action;
    }

    /**
     * String - value of member attribute &lt;b&gt;action&lt;/b&gt;.
     *
     * @param string $action
     */
    public function setAction($action)
    {
        $this->action = $action;
    }
    /**
     * String - value of member attribute &lt;b&gt;result&lt;/b&gt;.
     *
     * @return string
     */
    public function getResult()
    {
        return $this->result;
    }

    /**
     * String - value of member attribute &lt;b&gt;result&lt;/b&gt;.
     *
     * @param string $result
     */
    public function setResult($result)
    {
        $this->result = $result;
    }
    /**
     * String - value of member attribute &lt;b&gt;user&lt;/b&gt;.
     *
     * @return string
     */
    public function getUser()
    {
        return $this->user;
    }

    /**
     * String - value of member attribute &lt;b&gt;user&lt;/b&gt;.
     *
     * @param string $user
     */
    public function setUser($user)
    {
        $this->user = $user;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getEnforcer()
    {
        return $this->enforcer;
    }

    /**
     * (no documentation provided)
     *
     * @param string $enforcer
     */
    public function setEnforcer($enforcer)
    {
        $this->enforcer = $enforcer;
    }
    /**
     * int - value of member attribute &lt;b&gt;resourceType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getResourceType()
    {
        return $this->resourceType;
    }

    /**
     * int - value of member attribute &lt;b&gt;resourceType&lt;/b&gt;.
     *
     * @param integer $resourceType
     */
    public function setResourceType($resourceType)
    {
        $this->resourceType = $resourceType;
    }
    /**
     * int - value of member attribute &lt;b&gt;assetType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getAssetType()
    {
        return $this->assetType;
    }

    /**
     * int - value of member attribute &lt;b&gt;assetType&lt;/b&gt;.
     *
     * @param integer $assetType
     */
    public function setAssetType($assetType)
    {
        $this->assetType = $assetType;
    }

    /**
     * Initializes this VXAuditRecord from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of VXAuditRecord from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'date') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->date = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resource') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resource = $child;
            $happened = true;
        }
        else if (($xml->localName == 'action') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->action = $child;
            $happened = true;
        }
        else if (($xml->localName == 'result') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->result = $child;
            $happened = true;
        }
        else if (($xml->localName == 'user') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->user = $child;
            $happened = true;
        }
        else if (($xml->localName == 'enforcer') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->enforcer = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourceType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'assetType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->assetType = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXAuditRecord from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this VXAuditRecord to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXAuditRecord', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXAuditRecord to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->date) {
            $writer->startElementNs(null, 'date', null);
            $writer->text($this->date);
            $writer->endElement();
        }
        if ($this->resource) {
            $writer->startElementNs(null, 'resource', null);
            $writer->text($this->resource);
            $writer->endElement();
        }
        if ($this->action) {
            $writer->startElementNs(null, 'action', null);
            $writer->text($this->action);
            $writer->endElement();
        }
        if ($this->result) {
            $writer->startElementNs(null, 'result', null);
            $writer->text($this->result);
            $writer->endElement();
        }
        if ($this->user) {
            $writer->startElementNs(null, 'user', null);
            $writer->text($this->user);
            $writer->endElement();
        }
        if ($this->enforcer) {
            $writer->startElementNs(null, 'enforcer', null);
            $writer->text($this->enforcer);
            $writer->endElement();
        }
        if ($this->resourceType) {
            $writer->startElementNs(null, 'resourceType', null);
            $writer->text($this->resourceType);
            $writer->endElement();
        }
        if ($this->assetType) {
            $writer->startElementNs(null, 'assetType', null);
            $writer->text($this->assetType);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerEnumDef
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerEnumElementDef[]
     */
    private $elements;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $itemId;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $defaultIndex;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * Constructs a RangerEnumDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerEnumElementDef[]
     */
    public function getElements()
    {
        return $this->elements;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerEnumElementDef[] $elements
     */
    public function setElements($elements)
    {
        $this->elements = $elements;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getItemId()
    {
        return $this->itemId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $itemId
     */
    public function setItemId($itemId)
    {
        $this->itemId = $itemId;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getDefaultIndex()
    {
        return $this->defaultIndex;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $defaultIndex
     */
    public function setDefaultIndex($defaultIndex)
    {
        $this->defaultIndex = $defaultIndex;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * Initializes this RangerEnumDef from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerEnumDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'elements') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerEnumElementDef($xml);
            if (!isset($this->elements)) {
                $this->elements = array();
            }
            array_push($this->elements, $child);
            $happened = true;
        }
        else if (($xml->localName == 'itemId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->itemId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'defaultIndex') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->defaultIndex = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerEnumDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerEnumDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerEnumDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerEnumDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->elements) {
            foreach ($this->elements as $i => $x) {
                $writer->startElementNs(null, 'elements', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->itemId) {
            $writer->startElementNs(null, 'itemId', null);
            $writer->text($this->itemId);
            $writer->endElement();
        }
        if ($this->defaultIndex) {
            $writer->startElementNs(null, 'defaultIndex', null);
            $writer->text($this->defaultIndex);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerDataMaskDef
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerResourceDef[]
     */
    private $resources;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerDataMaskTypeDef[]
     */
    private $maskTypes;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef[]
     */
    private $accessTypes;

    /**
     * Constructs a RangerDataMaskDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerResourceDef[]
     */
    public function getResources()
    {
        return $this->resources;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerResourceDef[] $resources
     */
    public function setResources($resources)
    {
        $this->resources = $resources;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerDataMaskTypeDef[]
     */
    public function getMaskTypes()
    {
        return $this->maskTypes;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerDataMaskTypeDef[] $maskTypes
     */
    public function setMaskTypes($maskTypes)
    {
        $this->maskTypes = $maskTypes;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef[]
     */
    public function getAccessTypes()
    {
        return $this->accessTypes;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef[] $accessTypes
     */
    public function setAccessTypes($accessTypes)
    {
        $this->accessTypes = $accessTypes;
    }

    /**
     * Initializes this RangerDataMaskDef from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerDataMaskDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'resources') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerResourceDef($xml);
            if (!isset($this->resources)) {
                $this->resources = array();
            }
            array_push($this->resources, $child);
            $happened = true;
        }
        else if (($xml->localName == 'maskTypes') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerDataMaskTypeDef($xml);
            if (!isset($this->maskTypes)) {
                $this->maskTypes = array();
            }
            array_push($this->maskTypes, $child);
            $happened = true;
        }
        else if (($xml->localName == 'accessTypes') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef($xml);
            if (!isset($this->accessTypes)) {
                $this->accessTypes = array();
            }
            array_push($this->accessTypes, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerDataMaskDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerDataMaskDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerDataMaskDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerDataMaskDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->resources) {
            foreach ($this->resources as $i => $x) {
                $writer->startElementNs(null, 'resources', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->maskTypes) {
            foreach ($this->maskTypes as $i => $x) {
                $writer->startElementNs(null, 'maskTypes', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->accessTypes) {
            foreach ($this->accessTypes as $i => $x) {
                $writer->startElementNs(null, 'accessTypes', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXFileSyncSourceInfo
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $fileName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $syncTime;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $lastModified;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $totalUsersSynced;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $totalGroupsSynced;

    /**
     * Constructs a VXFileSyncSourceInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getFileName()
    {
        return $this->fileName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $fileName
     */
    public function setFileName($fileName)
    {
        $this->fileName = $fileName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSyncTime()
    {
        return $this->syncTime;
    }

    /**
     * (no documentation provided)
     *
     * @param string $syncTime
     */
    public function setSyncTime($syncTime)
    {
        $this->syncTime = $syncTime;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLastModified()
    {
        return $this->lastModified;
    }

    /**
     * (no documentation provided)
     *
     * @param string $lastModified
     */
    public function setLastModified($lastModified)
    {
        $this->lastModified = $lastModified;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTotalUsersSynced()
    {
        return $this->totalUsersSynced;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $totalUsersSynced
     */
    public function setTotalUsersSynced($totalUsersSynced)
    {
        $this->totalUsersSynced = $totalUsersSynced;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTotalGroupsSynced()
    {
        return $this->totalGroupsSynced;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $totalGroupsSynced
     */
    public function setTotalGroupsSynced($totalGroupsSynced)
    {
        $this->totalGroupsSynced = $totalGroupsSynced;
    }

    /**
     * Initializes this VXFileSyncSourceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of VXFileSyncSourceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'fileName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->fileName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'syncTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->syncTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'lastModified') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->lastModified = $child;
            $happened = true;
        }
        else if (($xml->localName == 'totalUsersSynced') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->totalUsersSynced = $child;
            $happened = true;
        }
        else if (($xml->localName == 'totalGroupsSynced') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->totalGroupsSynced = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXFileSyncSourceInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this VXFileSyncSourceInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXFileSyncSourceInfo', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXFileSyncSourceInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->fileName) {
            $writer->startElementNs(null, 'fileName', null);
            $writer->text($this->fileName);
            $writer->endElement();
        }
        if ($this->syncTime) {
            $writer->startElementNs(null, 'syncTime', null);
            $writer->text($this->syncTime);
            $writer->endElement();
        }
        if ($this->lastModified) {
            $writer->startElementNs(null, 'lastModified', null);
            $writer->text($this->lastModified);
            $writer->endElement();
        }
        if ($this->totalUsersSynced) {
            $writer->startElementNs(null, 'totalUsersSynced', null);
            $writer->text($this->totalUsersSynced);
            $writer->endElement();
        }
        if ($this->totalGroupsSynced) {
            $writer->startElementNs(null, 'totalGroupsSynced', null);
            $writer->text($this->totalGroupsSynced);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerAccessTypeDef
{

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $itemId;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $impliedGrants;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $label;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyLabel;

    /**
     * Constructs a RangerAccessTypeDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getItemId()
    {
        return $this->itemId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $itemId
     */
    public function setItemId($itemId)
    {
        $this->itemId = $itemId;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getImpliedGrants()
    {
        return $this->impliedGrants;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $impliedGrants
     */
    public function setImpliedGrants($impliedGrants)
    {
        $this->impliedGrants = $impliedGrants;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLabel()
    {
        return $this->label;
    }

    /**
     * (no documentation provided)
     *
     * @param string $label
     */
    public function setLabel($label)
    {
        $this->label = $label;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyLabel()
    {
        return $this->rbKeyLabel;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyLabel
     */
    public function setRbKeyLabel($rbKeyLabel)
    {
        $this->rbKeyLabel = $rbKeyLabel;
    }

    /**
     * Initializes this RangerAccessTypeDef from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerAccessTypeDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'itemId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->itemId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'impliedGrants') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->impliedGrants)) {
                $this->impliedGrants = array();
            }
            array_push($this->impliedGrants, $child);
            $happened = true;
        }
        else if (($xml->localName == 'label') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->label = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyLabel') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyLabel = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerAccessTypeDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerAccessTypeDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerAccessTypeDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerAccessTypeDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->itemId) {
            $writer->startElementNs(null, 'itemId', null);
            $writer->text($this->itemId);
            $writer->endElement();
        }
        if ($this->impliedGrants) {
            foreach ($this->impliedGrants as $i => $x) {
                $writer->startElementNs(null, 'impliedGrants', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->label) {
            $writer->startElementNs(null, 'label', null);
            $writer->text($this->label);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->rbKeyLabel) {
            $writer->startElementNs(null, 'rbKeyLabel', null);
            $writer->text($this->rbKeyLabel);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerPolicyItemCondition
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $values;

    /**
     * Constructs a RangerPolicyItemCondition from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getValues()
    {
        return $this->values;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $values
     */
    public function setValues($values)
    {
        $this->values = $values;
    }

    /**
     * Initializes this RangerPolicyItemCondition from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RangerPolicyItemCondition from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'type') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->type = $child;
            $happened = true;
        }
        else if (($xml->localName == 'values') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->values)) {
                $this->values = array();
            }
            array_push($this->values, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPolicyItemCondition from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes this RangerPolicyItemCondition to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPolicyItemCondition', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPolicyItemCondition to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->type) {
            $writer->startElementNs(null, 'type', null);
            $writer->text($this->type);
            $writer->endElement();
        }
        if ($this->values) {
            foreach ($this->values as $i => $x) {
                $writer->startElementNs(null, 'values', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\Admin\Client\Datatype;

/**
 * (no documentation provided)
 */
class RESTResponse
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $msgDesc;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $httpStatusCode;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $statusCode;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Admin\Client\Datatype\Message[]
     */
    private $messageList;

    /**
     * Constructs a RESTResponse from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getMsgDesc()
    {
        return $this->msgDesc;
    }

    /**
     * (no documentation provided)
     *
     * @param string $msgDesc
     */
    public function setMsgDesc($msgDesc)
    {
        $this->msgDesc = $msgDesc;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getHttpStatusCode()
    {
        return $this->httpStatusCode;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $httpStatusCode
     */
    public function setHttpStatusCode($httpStatusCode)
    {
        $this->httpStatusCode = $httpStatusCode;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getStatusCode()
    {
        return $this->statusCode;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $statusCode
     */
    public function setStatusCode($statusCode)
    {
        $this->statusCode = $statusCode;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Admin\Client\Datatype\Message[]
     */
    public function getMessageList()
    {
        return $this->messageList;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Admin\Client\Datatype\Message[] $messageList
     */
    public function setMessageList($messageList)
    {
        $this->messageList = $messageList;
    }

    /**
     * Initializes this RESTResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader to use to initialize this object.
     */
    public function initFromReader($xml)
    {
        $empty = $xml->isEmptyElement;

        if ($xml->hasAttributes) {
            $moreAttributes = $xml->moveToFirstAttribute();
            while ($moreAttributes) {
                if (!$this->setKnownAttribute($xml)) {
                    //skip unknown attributes...
                }
                $moreAttributes = $xml->moveToNextAttribute();
            }
        }

        if (!$empty) {
            $xml->read();
            while ($xml->nodeType != \XMLReader::END_ELEMENT) {
                if ($xml->nodeType != \XMLReader::ELEMENT) {
                    //no-op: skip any insignificant whitespace, comments, etc.
                }
                else if (!$xml->isEmptyElement && !$this->setKnownChildElement($xml)) {
                    $n = $xml->localName;
                    $ns = $xml->namespaceURI;
                    //skip the unknown element
                    while ($xml->nodeType != \XMLReader::END_ELEMENT && $xml->localName != $n && $xml->namespaceURI != $ns) {
                        $xml->read();
                    }
                }
                $xml->read(); //advance the reader.
            }
        }
    }


    /**
     * Sets a known child element of RESTResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = false;
        if (($xml->localName == 'msgDesc') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->msgDesc = $child;
            $happened = true;
        }
        else if (($xml->localName == 'httpStatusCode') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->httpStatusCode = $child;
            $happened = true;
        }
        else if (($xml->localName == 'statusCode') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->statusCode = $child;
            $happened = true;
        }
        else if (($xml->localName == 'messageList') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Admin\Client\Datatype\Message($xml);
            if (!isset($this->messageList)) {
                $this->messageList = array();
            }
            array_push($this->messageList, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RESTResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {

        return false;
    }

    /**
     * Writes the contents of this RESTResponse to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        if ($this->msgDesc) {
            $writer->startElementNs(null, 'msgDesc', null);
            $writer->text($this->msgDesc);
            $writer->endElement();
        }
        if ($this->httpStatusCode) {
            $writer->startElementNs(null, 'httpStatusCode', null);
            $writer->text($this->httpStatusCode);
            $writer->endElement();
        }
        if ($this->statusCode) {
            $writer->startElementNs(null, 'statusCode', null);
            $writer->text($this->statusCode);
            $writer->endElement();
        }
        if ($this->messageList) {
            foreach ($this->messageList as $i => $x) {
                $writer->startElementNs(null, 'messageList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\Common\View;

/**
 * (no documentation provided)
 */
class VTrxLogAttr extends \Org\Apache\Ranger\Common\View\ViewBaseBean
{

    /**
     * Constructs a VTrxLogAttr from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }


    /**
     * Sets a known child element of VTrxLogAttr from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        return false;
    }

    /**
     * Sets a known attribute of VTrxLogAttr from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VTrxLogAttr to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VTrxLogAttr', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VTrxLogAttr to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerServiceResource extends \Org\Apache\Ranger\Plugin\Model\RangerBaseModelObject
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $serviceName;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $resourceElements;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $resourceSignature;

    /**
     * Constructs a RangerServiceResource from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getServiceName()
    {
        return $this->serviceName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $serviceName
     */
    public function setServiceName($serviceName)
    {
        $this->serviceName = $serviceName;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getResourceElements()
    {
        return $this->resourceElements;
    }

    /**
     * (no documentation provided)
     *
     * @param array $resourceElements
     */
    public function setResourceElements($resourceElements)
    {
        $this->resourceElements = $resourceElements;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getResourceSignature()
    {
        return $this->resourceSignature;
    }

    /**
     * (no documentation provided)
     *
     * @param string $resourceSignature
     */
    public function setResourceSignature($resourceSignature)
    {
        $this->resourceSignature = $resourceSignature;
    }

    /**
     * Sets a known child element of RangerServiceResource from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'serviceName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->serviceName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourceElements') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceElements = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourceSignature') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceSignature = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerServiceResource from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerServiceResource to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerServiceResource', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerServiceResource to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->serviceName) {
            $writer->startElementNs(null, 'serviceName', null);
            $writer->text($this->serviceName);
            $writer->endElement();
        }
        if ($this->resourceElements) {
            $writer->startElementNs(null, 'resourceElements', null);
            $writer->text($this->resourceElements);
            $writer->endElement();
        }
        if ($this->resourceSignature) {
            $writer->startElementNs(null, 'resourceSignature', null);
            $writer->text($this->resourceSignature);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXMessage extends \Org\Apache\Ranger\Common\View\ViewBaseBean
{

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @var string
     */
    private $name;

    /**
     * String - value of member attribute &lt;b&gt;rbKey&lt;/b&gt;.
     *
     * @var string
     */
    private $rbKey;

    /**
     * String - value of member attribute &lt;b&gt;message&lt;/b&gt;.
     *
     * @var string
     */
    private $message;

    /**
     * Long - value of member attribute &lt;b&gt;objectId&lt;/b&gt;.
     *
     * @var integer
     */
    private $objectId;

    /**
     * String - value of member attribute &lt;b&gt;fieldName&lt;/b&gt;.
     *
     * @var string
     */
    private $fieldName;

    /**
     * Constructs a VXMessage from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * String - value of member attribute &lt;b&gt;rbKey&lt;/b&gt;.
     *
     * @return string
     */
    public function getRbKey()
    {
        return $this->rbKey;
    }

    /**
     * String - value of member attribute &lt;b&gt;rbKey&lt;/b&gt;.
     *
     * @param string $rbKey
     */
    public function setRbKey($rbKey)
    {
        $this->rbKey = $rbKey;
    }
    /**
     * String - value of member attribute &lt;b&gt;message&lt;/b&gt;.
     *
     * @return string
     */
    public function getMessage()
    {
        return $this->message;
    }

    /**
     * String - value of member attribute &lt;b&gt;message&lt;/b&gt;.
     *
     * @param string $message
     */
    public function setMessage($message)
    {
        $this->message = $message;
    }
    /**
     * Long - value of member attribute &lt;b&gt;objectId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getObjectId()
    {
        return $this->objectId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;objectId&lt;/b&gt;.
     *
     * @param integer $objectId
     */
    public function setObjectId($objectId)
    {
        $this->objectId = $objectId;
    }
    /**
     * String - value of member attribute &lt;b&gt;fieldName&lt;/b&gt;.
     *
     * @return string
     */
    public function getFieldName()
    {
        return $this->fieldName;
    }

    /**
     * String - value of member attribute &lt;b&gt;fieldName&lt;/b&gt;.
     *
     * @param string $fieldName
     */
    public function setFieldName($fieldName)
    {
        $this->fieldName = $fieldName;
    }

    /**
     * Sets a known child element of VXMessage from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKey') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKey = $child;
            $happened = true;
        }
        else if (($xml->localName == 'message') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->message = $child;
            $happened = true;
        }
        else if (($xml->localName == 'objectId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->objectId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'fieldName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->fieldName = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXMessage from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXMessage to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXMessage', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXMessage to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->rbKey) {
            $writer->startElementNs(null, 'rbKey', null);
            $writer->text($this->rbKey);
            $writer->endElement();
        }
        if ($this->message) {
            $writer->startElementNs(null, 'message', null);
            $writer->text($this->message);
            $writer->endElement();
        }
        if ($this->objectId) {
            $writer->startElementNs(null, 'objectId', null);
            $writer->text($this->objectId);
            $writer->endElement();
        }
        if ($this->fieldName) {
            $writer->startElementNs(null, 'fieldName', null);
            $writer->text($this->fieldName);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXLong extends \Org\Apache\Ranger\Common\View\ViewBaseBean
{

    /**
     * long - value of member attribute &lt;b&gt;value&lt;/b&gt;.
     *
     * @var integer
     */
    private $value;

    /**
     * Constructs a VXLong from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * long - value of member attribute &lt;b&gt;value&lt;/b&gt;.
     *
     * @return integer
     */
    public function getValue()
    {
        return $this->value;
    }

    /**
     * long - value of member attribute &lt;b&gt;value&lt;/b&gt;.
     *
     * @param integer $value
     */
    public function setValue($value)
    {
        $this->value = $value;
    }

    /**
     * Sets a known child element of VXLong from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'value') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->value = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXLong from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXLong to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXLong', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXLong to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->value) {
            $writer->startElementNs(null, 'value', null);
            $writer->text($this->value);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPasswordChange extends \Org\Apache\Ranger\Common\View\ViewBaseBean
{

    /**
     * Long - value of member attribute &lt;b&gt;id&lt;/b&gt;.
     *
     * @var integer
     */
    private $id;

    /**
     * String - value of member attribute &lt;b&gt;loginId&lt;/b&gt;.
     *
     * @var string
     */
    private $loginId;

    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @var string
     */
    private $emailAddress;

    /**
     * String - value of member attribute &lt;b&gt;resetCode&lt;/b&gt;.
     *
     * @var string
     */
    private $resetCode;

    /**
     * String - value of member attribute &lt;b&gt;oldPassword&lt;/b&gt;.
     *
     * @var string
     */
    private $oldPassword;

    /**
     * String - value of member attribute &lt;b&gt;updPassword&lt;/b&gt;.
     *
     * @var string
     */
    private $updPassword;

    /**
     * Constructs a VXPasswordChange from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * Long - value of member attribute &lt;b&gt;id&lt;/b&gt;.
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Long - value of member attribute &lt;b&gt;id&lt;/b&gt;.
     *
     * @param integer $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * String - value of member attribute &lt;b&gt;loginId&lt;/b&gt;.
     *
     * @return string
     */
    public function getLoginId()
    {
        return $this->loginId;
    }

    /**
     * String - value of member attribute &lt;b&gt;loginId&lt;/b&gt;.
     *
     * @param string $loginId
     */
    public function setLoginId($loginId)
    {
        $this->loginId = $loginId;
    }
    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @return string
     */
    public function getEmailAddress()
    {
        return $this->emailAddress;
    }

    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @param string $emailAddress
     */
    public function setEmailAddress($emailAddress)
    {
        $this->emailAddress = $emailAddress;
    }
    /**
     * String - value of member attribute &lt;b&gt;resetCode&lt;/b&gt;.
     *
     * @return string
     */
    public function getResetCode()
    {
        return $this->resetCode;
    }

    /**
     * String - value of member attribute &lt;b&gt;resetCode&lt;/b&gt;.
     *
     * @param string $resetCode
     */
    public function setResetCode($resetCode)
    {
        $this->resetCode = $resetCode;
    }
    /**
     * String - value of member attribute &lt;b&gt;oldPassword&lt;/b&gt;.
     *
     * @return string
     */
    public function getOldPassword()
    {
        return $this->oldPassword;
    }

    /**
     * String - value of member attribute &lt;b&gt;oldPassword&lt;/b&gt;.
     *
     * @param string $oldPassword
     */
    public function setOldPassword($oldPassword)
    {
        $this->oldPassword = $oldPassword;
    }
    /**
     * String - value of member attribute &lt;b&gt;updPassword&lt;/b&gt;.
     *
     * @return string
     */
    public function getUpdPassword()
    {
        return $this->updPassword;
    }

    /**
     * String - value of member attribute &lt;b&gt;updPassword&lt;/b&gt;.
     *
     * @param string $updPassword
     */
    public function setUpdPassword($updPassword)
    {
        $this->updPassword = $updPassword;
    }

    /**
     * Sets a known child element of VXPasswordChange from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'id') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->id = $child;
            $happened = true;
        }
        else if (($xml->localName == 'loginId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->loginId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'emailAddress') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->emailAddress = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resetCode') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resetCode = $child;
            $happened = true;
        }
        else if (($xml->localName == 'oldPassword') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->oldPassword = $child;
            $happened = true;
        }
        else if (($xml->localName == 'updPassword') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->updPassword = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPasswordChange from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPasswordChange to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPasswordChange', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPasswordChange to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->id) {
            $writer->startElementNs(null, 'id', null);
            $writer->text($this->id);
            $writer->endElement();
        }
        if ($this->loginId) {
            $writer->startElementNs(null, 'loginId', null);
            $writer->text($this->loginId);
            $writer->endElement();
        }
        if ($this->emailAddress) {
            $writer->startElementNs(null, 'emailAddress', null);
            $writer->text($this->emailAddress);
            $writer->endElement();
        }
        if ($this->resetCode) {
            $writer->startElementNs(null, 'resetCode', null);
            $writer->text($this->resetCode);
            $writer->endElement();
        }
        if ($this->oldPassword) {
            $writer->startElementNs(null, 'oldPassword', null);
            $writer->text($this->oldPassword);
            $writer->endElement();
        }
        if ($this->updPassword) {
            $writer->startElementNs(null, 'updPassword', null);
            $writer->text($this->updPassword);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerTag extends \Org\Apache\Ranger\Plugin\Model\RangerBaseModelObject
{

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $options;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerValiditySchedule[]
     */
    private $validityPeriods;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $attributes;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $owner;

    /**
     * Constructs a RangerTag from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getOptions()
    {
        return $this->options;
    }

    /**
     * (no documentation provided)
     *
     * @param array $options
     */
    public function setOptions($options)
    {
        $this->options = $options;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerValiditySchedule[]
     */
    public function getValidityPeriods()
    {
        return $this->validityPeriods;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerValiditySchedule[] $validityPeriods
     */
    public function setValidityPeriods($validityPeriods)
    {
        $this->validityPeriods = $validityPeriods;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getAttributes()
    {
        return $this->attributes;
    }

    /**
     * (no documentation provided)
     *
     * @param array $attributes
     */
    public function setAttributes($attributes)
    {
        $this->attributes = $attributes;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $owner
     */
    public function setOwner($owner)
    {
        $this->owner = $owner;
    }

    /**
     * Sets a known child element of RangerTag from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'options') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->options = $child;
            $happened = true;
        }
        else if (($xml->localName == 'validityPeriods') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerValiditySchedule($xml);
            if (!isset($this->validityPeriods)) {
                $this->validityPeriods = array();
            }
            array_push($this->validityPeriods, $child);
            $happened = true;
        }
        else if (($xml->localName == 'attributes') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->attributes = $child;
            $happened = true;
        }
        else if (($xml->localName == 'type') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->type = $child;
            $happened = true;
        }
        else if (($xml->localName == 'owner') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->owner = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerTag from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerTag to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerTag', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerTag to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->options) {
            $writer->startElementNs(null, 'options', null);
            $writer->text($this->options);
            $writer->endElement();
        }
        if ($this->validityPeriods) {
            foreach ($this->validityPeriods as $i => $x) {
                $writer->startElementNs(null, 'validityPeriods', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->attributes) {
            $writer->startElementNs(null, 'attributes', null);
            $writer->text($this->attributes);
            $writer->endElement();
        }
        if ($this->type) {
            $writer->startElementNs(null, 'type', null);
            $writer->text($this->type);
            $writer->endElement();
        }
        if ($this->owner) {
            $writer->startElementNs(null, 'owner', null);
            $writer->text($this->owner);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerTagResourceMap extends \Org\Apache\Ranger\Plugin\Model\RangerBaseModelObject
{

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $tagId;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $resourceId;

    /**
     * Constructs a RangerTagResourceMap from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTagId()
    {
        return $this->tagId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $tagId
     */
    public function setTagId($tagId)
    {
        $this->tagId = $tagId;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getResourceId()
    {
        return $this->resourceId;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $resourceId
     */
    public function setResourceId($resourceId)
    {
        $this->resourceId = $resourceId;
    }

    /**
     * Sets a known child element of RangerTagResourceMap from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'tagId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tagId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourceId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceId = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerTagResourceMap from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerTagResourceMap to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerTagResourceMap', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerTagResourceMap to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->tagId) {
            $writer->startElementNs(null, 'tagId', null);
            $writer->text($this->tagId);
            $writer->endElement();
        }
        if ($this->resourceId) {
            $writer->startElementNs(null, 'resourceId', null);
            $writer->text($this->resourceId);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerTagDef extends \Org\Apache\Ranger\Plugin\Model\RangerBaseModelObject
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerTagAttributeDef[]
     */
    private $attributeDefs;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $source;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * Constructs a RangerTagDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerTagAttributeDef[]
     */
    public function getAttributeDefs()
    {
        return $this->attributeDefs;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerTagAttributeDef[] $attributeDefs
     */
    public function setAttributeDefs($attributeDefs)
    {
        $this->attributeDefs = $attributeDefs;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSource()
    {
        return $this->source;
    }

    /**
     * (no documentation provided)
     *
     * @param string $source
     */
    public function setSource($source)
    {
        $this->source = $source;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * Sets a known child element of RangerTagDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'attributeDefs') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerTagAttributeDef($xml);
            if (!isset($this->attributeDefs)) {
                $this->attributeDefs = array();
            }
            array_push($this->attributeDefs, $child);
            $happened = true;
        }
        else if (($xml->localName == 'source') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->source = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerTagDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerTagDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerTagDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerTagDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->attributeDefs) {
            foreach ($this->attributeDefs as $i => $x) {
                $writer->startElementNs(null, 'attributeDefs', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->source) {
            $writer->startElementNs(null, 'source', null);
            $writer->text($this->source);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerRowFilterPolicyItem extends \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemRowFilterInfo
     */
    private $rowFilterInfo;

    /**
     * Constructs a RangerRowFilterPolicyItem from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemRowFilterInfo
     */
    public function getRowFilterInfo()
    {
        return $this->rowFilterInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemRowFilterInfo $rowFilterInfo
     */
    public function setRowFilterInfo($rowFilterInfo)
    {
        $this->rowFilterInfo = $rowFilterInfo;
    }

    /**
     * Sets a known child element of RangerRowFilterPolicyItem from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'rowFilterInfo') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemRowFilterInfo($xml);
            $this->rowFilterInfo = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerRowFilterPolicyItem from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerRowFilterPolicyItem to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerRowFilterPolicyItem', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerRowFilterPolicyItem to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->rowFilterInfo) {
            $writer->startElementNs(null, 'rowFilterInfo', null);
            $this->rowFilterInfo->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerService extends \Org\Apache\Ranger\Plugin\Model\RangerBaseModelObject
{

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $configs;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $tagVersion;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $policyVersion;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $type;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $tagService;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $policyUpdateTime;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $tagUpdateTime;

    /**
     * Constructs a RangerService from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getConfigs()
    {
        return $this->configs;
    }

    /**
     * (no documentation provided)
     *
     * @param array $configs
     */
    public function setConfigs($configs)
    {
        $this->configs = $configs;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTagVersion()
    {
        return $this->tagVersion;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $tagVersion
     */
    public function setTagVersion($tagVersion)
    {
        $this->tagVersion = $tagVersion;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getPolicyVersion()
    {
        return $this->policyVersion;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $policyVersion
     */
    public function setPolicyVersion($policyVersion)
    {
        $this->policyVersion = $policyVersion;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * (no documentation provided)
     *
     * @param string $type
     */
    public function setType($type)
    {
        $this->type = $type;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getTagService()
    {
        return $this->tagService;
    }

    /**
     * (no documentation provided)
     *
     * @param string $tagService
     */
    public function setTagService($tagService)
    {
        $this->tagService = $tagService;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getPolicyUpdateTime()
    {
        return $this->policyUpdateTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $policyUpdateTime
     */
    public function setPolicyUpdateTime($policyUpdateTime)
    {
        $this->policyUpdateTime = $policyUpdateTime;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTagUpdateTime()
    {
        return $this->tagUpdateTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $tagUpdateTime
     */
    public function setTagUpdateTime($tagUpdateTime)
    {
        $this->tagUpdateTime = $tagUpdateTime;
    }

    /**
     * Sets a known child element of RangerService from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'configs') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->configs = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'tagVersion') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tagVersion = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policyVersion') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyVersion = $child;
            $happened = true;
        }
        else if (($xml->localName == 'type') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->type = $child;
            $happened = true;
        }
        else if (($xml->localName == 'tagService') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tagService = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policyUpdateTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyUpdateTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'tagUpdateTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tagUpdateTime = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerService from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerService to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerService', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerService to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->configs) {
            $writer->startElementNs(null, 'configs', null);
            $writer->text($this->configs);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->tagVersion) {
            $writer->startElementNs(null, 'tagVersion', null);
            $writer->text($this->tagVersion);
            $writer->endElement();
        }
        if ($this->policyVersion) {
            $writer->startElementNs(null, 'policyVersion', null);
            $writer->text($this->policyVersion);
            $writer->endElement();
        }
        if ($this->type) {
            $writer->startElementNs(null, 'type', null);
            $writer->text($this->type);
            $writer->endElement();
        }
        if ($this->tagService) {
            $writer->startElementNs(null, 'tagService', null);
            $writer->text($this->tagService);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->policyUpdateTime) {
            $writer->startElementNs(null, 'policyUpdateTime', null);
            $writer->text($this->policyUpdateTime);
            $writer->endElement();
        }
        if ($this->tagUpdateTime) {
            $writer->startElementNs(null, 'tagUpdateTime', null);
            $writer->text($this->tagUpdateTime);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerServiceDef extends \Org\Apache\Ranger\Plugin\Model\RangerBaseModelObject
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicyConditionDef[]
     */
    private $policyConditions;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $label;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerDataMaskDef
     */
    private $dataMaskDef;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $options;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyLabel;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerContextEnricherDef[]
     */
    private $contextEnrichers;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerResourceDef[]
     */
    private $resources;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef[]
     */
    private $accessTypes;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerRowFilterDef
     */
    private $rowFilterDef;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerServiceConfigDef[]
     */
    private $configs;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerEnumDef[]
     */
    private $enums;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $rbKeyDescription;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $implClass;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * Constructs a RangerServiceDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicyConditionDef[]
     */
    public function getPolicyConditions()
    {
        return $this->policyConditions;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicyConditionDef[] $policyConditions
     */
    public function setPolicyConditions($policyConditions)
    {
        $this->policyConditions = $policyConditions;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLabel()
    {
        return $this->label;
    }

    /**
     * (no documentation provided)
     *
     * @param string $label
     */
    public function setLabel($label)
    {
        $this->label = $label;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerDataMaskDef
     */
    public function getDataMaskDef()
    {
        return $this->dataMaskDef;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerDataMaskDef $dataMaskDef
     */
    public function setDataMaskDef($dataMaskDef)
    {
        $this->dataMaskDef = $dataMaskDef;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getOptions()
    {
        return $this->options;
    }

    /**
     * (no documentation provided)
     *
     * @param array $options
     */
    public function setOptions($options)
    {
        $this->options = $options;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyLabel()
    {
        return $this->rbKeyLabel;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyLabel
     */
    public function setRbKeyLabel($rbKeyLabel)
    {
        $this->rbKeyLabel = $rbKeyLabel;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerContextEnricherDef[]
     */
    public function getContextEnrichers()
    {
        return $this->contextEnrichers;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerContextEnricherDef[] $contextEnrichers
     */
    public function setContextEnrichers($contextEnrichers)
    {
        $this->contextEnrichers = $contextEnrichers;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerResourceDef[]
     */
    public function getResources()
    {
        return $this->resources;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerResourceDef[] $resources
     */
    public function setResources($resources)
    {
        $this->resources = $resources;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef[]
     */
    public function getAccessTypes()
    {
        return $this->accessTypes;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef[] $accessTypes
     */
    public function setAccessTypes($accessTypes)
    {
        $this->accessTypes = $accessTypes;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerRowFilterDef
     */
    public function getRowFilterDef()
    {
        return $this->rowFilterDef;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerRowFilterDef $rowFilterDef
     */
    public function setRowFilterDef($rowFilterDef)
    {
        $this->rowFilterDef = $rowFilterDef;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerServiceConfigDef[]
     */
    public function getConfigs()
    {
        return $this->configs;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerServiceConfigDef[] $configs
     */
    public function setConfigs($configs)
    {
        $this->configs = $configs;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerEnumDef[]
     */
    public function getEnums()
    {
        return $this->enums;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerEnumDef[] $enums
     */
    public function setEnums($enums)
    {
        $this->enums = $enums;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getRbKeyDescription()
    {
        return $this->rbKeyDescription;
    }

    /**
     * (no documentation provided)
     *
     * @param string $rbKeyDescription
     */
    public function setRbKeyDescription($rbKeyDescription)
    {
        $this->rbKeyDescription = $rbKeyDescription;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getImplClass()
    {
        return $this->implClass;
    }

    /**
     * (no documentation provided)
     *
     * @param string $implClass
     */
    public function setImplClass($implClass)
    {
        $this->implClass = $implClass;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * Sets a known child element of RangerServiceDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'policyConditions') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicyConditionDef($xml);
            if (!isset($this->policyConditions)) {
                $this->policyConditions = array();
            }
            array_push($this->policyConditions, $child);
            $happened = true;
        }
        else if (($xml->localName == 'label') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->label = $child;
            $happened = true;
        }
        else if (($xml->localName == 'dataMaskDef') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerDataMaskDef($xml);
            $this->dataMaskDef = $child;
            $happened = true;
        }
        else if (($xml->localName == 'options') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->options = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyLabel') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyLabel = $child;
            $happened = true;
        }
        else if (($xml->localName == 'contextEnrichers') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerContextEnricherDef($xml);
            if (!isset($this->contextEnrichers)) {
                $this->contextEnrichers = array();
            }
            array_push($this->contextEnrichers, $child);
            $happened = true;
        }
        else if (($xml->localName == 'resources') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerResourceDef($xml);
            if (!isset($this->resources)) {
                $this->resources = array();
            }
            array_push($this->resources, $child);
            $happened = true;
        }
        else if (($xml->localName == 'accessTypes') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerAccessTypeDef($xml);
            if (!isset($this->accessTypes)) {
                $this->accessTypes = array();
            }
            array_push($this->accessTypes, $child);
            $happened = true;
        }
        else if (($xml->localName == 'rowFilterDef') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerRowFilterDef($xml);
            $this->rowFilterDef = $child;
            $happened = true;
        }
        else if (($xml->localName == 'configs') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerServiceConfigDef($xml);
            if (!isset($this->configs)) {
                $this->configs = array();
            }
            array_push($this->configs, $child);
            $happened = true;
        }
        else if (($xml->localName == 'enums') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerEnumDef($xml);
            if (!isset($this->enums)) {
                $this->enums = array();
            }
            array_push($this->enums, $child);
            $happened = true;
        }
        else if (($xml->localName == 'rbKeyDescription') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKeyDescription = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'implClass') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->implClass = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerServiceDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerServiceDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerServiceDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerServiceDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->policyConditions) {
            foreach ($this->policyConditions as $i => $x) {
                $writer->startElementNs(null, 'policyConditions', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->label) {
            $writer->startElementNs(null, 'label', null);
            $writer->text($this->label);
            $writer->endElement();
        }
        if ($this->dataMaskDef) {
            $writer->startElementNs(null, 'dataMaskDef', null);
            $this->dataMaskDef->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->options) {
            $writer->startElementNs(null, 'options', null);
            $writer->text($this->options);
            $writer->endElement();
        }
        if ($this->rbKeyLabel) {
            $writer->startElementNs(null, 'rbKeyLabel', null);
            $writer->text($this->rbKeyLabel);
            $writer->endElement();
        }
        if ($this->contextEnrichers) {
            foreach ($this->contextEnrichers as $i => $x) {
                $writer->startElementNs(null, 'contextEnrichers', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->resources) {
            foreach ($this->resources as $i => $x) {
                $writer->startElementNs(null, 'resources', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->accessTypes) {
            foreach ($this->accessTypes as $i => $x) {
                $writer->startElementNs(null, 'accessTypes', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->rowFilterDef) {
            $writer->startElementNs(null, 'rowFilterDef', null);
            $this->rowFilterDef->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->configs) {
            foreach ($this->configs as $i => $x) {
                $writer->startElementNs(null, 'configs', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->enums) {
            foreach ($this->enums as $i => $x) {
                $writer->startElementNs(null, 'enums', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->rbKeyDescription) {
            $writer->startElementNs(null, 'rbKeyDescription', null);
            $writer->text($this->rbKeyDescription);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->implClass) {
            $writer->startElementNs(null, 'implClass', null);
            $writer->text($this->implClass);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXResponse extends \Org\Apache\Ranger\Common\View\ViewBaseBean
{

    /**
     * int - value of member attribute &lt;b&gt;statusCode&lt;/b&gt;.
     *
     * @var integer
     */
    private $statusCode;

    /**
     * String - value of member attribute &lt;b&gt;msgDesc&lt;/b&gt;.
     *
     * @var string
     */
    private $msgDesc;

    /**
     * List&lt;VXMessage&gt; - value of member attribute &lt;b&gt;messageList&lt;/b&gt;.
     *
     * @var \Org\Apache\Ranger\View\VXMessage[]
     */
    private $messageList;

    /**
     * Constructs a VXResponse from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * int - value of member attribute &lt;b&gt;statusCode&lt;/b&gt;.
     *
     * @return integer
     */
    public function getStatusCode()
    {
        return $this->statusCode;
    }

    /**
     * int - value of member attribute &lt;b&gt;statusCode&lt;/b&gt;.
     *
     * @param integer $statusCode
     */
    public function setStatusCode($statusCode)
    {
        $this->statusCode = $statusCode;
    }
    /**
     * String - value of member attribute &lt;b&gt;msgDesc&lt;/b&gt;.
     *
     * @return string
     */
    public function getMsgDesc()
    {
        return $this->msgDesc;
    }

    /**
     * String - value of member attribute &lt;b&gt;msgDesc&lt;/b&gt;.
     *
     * @param string $msgDesc
     */
    public function setMsgDesc($msgDesc)
    {
        $this->msgDesc = $msgDesc;
    }
    /**
     * List&lt;VXMessage&gt; - value of member attribute &lt;b&gt;messageList&lt;/b&gt;.
     *
     * @return \Org\Apache\Ranger\View\VXMessage[]
     */
    public function getMessageList()
    {
        return $this->messageList;
    }

    /**
     * List&lt;VXMessage&gt; - value of member attribute &lt;b&gt;messageList&lt;/b&gt;.
     *
     * @param \Org\Apache\Ranger\View\VXMessage[] $messageList
     */
    public function setMessageList($messageList)
    {
        $this->messageList = $messageList;
    }

    /**
     * Sets a known child element of VXResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'statusCode') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->statusCode = $child;
            $happened = true;
        }
        else if (($xml->localName == 'msgDesc') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->msgDesc = $child;
            $happened = true;
        }
        else if (($xml->localName == 'messageList') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXMessage($xml);
            if (!isset($this->messageList)) {
                $this->messageList = array();
            }
            array_push($this->messageList, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXResponse from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXResponse to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXResponse', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXResponse to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->statusCode) {
            $writer->startElementNs(null, 'statusCode', null);
            $writer->text($this->statusCode);
            $writer->endElement();
        }
        if ($this->msgDesc) {
            $writer->startElementNs(null, 'msgDesc', null);
            $writer->text($this->msgDesc);
            $writer->endElement();
        }
        if ($this->messageList) {
            foreach ($this->messageList as $i => $x) {
                $writer->startElementNs(null, 'messageList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXString extends \Org\Apache\Ranger\Common\View\ViewBaseBean
{

    /**
     * String - value of member attribute &lt;b&gt;value&lt;/b&gt;.
     *
     * @var string
     */
    private $value;

    /**
     * Constructs a VXString from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;value&lt;/b&gt;.
     *
     * @return string
     */
    public function getValue()
    {
        return $this->value;
    }

    /**
     * String - value of member attribute &lt;b&gt;value&lt;/b&gt;.
     *
     * @param string $value
     */
    public function setValue($value)
    {
        $this->value = $value;
    }

    /**
     * Sets a known child element of VXString from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'value') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->value = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXString from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXString to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXString', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXString to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->value) {
            $writer->startElementNs(null, 'value', null);
            $writer->text($this->value);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerSecurityZone extends \Org\Apache\Ranger\Plugin\Model\RangerBaseModelObject
{

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $auditUserGroups;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $adminUsers;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $adminUserGroups;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $auditUsers;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $services;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * Constructs a RangerSecurityZone from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getAuditUserGroups()
    {
        return $this->auditUserGroups;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $auditUserGroups
     */
    public function setAuditUserGroups($auditUserGroups)
    {
        $this->auditUserGroups = $auditUserGroups;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getAdminUsers()
    {
        return $this->adminUsers;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $adminUsers
     */
    public function setAdminUsers($adminUsers)
    {
        $this->adminUsers = $adminUsers;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getAdminUserGroups()
    {
        return $this->adminUserGroups;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $adminUserGroups
     */
    public function setAdminUserGroups($adminUserGroups)
    {
        $this->adminUserGroups = $adminUserGroups;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getAuditUsers()
    {
        return $this->auditUsers;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $auditUsers
     */
    public function setAuditUsers($auditUsers)
    {
        $this->auditUsers = $auditUsers;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getServices()
    {
        return $this->services;
    }

    /**
     * (no documentation provided)
     *
     * @param array $services
     */
    public function setServices($services)
    {
        $this->services = $services;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * Sets a known child element of RangerSecurityZone from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'auditUserGroups') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->auditUserGroups)) {
                $this->auditUserGroups = array();
            }
            array_push($this->auditUserGroups, $child);
            $happened = true;
        }
        else if (($xml->localName == 'adminUsers') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->adminUsers)) {
                $this->adminUsers = array();
            }
            array_push($this->adminUsers, $child);
            $happened = true;
        }
        else if (($xml->localName == 'adminUserGroups') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->adminUserGroups)) {
                $this->adminUserGroups = array();
            }
            array_push($this->adminUserGroups, $child);
            $happened = true;
        }
        else if (($xml->localName == 'auditUsers') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->auditUsers)) {
                $this->auditUsers = array();
            }
            array_push($this->auditUsers, $child);
            $happened = true;
        }
        else if (($xml->localName == 'services') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->services = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerSecurityZone from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerSecurityZone to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerSecurityZone', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerSecurityZone to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->auditUserGroups) {
            foreach ($this->auditUserGroups as $i => $x) {
                $writer->startElementNs(null, 'auditUserGroups', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->adminUsers) {
            foreach ($this->adminUsers as $i => $x) {
                $writer->startElementNs(null, 'adminUsers', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->adminUserGroups) {
            foreach ($this->adminUserGroups as $i => $x) {
                $writer->startElementNs(null, 'adminUserGroups', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->auditUsers) {
            foreach ($this->auditUsers as $i => $x) {
                $writer->startElementNs(null, 'auditUsers', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->services) {
            $writer->startElementNs(null, 'services', null);
            $writer->text($this->services);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerPolicy extends \Org\Apache\Ranger\Plugin\Model\RangerBaseModelObject
{

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $policyType;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $options;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $serviceType;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $service;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $isAuditEnabled;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $resources;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[]
     */
    private $policyItems;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $policyPriority;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[]
     */
    private $denyPolicyItems;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[]
     */
    private $allowExceptions;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerDataMaskPolicyItem[]
     */
    private $dataMaskPolicyItems;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $resourceSignature;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $description;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerRowFilterPolicyItem[]
     */
    private $rowFilterPolicyItems;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[]
     */
    private $denyExceptions;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $zoneName;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $policyLabels;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerValiditySchedule[]
     */
    private $validitySchedules;

    /**
     * Constructs a RangerPolicy from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getPolicyType()
    {
        return $this->policyType;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $policyType
     */
    public function setPolicyType($policyType)
    {
        $this->policyType = $policyType;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getOptions()
    {
        return $this->options;
    }

    /**
     * (no documentation provided)
     *
     * @param array $options
     */
    public function setOptions($options)
    {
        $this->options = $options;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getServiceType()
    {
        return $this->serviceType;
    }

    /**
     * (no documentation provided)
     *
     * @param string $serviceType
     */
    public function setServiceType($serviceType)
    {
        $this->serviceType = $serviceType;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getService()
    {
        return $this->service;
    }

    /**
     * (no documentation provided)
     *
     * @param string $service
     */
    public function setService($service)
    {
        $this->service = $service;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getIsAuditEnabled()
    {
        return $this->isAuditEnabled;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $isAuditEnabled
     */
    public function setIsAuditEnabled($isAuditEnabled)
    {
        $this->isAuditEnabled = $isAuditEnabled;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getResources()
    {
        return $this->resources;
    }

    /**
     * (no documentation provided)
     *
     * @param array $resources
     */
    public function setResources($resources)
    {
        $this->resources = $resources;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[]
     */
    public function getPolicyItems()
    {
        return $this->policyItems;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[] $policyItems
     */
    public function setPolicyItems($policyItems)
    {
        $this->policyItems = $policyItems;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getPolicyPriority()
    {
        return $this->policyPriority;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $policyPriority
     */
    public function setPolicyPriority($policyPriority)
    {
        $this->policyPriority = $policyPriority;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[]
     */
    public function getDenyPolicyItems()
    {
        return $this->denyPolicyItems;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[] $denyPolicyItems
     */
    public function setDenyPolicyItems($denyPolicyItems)
    {
        $this->denyPolicyItems = $denyPolicyItems;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[]
     */
    public function getAllowExceptions()
    {
        return $this->allowExceptions;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[] $allowExceptions
     */
    public function setAllowExceptions($allowExceptions)
    {
        $this->allowExceptions = $allowExceptions;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerDataMaskPolicyItem[]
     */
    public function getDataMaskPolicyItems()
    {
        return $this->dataMaskPolicyItems;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerDataMaskPolicyItem[] $dataMaskPolicyItems
     */
    public function setDataMaskPolicyItems($dataMaskPolicyItems)
    {
        $this->dataMaskPolicyItems = $dataMaskPolicyItems;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getResourceSignature()
    {
        return $this->resourceSignature;
    }

    /**
     * (no documentation provided)
     *
     * @param string $resourceSignature
     */
    public function setResourceSignature($resourceSignature)
    {
        $this->resourceSignature = $resourceSignature;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * (no documentation provided)
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * (no documentation provided)
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerRowFilterPolicyItem[]
     */
    public function getRowFilterPolicyItems()
    {
        return $this->rowFilterPolicyItems;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerRowFilterPolicyItem[] $rowFilterPolicyItems
     */
    public function setRowFilterPolicyItems($rowFilterPolicyItems)
    {
        $this->rowFilterPolicyItems = $rowFilterPolicyItems;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[]
     */
    public function getDenyExceptions()
    {
        return $this->denyExceptions;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem[] $denyExceptions
     */
    public function setDenyExceptions($denyExceptions)
    {
        $this->denyExceptions = $denyExceptions;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getZoneName()
    {
        return $this->zoneName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $zoneName
     */
    public function setZoneName($zoneName)
    {
        $this->zoneName = $zoneName;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getPolicyLabels()
    {
        return $this->policyLabels;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $policyLabels
     */
    public function setPolicyLabels($policyLabels)
    {
        $this->policyLabels = $policyLabels;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerValiditySchedule[]
     */
    public function getValiditySchedules()
    {
        return $this->validitySchedules;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerValiditySchedule[] $validitySchedules
     */
    public function setValiditySchedules($validitySchedules)
    {
        $this->validitySchedules = $validitySchedules;
    }

    /**
     * Sets a known child element of RangerPolicy from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'policyType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'options') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->options = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serviceType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->serviceType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'service') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->service = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isAuditEnabled') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isAuditEnabled = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resources') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resources = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policyItems') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem($xml);
            if (!isset($this->policyItems)) {
                $this->policyItems = array();
            }
            array_push($this->policyItems, $child);
            $happened = true;
        }
        else if (($xml->localName == 'policyPriority') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyPriority = $child;
            $happened = true;
        }
        else if (($xml->localName == 'denyPolicyItems') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem($xml);
            if (!isset($this->denyPolicyItems)) {
                $this->denyPolicyItems = array();
            }
            array_push($this->denyPolicyItems, $child);
            $happened = true;
        }
        else if (($xml->localName == 'allowExceptions') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem($xml);
            if (!isset($this->allowExceptions)) {
                $this->allowExceptions = array();
            }
            array_push($this->allowExceptions, $child);
            $happened = true;
        }
        else if (($xml->localName == 'dataMaskPolicyItems') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerDataMaskPolicyItem($xml);
            if (!isset($this->dataMaskPolicyItems)) {
                $this->dataMaskPolicyItems = array();
            }
            array_push($this->dataMaskPolicyItems, $child);
            $happened = true;
        }
        else if (($xml->localName == 'resourceSignature') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceSignature = $child;
            $happened = true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rowFilterPolicyItems') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerRowFilterPolicyItem($xml);
            if (!isset($this->rowFilterPolicyItems)) {
                $this->rowFilterPolicyItems = array();
            }
            array_push($this->rowFilterPolicyItems, $child);
            $happened = true;
        }
        else if (($xml->localName == 'denyExceptions') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem($xml);
            if (!isset($this->denyExceptions)) {
                $this->denyExceptions = array();
            }
            array_push($this->denyExceptions, $child);
            $happened = true;
        }
        else if (($xml->localName == 'zoneName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->zoneName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policyLabels') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->policyLabels)) {
                $this->policyLabels = array();
            }
            array_push($this->policyLabels, $child);
            $happened = true;
        }
        else if (($xml->localName == 'validitySchedules') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerValiditySchedule($xml);
            if (!isset($this->validitySchedules)) {
                $this->validitySchedules = array();
            }
            array_push($this->validitySchedules, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPolicy from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerPolicy to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPolicy', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPolicy to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->policyType) {
            $writer->startElementNs(null, 'policyType', null);
            $writer->text($this->policyType);
            $writer->endElement();
        }
        if ($this->options) {
            $writer->startElementNs(null, 'options', null);
            $writer->text($this->options);
            $writer->endElement();
        }
        if ($this->serviceType) {
            $writer->startElementNs(null, 'serviceType', null);
            $writer->text($this->serviceType);
            $writer->endElement();
        }
        if ($this->service) {
            $writer->startElementNs(null, 'service', null);
            $writer->text($this->service);
            $writer->endElement();
        }
        if ($this->isAuditEnabled) {
            $writer->startElementNs(null, 'isAuditEnabled', null);
            $writer->text($this->isAuditEnabled);
            $writer->endElement();
        }
        if ($this->resources) {
            $writer->startElementNs(null, 'resources', null);
            $writer->text($this->resources);
            $writer->endElement();
        }
        if ($this->policyItems) {
            foreach ($this->policyItems as $i => $x) {
                $writer->startElementNs(null, 'policyItems', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->policyPriority) {
            $writer->startElementNs(null, 'policyPriority', null);
            $writer->text($this->policyPriority);
            $writer->endElement();
        }
        if ($this->denyPolicyItems) {
            foreach ($this->denyPolicyItems as $i => $x) {
                $writer->startElementNs(null, 'denyPolicyItems', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->allowExceptions) {
            foreach ($this->allowExceptions as $i => $x) {
                $writer->startElementNs(null, 'allowExceptions', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->dataMaskPolicyItems) {
            foreach ($this->dataMaskPolicyItems as $i => $x) {
                $writer->startElementNs(null, 'dataMaskPolicyItems', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->resourceSignature) {
            $writer->startElementNs(null, 'resourceSignature', null);
            $writer->text($this->resourceSignature);
            $writer->endElement();
        }
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->rowFilterPolicyItems) {
            foreach ($this->rowFilterPolicyItems as $i => $x) {
                $writer->startElementNs(null, 'rowFilterPolicyItems', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->denyExceptions) {
            foreach ($this->denyExceptions as $i => $x) {
                $writer->startElementNs(null, 'denyExceptions', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->zoneName) {
            $writer->startElementNs(null, 'zoneName', null);
            $writer->text($this->zoneName);
            $writer->endElement();
        }
        if ($this->policyLabels) {
            foreach ($this->policyLabels as $i => $x) {
                $writer->startElementNs(null, 'policyLabels', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->validitySchedules) {
            foreach ($this->validitySchedules as $i => $x) {
                $writer->startElementNs(null, 'validitySchedules', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\Plugin\Model;

/**
 * (no documentation provided)
 */
class RangerDataMaskPolicyItem extends \Org\Apache\Ranger\Plugin\Model\RangerPolicyItem
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemDataMaskInfo
     */
    private $dataMaskInfo;

    /**
     * Constructs a RangerDataMaskPolicyItem from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemDataMaskInfo
     */
    public function getDataMaskInfo()
    {
        return $this->dataMaskInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemDataMaskInfo $dataMaskInfo
     */
    public function setDataMaskInfo($dataMaskInfo)
    {
        $this->dataMaskInfo = $dataMaskInfo;
    }

    /**
     * Sets a known child element of RangerDataMaskPolicyItem from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'dataMaskInfo') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicyItemDataMaskInfo($xml);
            $this->dataMaskInfo = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerDataMaskPolicyItem from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerDataMaskPolicyItem to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerDataMaskPolicyItem', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerDataMaskPolicyItem to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->dataMaskInfo) {
            $writer->startElementNs(null, 'dataMaskInfo', null);
            $this->dataMaskInfo->writeXmlContents($writer);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Common\View;

/**
 * (no documentation provided)
 */
class VList extends \Org\Apache\Ranger\Common\View\ViewBaseBean
{

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $startIndex;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $pageSize;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $totalCount;

    /**
     * int - value of member attribute &lt;b&gt;resultSize&lt;/b&gt;.
     *
     * @var integer
     */
    private $resultSize;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $sortType;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $sortBy;

    /**
     * Constructs a VList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getStartIndex()
    {
        return $this->startIndex;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $startIndex
     */
    public function setStartIndex($startIndex)
    {
        $this->startIndex = $startIndex;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getPageSize()
    {
        return $this->pageSize;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $pageSize
     */
    public function setPageSize($pageSize)
    {
        $this->pageSize = $pageSize;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getTotalCount()
    {
        return $this->totalCount;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $totalCount
     */
    public function setTotalCount($totalCount)
    {
        $this->totalCount = $totalCount;
    }
    /**
     * int - value of member attribute &lt;b&gt;resultSize&lt;/b&gt;.
     *
     * @return integer
     */
    public function getResultSize()
    {
        return $this->resultSize;
    }

    /**
     * int - value of member attribute &lt;b&gt;resultSize&lt;/b&gt;.
     *
     * @param integer $resultSize
     */
    public function setResultSize($resultSize)
    {
        $this->resultSize = $resultSize;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSortType()
    {
        return $this->sortType;
    }

    /**
     * (no documentation provided)
     *
     * @param string $sortType
     */
    public function setSortType($sortType)
    {
        $this->sortType = $sortType;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSortBy()
    {
        return $this->sortBy;
    }

    /**
     * (no documentation provided)
     *
     * @param string $sortBy
     */
    public function setSortBy($sortBy)
    {
        $this->sortBy = $sortBy;
    }

    /**
     * Sets a known child element of VList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'startIndex') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->startIndex = $child;
            $happened = true;
        }
        else if (($xml->localName == 'pageSize') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->pageSize = $child;
            $happened = true;
        }
        else if (($xml->localName == 'totalCount') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->totalCount = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resultSize') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resultSize = $child;
            $happened = true;
        }
        else if (($xml->localName == 'sortType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->sortType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'sortBy') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->sortBy = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->startIndex) {
            $writer->startElementNs(null, 'startIndex', null);
            $writer->text($this->startIndex);
            $writer->endElement();
        }
        if ($this->pageSize) {
            $writer->startElementNs(null, 'pageSize', null);
            $writer->text($this->pageSize);
            $writer->endElement();
        }
        if ($this->totalCount) {
            $writer->startElementNs(null, 'totalCount', null);
            $writer->text($this->totalCount);
            $writer->endElement();
        }
        if ($this->resultSize) {
            $writer->startElementNs(null, 'resultSize', null);
            $writer->text($this->resultSize);
            $writer->endElement();
        }
        if ($this->sortType) {
            $writer->startElementNs(null, 'sortType', null);
            $writer->text($this->sortType);
            $writer->endElement();
        }
        if ($this->sortBy) {
            $writer->startElementNs(null, 'sortBy', null);
            $writer->text($this->sortBy);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Common\View;

/**
 * (no documentation provided)
 */
class VEnumElement extends \Org\Apache\Ranger\Common\View\ViewBaseBean
{

    /**
     * the elementName
     *
     * @var string
     */
    private $elementName;

    /**
     * the enumName
     *
     * @var string
     */
    private $enumName;

    /**
     * the rbKey
     *
     * @var string
     */
    private $rbKey;

    /**
     * int - value of member attribute &lt;b&gt;elementValue&lt;/b&gt;.
     *
     * @var integer
     */
    private $elementValue;

    /**
     * String - value of member attribute &lt;b&gt;elementLabel&lt;/b&gt;.
     *
     * @var string
     */
    private $elementLabel;

    /**
     * Constructs a VEnumElement from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * the elementName
     *
     * @return string
     */
    public function getElementName()
    {
        return $this->elementName;
    }

    /**
     * the elementName
     *
     * @param string $elementName
     */
    public function setElementName($elementName)
    {
        $this->elementName = $elementName;
    }
    /**
     * the enumName
     *
     * @return string
     */
    public function getEnumName()
    {
        return $this->enumName;
    }

    /**
     * the enumName
     *
     * @param string $enumName
     */
    public function setEnumName($enumName)
    {
        $this->enumName = $enumName;
    }
    /**
     * the rbKey
     *
     * @return string
     */
    public function getRbKey()
    {
        return $this->rbKey;
    }

    /**
     * the rbKey
     *
     * @param string $rbKey
     */
    public function setRbKey($rbKey)
    {
        $this->rbKey = $rbKey;
    }
    /**
     * int - value of member attribute &lt;b&gt;elementValue&lt;/b&gt;.
     *
     * @return integer
     */
    public function getElementValue()
    {
        return $this->elementValue;
    }

    /**
     * int - value of member attribute &lt;b&gt;elementValue&lt;/b&gt;.
     *
     * @param integer $elementValue
     */
    public function setElementValue($elementValue)
    {
        $this->elementValue = $elementValue;
    }
    /**
     * String - value of member attribute &lt;b&gt;elementLabel&lt;/b&gt;.
     *
     * @return string
     */
    public function getElementLabel()
    {
        return $this->elementLabel;
    }

    /**
     * String - value of member attribute &lt;b&gt;elementLabel&lt;/b&gt;.
     *
     * @param string $elementLabel
     */
    public function setElementLabel($elementLabel)
    {
        $this->elementLabel = $elementLabel;
    }

    /**
     * Sets a known child element of VEnumElement from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'elementName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->elementName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'enumName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->enumName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'rbKey') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->rbKey = $child;
            $happened = true;
        }
        else if (($xml->localName == 'elementValue') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->elementValue = $child;
            $happened = true;
        }
        else if (($xml->localName == 'elementLabel') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->elementLabel = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VEnumElement from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VEnumElement to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VEnumElement', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VEnumElement to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->elementName) {
            $writer->startElementNs(null, 'elementName', null);
            $writer->text($this->elementName);
            $writer->endElement();
        }
        if ($this->enumName) {
            $writer->startElementNs(null, 'enumName', null);
            $writer->text($this->enumName);
            $writer->endElement();
        }
        if ($this->rbKey) {
            $writer->startElementNs(null, 'rbKey', null);
            $writer->text($this->rbKey);
            $writer->endElement();
        }
        if ($this->elementValue) {
            $writer->startElementNs(null, 'elementValue', null);
            $writer->text($this->elementValue);
            $writer->endElement();
        }
        if ($this->elementLabel) {
            $writer->startElementNs(null, 'elementLabel', null);
            $writer->text($this->elementLabel);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXDataObject extends \Org\Apache\Ranger\Common\View\ViewBaseBean
{

    /**
     * Long - value of member attribute &lt;b&gt;id&lt;/b&gt;.
     *
     * @var integer
     */
    private $id;

    /**
     * Date - value of member attribute &lt;b&gt;createDate&lt;/b&gt;.
     *
     * @var integer
     */
    private $createDate;

    /**
     * Date - value of member attribute &lt;b&gt;updateDate&lt;/b&gt;.
     *
     * @var integer
     */
    private $updateDate;

    /**
     * String - value of member attribute &lt;b&gt;owner&lt;/b&gt;.
     *
     * @var string
     */
    private $owner;

    /**
     * String - value of member attribute &lt;b&gt;updatedBy&lt;/b&gt;.
     *
     * @var string
     */
    private $updatedBy;

    /**
     * Constructs a VXDataObject from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * Long - value of member attribute &lt;b&gt;id&lt;/b&gt;.
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Long - value of member attribute &lt;b&gt;id&lt;/b&gt;.
     *
     * @param integer $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }
    /**
     * Date - value of member attribute &lt;b&gt;createDate&lt;/b&gt;.
     *
     * @return integer
     */
    public function getCreateDate()
    {
        return $this->createDate;
    }

    /**
     * Date - value of member attribute &lt;b&gt;createDate&lt;/b&gt;.
     *
     * @param integer $createDate
     */
    public function setCreateDate($createDate)
    {
        $this->createDate = $createDate;
    }
    /**
     * Date - value of member attribute &lt;b&gt;updateDate&lt;/b&gt;.
     *
     * @return integer
     */
    public function getUpdateDate()
    {
        return $this->updateDate;
    }

    /**
     * Date - value of member attribute &lt;b&gt;updateDate&lt;/b&gt;.
     *
     * @param integer $updateDate
     */
    public function setUpdateDate($updateDate)
    {
        $this->updateDate = $updateDate;
    }
    /**
     * String - value of member attribute &lt;b&gt;owner&lt;/b&gt;.
     *
     * @return string
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * String - value of member attribute &lt;b&gt;owner&lt;/b&gt;.
     *
     * @param string $owner
     */
    public function setOwner($owner)
    {
        $this->owner = $owner;
    }
    /**
     * String - value of member attribute &lt;b&gt;updatedBy&lt;/b&gt;.
     *
     * @return string
     */
    public function getUpdatedBy()
    {
        return $this->updatedBy;
    }

    /**
     * String - value of member attribute &lt;b&gt;updatedBy&lt;/b&gt;.
     *
     * @param string $updatedBy
     */
    public function setUpdatedBy($updatedBy)
    {
        $this->updatedBy = $updatedBy;
    }

    /**
     * Sets a known child element of VXDataObject from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'id') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->id = $child;
            $happened = true;
        }
        else if (($xml->localName == 'createDate') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->createDate = $child;
            $happened = true;
        }
        else if (($xml->localName == 'updateDate') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->updateDate = $child;
            $happened = true;
        }
        else if (($xml->localName == 'owner') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->owner = $child;
            $happened = true;
        }
        else if (($xml->localName == 'updatedBy') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->updatedBy = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXDataObject from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXDataObject to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXDataObject', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXDataObject to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->id) {
            $writer->startElementNs(null, 'id', null);
            $writer->text($this->id);
            $writer->endElement();
        }
        if ($this->createDate) {
            $writer->startElementNs(null, 'createDate', null);
            $writer->text($this->createDate);
            $writer->endElement();
        }
        if ($this->updateDate) {
            $writer->startElementNs(null, 'updateDate', null);
            $writer->text($this->updateDate);
            $writer->endElement();
        }
        if ($this->owner) {
            $writer->startElementNs(null, 'owner', null);
            $writer->text($this->owner);
            $writer->endElement();
        }
        if ($this->updatedBy) {
            $writer->startElementNs(null, 'updatedBy', null);
            $writer->text($this->updatedBy);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\Common\View;

/**
 * (no documentation provided)
 */
class VEnum extends \Org\Apache\Ranger\Common\View\ViewBaseBean
{

    /**
     * String - value of member attribute &lt;b&gt;enumName&lt;/b&gt;.
     *
     * @var string
     */
    private $enumName;

    /**
     * List&lt;VEnumElement&gt; - value of member attribute
     * &lt;b&gt;elementList&lt;/b&gt;.
     *
     * @var \Org\Apache\Ranger\Common\View\VEnumElement[]
     */
    private $elementList;

    /**
     * Constructs a VEnum from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;enumName&lt;/b&gt;.
     *
     * @return string
     */
    public function getEnumName()
    {
        return $this->enumName;
    }

    /**
     * String - value of member attribute &lt;b&gt;enumName&lt;/b&gt;.
     *
     * @param string $enumName
     */
    public function setEnumName($enumName)
    {
        $this->enumName = $enumName;
    }
    /**
     * List&lt;VEnumElement&gt; - value of member attribute
       * &lt;b&gt;elementList&lt;/b&gt;.
     *
     * @return \Org\Apache\Ranger\Common\View\VEnumElement[]
     */
    public function getElementList()
    {
        return $this->elementList;
    }

    /**
     * List&lt;VEnumElement&gt; - value of member attribute
       * &lt;b&gt;elementList&lt;/b&gt;.
     *
     * @param \Org\Apache\Ranger\Common\View\VEnumElement[] $elementList
     */
    public function setElementList($elementList)
    {
        $this->elementList = $elementList;
    }

    /**
     * Sets a known child element of VEnum from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'enumName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->enumName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'elementList') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Common\View\VEnumElement($xml);
            if (!isset($this->elementList)) {
                $this->elementList = array();
            }
            array_push($this->elementList, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VEnum from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VEnum to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VEnum', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VEnum to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->enumName) {
            $writer->startElementNs(null, 'enumName', null);
            $writer->text($this->enumName);
            $writer->endElement();
        }
        if ($this->elementList) {
            foreach ($this->elementList as $i => $x) {
                $writer->startElementNs(null, 'elementList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXGroupGroupList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXGroupGroup[]
     */
    private $vXGroupGroups;

    /**
     * Constructs a VXGroupGroupList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXGroupGroup[]
     */
    public function getVXGroupGroups()
    {
        return $this->vXGroupGroups;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXGroupGroup[] $vXGroupGroups
     */
    public function setVXGroupGroups($vXGroupGroups)
    {
        $this->vXGroupGroups = $vXGroupGroups;
    }

    /**
     * Sets a known child element of VXGroupGroupList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXGroupGroups') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXGroupGroup($xml);
            if (!isset($this->vXGroupGroups)) {
                $this->vXGroupGroups = array();
            }
            array_push($this->vXGroupGroups, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXGroupGroupList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXGroupGroupList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXGroupGroupList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXGroupGroupList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXGroupGroups) {
            foreach ($this->vXGroupGroups as $i => $x) {
                $writer->startElementNs(null, 'vXGroupGroups', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXGroupList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXGroup[]
     */
    private $vXGroups;

    /**
     * Constructs a VXGroupList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXGroup[]
     */
    public function getVXGroups()
    {
        return $this->vXGroups;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXGroup[] $vXGroups
     */
    public function setVXGroups($vXGroups)
    {
        $this->vXGroups = $vXGroups;
    }

    /**
     * Sets a known child element of VXGroupList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXGroups') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXGroup($xml);
            if (!isset($this->vXGroups)) {
                $this->vXGroups = array();
            }
            array_push($this->vXGroups, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXGroupList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXGroupList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXGroupList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXGroupList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXGroups) {
            foreach ($this->vXGroups as $i => $x) {
                $writer->startElementNs(null, 'vXGroups', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXGroupPermissionList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXGroupPermission[]
     */
    private $vXGroupPermission;

    /**
     * Constructs a VXGroupPermissionList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXGroupPermission[]
     */
    public function getVXGroupPermission()
    {
        return $this->vXGroupPermission;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXGroupPermission[] $vXGroupPermission
     */
    public function setVXGroupPermission($vXGroupPermission)
    {
        $this->vXGroupPermission = $vXGroupPermission;
    }

    /**
     * Sets a known child element of VXGroupPermissionList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXGroupPermission') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXGroupPermission($xml);
            if (!isset($this->vXGroupPermission)) {
                $this->vXGroupPermission = array();
            }
            array_push($this->vXGroupPermission, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXGroupPermissionList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXGroupPermissionList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXGroupPermissionList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXGroupPermissionList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXGroupPermission) {
            foreach ($this->vXGroupPermission as $i => $x) {
                $writer->startElementNs(null, 'vXGroupPermission', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXGroupUser extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @var string
     */
    private $name;

    /**
     * Long - value of member attribute &lt;b&gt;parentGroupId&lt;/b&gt;.
     *
     * @var integer
     */
    private $parentGroupId;

    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @var integer
     */
    private $userId;

    /**
     * Constructs a VXGroupUser from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * Long - value of member attribute &lt;b&gt;parentGroupId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getParentGroupId()
    {
        return $this->parentGroupId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;parentGroupId&lt;/b&gt;.
     *
     * @param integer $parentGroupId
     */
    public function setParentGroupId($parentGroupId)
    {
        $this->parentGroupId = $parentGroupId;
    }
    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getUserId()
    {
        return $this->userId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @param integer $userId
     */
    public function setUserId($userId)
    {
        $this->userId = $userId;
    }

    /**
     * Sets a known child element of VXGroupUser from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'parentGroupId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->parentGroupId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userId = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXGroupUser from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXGroupUser to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXGroupUser', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXGroupUser to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->parentGroupId) {
            $writer->startElementNs(null, 'parentGroupId', null);
            $writer->text($this->parentGroupId);
            $writer->endElement();
        }
        if ($this->userId) {
            $writer->startElementNs(null, 'userId', null);
            $writer->text($this->userId);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXGroupUserInfo extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXGroup
     */
    private $xgroupInfo;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXUser[]
     */
    private $xuserInfo;

    /**
     * Constructs a VXGroupUserInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXGroup
     */
    public function getXgroupInfo()
    {
        return $this->xgroupInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXGroup $xgroupInfo
     */
    public function setXgroupInfo($xgroupInfo)
    {
        $this->xgroupInfo = $xgroupInfo;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXUser[]
     */
    public function getXuserInfo()
    {
        return $this->xuserInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXUser[] $xuserInfo
     */
    public function setXuserInfo($xuserInfo)
    {
        $this->xuserInfo = $xuserInfo;
    }

    /**
     * Sets a known child element of VXGroupUserInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'xgroupInfo') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXGroup($xml);
            $this->xgroupInfo = $child;
            $happened = true;
        }
        else if (($xml->localName == 'xuserInfo') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXUser($xml);
            if (!isset($this->xuserInfo)) {
                $this->xuserInfo = array();
            }
            array_push($this->xuserInfo, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXGroupUserInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXGroupUserInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXGroupUserInfo', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXGroupUserInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->xgroupInfo) {
            $writer->startElementNs(null, 'xgroupInfo', null);
            $this->xgroupInfo->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->xuserInfo) {
            foreach ($this->xuserInfo as $i => $x) {
                $writer->startElementNs(null, 'xuserInfo', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXKmsKey extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * the name
     *
     * @var string
     */
    private $name;

    /**
     * the cipher
     *
     * @var string
     */
    private $cipher;

    /**
     * the length
     *
     * @var integer
     */
    private $length;

    /**
     * the description
     *
     * @var string
     */
    private $description;

    /**
     * the version
     *
     * @var integer
     */
    private $versions;

    /**
     * the material
     *
     * @var string
     */
    private $material;

    /**
     * the versionName
     *
     * @var string
     */
    private $versionName;

    /**
     * the created
     *
     * @var integer
     */
    private $created;

    /**
     * the attributes
     *
     * @var array
     */
    private $attributes;

    /**
     * Constructs a VXKmsKey from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * the name
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * the name
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * the cipher
     *
     * @return string
     */
    public function getCipher()
    {
        return $this->cipher;
    }

    /**
     * the cipher
     *
     * @param string $cipher
     */
    public function setCipher($cipher)
    {
        $this->cipher = $cipher;
    }
    /**
     * the length
     *
     * @return integer
     */
    public function getLength()
    {
        return $this->length;
    }

    /**
     * the length
     *
     * @param integer $length
     */
    public function setLength($length)
    {
        $this->length = $length;
    }
    /**
     * the description
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * the description
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * the version
     *
     * @return integer
     */
    public function getVersions()
    {
        return $this->versions;
    }

    /**
     * the version
     *
     * @param integer $versions
     */
    public function setVersions($versions)
    {
        $this->versions = $versions;
    }
    /**
     * the material
     *
     * @return string
     */
    public function getMaterial()
    {
        return $this->material;
    }

    /**
     * the material
     *
     * @param string $material
     */
    public function setMaterial($material)
    {
        $this->material = $material;
    }
    /**
     * the versionName
     *
     * @return string
     */
    public function getVersionName()
    {
        return $this->versionName;
    }

    /**
     * the versionName
     *
     * @param string $versionName
     */
    public function setVersionName($versionName)
    {
        $this->versionName = $versionName;
    }
    /**
     * the created
     *
     * @return integer
     */
    public function getCreated()
    {
        return $this->created;
    }

    /**
     * the created
     *
     * @param integer $created
     */
    public function setCreated($created)
    {
        $this->created = $created;
    }
    /**
     * the attributes
     *
     * @return array
     */
    public function getAttributes()
    {
        return $this->attributes;
    }

    /**
     * the attributes
     *
     * @param array $attributes
     */
    public function setAttributes($attributes)
    {
        $this->attributes = $attributes;
    }

    /**
     * Sets a known child element of VXKmsKey from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'cipher') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->cipher = $child;
            $happened = true;
        }
        else if (($xml->localName == 'length') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->length = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'versions') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->versions = $child;
            $happened = true;
        }
        else if (($xml->localName == 'material') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->material = $child;
            $happened = true;
        }
        else if (($xml->localName == 'versionName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->versionName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'created') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->created = $child;
            $happened = true;
        }
        else if (($xml->localName == 'attributes') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->attributes = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXKmsKey from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXKmsKey to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXKmsKey', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXKmsKey to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->cipher) {
            $writer->startElementNs(null, 'cipher', null);
            $writer->text($this->cipher);
            $writer->endElement();
        }
        if ($this->length) {
            $writer->startElementNs(null, 'length', null);
            $writer->text($this->length);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->versions) {
            $writer->startElementNs(null, 'versions', null);
            $writer->text($this->versions);
            $writer->endElement();
        }
        if ($this->material) {
            $writer->startElementNs(null, 'material', null);
            $writer->text($this->material);
            $writer->endElement();
        }
        if ($this->versionName) {
            $writer->startElementNs(null, 'versionName', null);
            $writer->text($this->versionName);
            $writer->endElement();
        }
        if ($this->created) {
            $writer->startElementNs(null, 'created', null);
            $writer->text($this->created);
            $writer->endElement();
        }
        if ($this->attributes) {
            $writer->startElementNs(null, 'attributes', null);
            $writer->text($this->attributes);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXModuleDef extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * the userPermList
     *
     * @var \Org\Apache\Ranger\View\VXUserPermission[]
     */
    private $userPermList;

    /**
     * the groupPermList
     *
     * @var \Org\Apache\Ranger\View\VXGroupPermission[]
     */
    private $groupPermList;

    /**
     * the createTime
     *
     * @var integer
     */
    private $createTime;

    /**
     * the updateTime
     *
     * @var integer
     */
    private $updateTime;

    /**
     * the addedById
     *
     * @var integer
     */
    private $addedById;

    /**
     * the updatedById
     *
     * @var integer
     */
    private $updatedById;

    /**
     * the module
     *
     * @var string
     */
    private $module;

    /**
     * the url
     *
     * @var string
     */
    private $url;

    /**
     * Constructs a VXModuleDef from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * the userPermList
     *
     * @return \Org\Apache\Ranger\View\VXUserPermission[]
     */
    public function getUserPermList()
    {
        return $this->userPermList;
    }

    /**
     * the userPermList
     *
     * @param \Org\Apache\Ranger\View\VXUserPermission[] $userPermList
     */
    public function setUserPermList($userPermList)
    {
        $this->userPermList = $userPermList;
    }
    /**
     * the groupPermList
     *
     * @return \Org\Apache\Ranger\View\VXGroupPermission[]
     */
    public function getGroupPermList()
    {
        return $this->groupPermList;
    }

    /**
     * the groupPermList
     *
     * @param \Org\Apache\Ranger\View\VXGroupPermission[] $groupPermList
     */
    public function setGroupPermList($groupPermList)
    {
        $this->groupPermList = $groupPermList;
    }
    /**
     * the createTime
     *
     * @return integer
     */
    public function getCreateTime()
    {
        return $this->createTime;
    }

    /**
     * the createTime
     *
     * @param integer $createTime
     */
    public function setCreateTime($createTime)
    {
        $this->createTime = $createTime;
    }
    /**
     * the updateTime
     *
     * @return integer
     */
    public function getUpdateTime()
    {
        return $this->updateTime;
    }

    /**
     * the updateTime
     *
     * @param integer $updateTime
     */
    public function setUpdateTime($updateTime)
    {
        $this->updateTime = $updateTime;
    }
    /**
     * the addedById
     *
     * @return integer
     */
    public function getAddedById()
    {
        return $this->addedById;
    }

    /**
     * the addedById
     *
     * @param integer $addedById
     */
    public function setAddedById($addedById)
    {
        $this->addedById = $addedById;
    }
    /**
     * the updatedById
     *
     * @return integer
     */
    public function getUpdatedById()
    {
        return $this->updatedById;
    }

    /**
     * the updatedById
     *
     * @param integer $updatedById
     */
    public function setUpdatedById($updatedById)
    {
        $this->updatedById = $updatedById;
    }
    /**
     * the module
     *
     * @return string
     */
    public function getModule()
    {
        return $this->module;
    }

    /**
     * the module
     *
     * @param string $module
     */
    public function setModule($module)
    {
        $this->module = $module;
    }
    /**
     * the url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->url;
    }

    /**
     * the url
     *
     * @param string $url
     */
    public function setUrl($url)
    {
        $this->url = $url;
    }

    /**
     * Sets a known child element of VXModuleDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'userPermList') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXUserPermission($xml);
            if (!isset($this->userPermList)) {
                $this->userPermList = array();
            }
            array_push($this->userPermList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'groupPermList') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXGroupPermission($xml);
            if (!isset($this->groupPermList)) {
                $this->groupPermList = array();
            }
            array_push($this->groupPermList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'createTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->createTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'updateTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->updateTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'addedById') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->addedById = $child;
            $happened = true;
        }
        else if (($xml->localName == 'updatedById') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->updatedById = $child;
            $happened = true;
        }
        else if (($xml->localName == 'module') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->module = $child;
            $happened = true;
        }
        else if (($xml->localName == 'url') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->url = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXModuleDef from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXModuleDef to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXModuleDef', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXModuleDef to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->userPermList) {
            foreach ($this->userPermList as $i => $x) {
                $writer->startElementNs(null, 'userPermList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->groupPermList) {
            foreach ($this->groupPermList as $i => $x) {
                $writer->startElementNs(null, 'groupPermList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->createTime) {
            $writer->startElementNs(null, 'createTime', null);
            $writer->text($this->createTime);
            $writer->endElement();
        }
        if ($this->updateTime) {
            $writer->startElementNs(null, 'updateTime', null);
            $writer->text($this->updateTime);
            $writer->endElement();
        }
        if ($this->addedById) {
            $writer->startElementNs(null, 'addedById', null);
            $writer->text($this->addedById);
            $writer->endElement();
        }
        if ($this->updatedById) {
            $writer->startElementNs(null, 'updatedById', null);
            $writer->text($this->updatedById);
            $writer->endElement();
        }
        if ($this->module) {
            $writer->startElementNs(null, 'module', null);
            $writer->text($this->module);
            $writer->endElement();
        }
        if ($this->url) {
            $writer->startElementNs(null, 'url', null);
            $writer->text($this->url);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPermMap extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;permGroup&lt;/b&gt;.
     *
     * @var string
     */
    private $permGroup;

    /**
     * Long - value of member attribute &lt;b&gt;resourceId&lt;/b&gt;.
     *
     * @var integer
     */
    private $resourceId;

    /**
     * Long - value of member attribute &lt;b&gt;groupId&lt;/b&gt;.
     *
     * @var integer
     */
    private $groupId;

    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @var integer
     */
    private $userId;

    /**
     * int - value of member attribute &lt;b&gt;permFor&lt;/b&gt;.
     *
     * @var integer
     */
    private $permFor;

    /**
     * int - value of member attribute &lt;b&gt;permType&lt;/b&gt;.
     *
     * @var integer
     */
    private $permType;

    /**
     * boolean - value of member attribute &lt;b&gt;grantOrRevoke&lt;/b&gt;.
     *
     * @var boolean
     */
    private $grantOrRevoke;

    /**
     * String - value of member attribute &lt;b&gt;groupName&lt;/b&gt;.
     *
     * @var string
     */
    private $groupName;

    /**
     * String - value of member attribute &lt;b&gt;userName&lt;/b&gt;.
     *
     * @var string
     */
    private $userName;

    /**
     * int - value of member attribute &lt;b&gt;isRecursive&lt;/b&gt;.
     *
     * @var integer
     */
    private $isRecursive;

    /**
     * boolean - value of member attribute &lt;b&gt;isWildCard&lt;/b&gt;.
     *
     * @var boolean
     */
    private $isWildCard;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $ipAddress;

    /**
     * Constructs a VXPermMap from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;permGroup&lt;/b&gt;.
     *
     * @return string
     */
    public function getPermGroup()
    {
        return $this->permGroup;
    }

    /**
     * String - value of member attribute &lt;b&gt;permGroup&lt;/b&gt;.
     *
     * @param string $permGroup
     */
    public function setPermGroup($permGroup)
    {
        $this->permGroup = $permGroup;
    }
    /**
     * Long - value of member attribute &lt;b&gt;resourceId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getResourceId()
    {
        return $this->resourceId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;resourceId&lt;/b&gt;.
     *
     * @param integer $resourceId
     */
    public function setResourceId($resourceId)
    {
        $this->resourceId = $resourceId;
    }
    /**
     * Long - value of member attribute &lt;b&gt;groupId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getGroupId()
    {
        return $this->groupId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;groupId&lt;/b&gt;.
     *
     * @param integer $groupId
     */
    public function setGroupId($groupId)
    {
        $this->groupId = $groupId;
    }
    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getUserId()
    {
        return $this->userId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @param integer $userId
     */
    public function setUserId($userId)
    {
        $this->userId = $userId;
    }
    /**
     * int - value of member attribute &lt;b&gt;permFor&lt;/b&gt;.
     *
     * @return integer
     */
    public function getPermFor()
    {
        return $this->permFor;
    }

    /**
     * int - value of member attribute &lt;b&gt;permFor&lt;/b&gt;.
     *
     * @param integer $permFor
     */
    public function setPermFor($permFor)
    {
        $this->permFor = $permFor;
    }
    /**
     * int - value of member attribute &lt;b&gt;permType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getPermType()
    {
        return $this->permType;
    }

    /**
     * int - value of member attribute &lt;b&gt;permType&lt;/b&gt;.
     *
     * @param integer $permType
     */
    public function setPermType($permType)
    {
        $this->permType = $permType;
    }
    /**
     * boolean - value of member attribute &lt;b&gt;grantOrRevoke&lt;/b&gt;.
     *
     * @return boolean
     */
    public function getGrantOrRevoke()
    {
        return $this->grantOrRevoke;
    }

    /**
     * boolean - value of member attribute &lt;b&gt;grantOrRevoke&lt;/b&gt;.
     *
     * @param boolean $grantOrRevoke
     */
    public function setGrantOrRevoke($grantOrRevoke)
    {
        $this->grantOrRevoke = $grantOrRevoke;
    }
    /**
     * String - value of member attribute &lt;b&gt;groupName&lt;/b&gt;.
     *
     * @return string
     */
    public function getGroupName()
    {
        return $this->groupName;
    }

    /**
     * String - value of member attribute &lt;b&gt;groupName&lt;/b&gt;.
     *
     * @param string $groupName
     */
    public function setGroupName($groupName)
    {
        $this->groupName = $groupName;
    }
    /**
     * String - value of member attribute &lt;b&gt;userName&lt;/b&gt;.
     *
     * @return string
     */
    public function getUserName()
    {
        return $this->userName;
    }

    /**
     * String - value of member attribute &lt;b&gt;userName&lt;/b&gt;.
     *
     * @param string $userName
     */
    public function setUserName($userName)
    {
        $this->userName = $userName;
    }
    /**
     * int - value of member attribute &lt;b&gt;isRecursive&lt;/b&gt;.
     *
     * @return integer
     */
    public function getIsRecursive()
    {
        return $this->isRecursive;
    }

    /**
     * int - value of member attribute &lt;b&gt;isRecursive&lt;/b&gt;.
     *
     * @param integer $isRecursive
     */
    public function setIsRecursive($isRecursive)
    {
        $this->isRecursive = $isRecursive;
    }
    /**
     * boolean - value of member attribute &lt;b&gt;isWildCard&lt;/b&gt;.
     *
     * @return boolean
     */
    public function getIsWildCard()
    {
        return $this->isWildCard;
    }

    /**
     * boolean - value of member attribute &lt;b&gt;isWildCard&lt;/b&gt;.
     *
     * @param boolean $isWildCard
     */
    public function setIsWildCard($isWildCard)
    {
        $this->isWildCard = $isWildCard;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getIpAddress()
    {
        return $this->ipAddress;
    }

    /**
     * (no documentation provided)
     *
     * @param string $ipAddress
     */
    public function setIpAddress($ipAddress)
    {
        $this->ipAddress = $ipAddress;
    }

    /**
     * Sets a known child element of VXPermMap from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'permGroup') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->permGroup = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourceId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'permFor') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->permFor = $child;
            $happened = true;
        }
        else if (($xml->localName == 'permType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->permType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'grantOrRevoke') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->grantOrRevoke = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isRecursive') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isRecursive = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isWildCard') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isWildCard = $child;
            $happened = true;
        }
        else if (($xml->localName == 'ipAddress') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->ipAddress = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPermMap from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPermMap to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPermMap', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPermMap to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->permGroup) {
            $writer->startElementNs(null, 'permGroup', null);
            $writer->text($this->permGroup);
            $writer->endElement();
        }
        if ($this->resourceId) {
            $writer->startElementNs(null, 'resourceId', null);
            $writer->text($this->resourceId);
            $writer->endElement();
        }
        if ($this->groupId) {
            $writer->startElementNs(null, 'groupId', null);
            $writer->text($this->groupId);
            $writer->endElement();
        }
        if ($this->userId) {
            $writer->startElementNs(null, 'userId', null);
            $writer->text($this->userId);
            $writer->endElement();
        }
        if ($this->permFor) {
            $writer->startElementNs(null, 'permFor', null);
            $writer->text($this->permFor);
            $writer->endElement();
        }
        if ($this->permType) {
            $writer->startElementNs(null, 'permType', null);
            $writer->text($this->permType);
            $writer->endElement();
        }
        if ($this->grantOrRevoke) {
            $writer->startElementNs(null, 'grantOrRevoke', null);
            $writer->text($this->grantOrRevoke);
            $writer->endElement();
        }
        if ($this->groupName) {
            $writer->startElementNs(null, 'groupName', null);
            $writer->text($this->groupName);
            $writer->endElement();
        }
        if ($this->userName) {
            $writer->startElementNs(null, 'userName', null);
            $writer->text($this->userName);
            $writer->endElement();
        }
        if ($this->isRecursive) {
            $writer->startElementNs(null, 'isRecursive', null);
            $writer->text($this->isRecursive);
            $writer->endElement();
        }
        if ($this->isWildCard) {
            $writer->startElementNs(null, 'isWildCard', null);
            $writer->text($this->isWildCard);
            $writer->endElement();
        }
        if ($this->ipAddress) {
            $writer->startElementNs(null, 'ipAddress', null);
            $writer->text($this->ipAddress);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPermMapList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXPermMap[]
     */
    private $vXPermMaps;

    /**
     * Constructs a VXPermMapList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXPermMap[]
     */
    public function getVXPermMaps()
    {
        return $this->vXPermMaps;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXPermMap[] $vXPermMaps
     */
    public function setVXPermMaps($vXPermMaps)
    {
        $this->vXPermMaps = $vXPermMaps;
    }

    /**
     * Sets a known child element of VXPermMapList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXPermMaps') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXPermMap($xml);
            if (!isset($this->vXPermMaps)) {
                $this->vXPermMaps = array();
            }
            array_push($this->vXPermMaps, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPermMapList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPermMapList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPermMapList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPermMapList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXPermMaps) {
            foreach ($this->vXPermMaps as $i => $x) {
                $writer->startElementNs(null, 'vXPermMaps', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPolicy extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;policyName&lt;/b&gt;.
     *
     * @var string
     */
    private $policyName;

    /**
     * String - value of member attribute &lt;b&gt;resourceName&lt;/b&gt;.
     *
     * @var string
     */
    private $resourceName;

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @var string
     */
    private $description;

    /**
     * String - value of member attribute &lt;b&gt;repositoryName&lt;/b&gt;.
     *
     * @var string
     */
    private $repositoryName;

    /**
     * String - value of member attribute &lt;b&gt;repositoryType&lt;/b&gt;.
     *
     * @var string
     */
    private $repositoryType;

    /**
     * List&lt;VXPermObj&gt; - value of member attribute &lt;b&gt;permMapList&lt;/b&gt;.
     *
     * @var \Org\Apache\Ranger\View\VXPermObj[]
     */
    private $permMapList;

    /**
     * String - value of member attribute &lt;b&gt;tables&lt;/b&gt;.
     *
     * @var string
     */
    private $tables;

    /**
     * String - value of member attribute &lt;b&gt;columnFamilies&lt;/b&gt;.
     *
     * @var string
     */
    private $columnFamilies;

    /**
     * String - value of member attribute &lt;b&gt;columns&lt;/b&gt;.
     *
     * @var string
     */
    private $columns;

    /**
     * String - value of member attribute &lt;b&gt;databases&lt;/b&gt;.
     *
     * @var string
     */
    private $databases;

    /**
     * String - value of member attribute &lt;b&gt;udfs&lt;/b&gt;.
     *
     * @var string
     */
    private $udfs;

    /**
     * String - value of member attribute &lt;b&gt;tableType&lt;/b&gt;.
     *
     * @var string
     */
    private $tableType;

    /**
     * String - value of member attribute &lt;b&gt;columnType&lt;/b&gt;.
     *
     * @var string
     */
    private $columnType;

    /**
     * String - value of member attribute &lt;b&gt;topologies&lt;/b&gt;.
     *
     * @var string
     */
    private $topologies;

    /**
     * String - value of member attribute &lt;b&gt;services&lt;/b&gt;.
     *
     * @var string
     */
    private $services;

    /**
     * boolean - value of member attribute &lt;b&gt;isEnable&lt;/b&gt;.
     *
     * @var boolean
     */
    private $isEnabled;

    /**
     * boolean - value of member attribute &lt;b&gt;isRecursive&lt;/b&gt;.
     *
     * @var boolean
     */
    private $isRecursive;

    /**
     * boolean - value of member attribute &lt;b&gt;isAuditEnabled&lt;/b&gt;.
     *
     * @var boolean
     */
    private $isAuditEnabled;

    /**
     * String - value of member attribute &lt;b&gt;version&lt;/b&gt;.
     *
     * @var string
     */
    private $version;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $grantor;

    /**
     * (no documentation provided)
     *
     * @var boolean
     */
    private $replacePerm;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $policyLabel;

    /**
     * Constructs a VXPolicy from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;policyName&lt;/b&gt;.
     *
     * @return string
     */
    public function getPolicyName()
    {
        return $this->policyName;
    }

    /**
     * String - value of member attribute &lt;b&gt;policyName&lt;/b&gt;.
     *
     * @param string $policyName
     */
    public function setPolicyName($policyName)
    {
        $this->policyName = $policyName;
    }
    /**
     * String - value of member attribute &lt;b&gt;resourceName&lt;/b&gt;.
     *
     * @return string
     */
    public function getResourceName()
    {
        return $this->resourceName;
    }

    /**
     * String - value of member attribute &lt;b&gt;resourceName&lt;/b&gt;.
     *
     * @param string $resourceName
     */
    public function setResourceName($resourceName)
    {
        $this->resourceName = $resourceName;
    }
    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * String - value of member attribute &lt;b&gt;repositoryName&lt;/b&gt;.
     *
     * @return string
     */
    public function getRepositoryName()
    {
        return $this->repositoryName;
    }

    /**
     * String - value of member attribute &lt;b&gt;repositoryName&lt;/b&gt;.
     *
     * @param string $repositoryName
     */
    public function setRepositoryName($repositoryName)
    {
        $this->repositoryName = $repositoryName;
    }
    /**
     * String - value of member attribute &lt;b&gt;repositoryType&lt;/b&gt;.
     *
     * @return string
     */
    public function getRepositoryType()
    {
        return $this->repositoryType;
    }

    /**
     * String - value of member attribute &lt;b&gt;repositoryType&lt;/b&gt;.
     *
     * @param string $repositoryType
     */
    public function setRepositoryType($repositoryType)
    {
        $this->repositoryType = $repositoryType;
    }
    /**
     * List&lt;VXPermObj&gt; - value of member attribute &lt;b&gt;permMapList&lt;/b&gt;.
     *
     * @return \Org\Apache\Ranger\View\VXPermObj[]
     */
    public function getPermMapList()
    {
        return $this->permMapList;
    }

    /**
     * List&lt;VXPermObj&gt; - value of member attribute &lt;b&gt;permMapList&lt;/b&gt;.
     *
     * @param \Org\Apache\Ranger\View\VXPermObj[] $permMapList
     */
    public function setPermMapList($permMapList)
    {
        $this->permMapList = $permMapList;
    }
    /**
     * String - value of member attribute &lt;b&gt;tables&lt;/b&gt;.
     *
     * @return string
     */
    public function getTables()
    {
        return $this->tables;
    }

    /**
     * String - value of member attribute &lt;b&gt;tables&lt;/b&gt;.
     *
     * @param string $tables
     */
    public function setTables($tables)
    {
        $this->tables = $tables;
    }
    /**
     * String - value of member attribute &lt;b&gt;columnFamilies&lt;/b&gt;.
     *
     * @return string
     */
    public function getColumnFamilies()
    {
        return $this->columnFamilies;
    }

    /**
     * String - value of member attribute &lt;b&gt;columnFamilies&lt;/b&gt;.
     *
     * @param string $columnFamilies
     */
    public function setColumnFamilies($columnFamilies)
    {
        $this->columnFamilies = $columnFamilies;
    }
    /**
     * String - value of member attribute &lt;b&gt;columns&lt;/b&gt;.
     *
     * @return string
     */
    public function getColumns()
    {
        return $this->columns;
    }

    /**
     * String - value of member attribute &lt;b&gt;columns&lt;/b&gt;.
     *
     * @param string $columns
     */
    public function setColumns($columns)
    {
        $this->columns = $columns;
    }
    /**
     * String - value of member attribute &lt;b&gt;databases&lt;/b&gt;.
     *
     * @return string
     */
    public function getDatabases()
    {
        return $this->databases;
    }

    /**
     * String - value of member attribute &lt;b&gt;databases&lt;/b&gt;.
     *
     * @param string $databases
     */
    public function setDatabases($databases)
    {
        $this->databases = $databases;
    }
    /**
     * String - value of member attribute &lt;b&gt;udfs&lt;/b&gt;.
     *
     * @return string
     */
    public function getUdfs()
    {
        return $this->udfs;
    }

    /**
     * String - value of member attribute &lt;b&gt;udfs&lt;/b&gt;.
     *
     * @param string $udfs
     */
    public function setUdfs($udfs)
    {
        $this->udfs = $udfs;
    }
    /**
     * String - value of member attribute &lt;b&gt;tableType&lt;/b&gt;.
     *
     * @return string
     */
    public function getTableType()
    {
        return $this->tableType;
    }

    /**
     * String - value of member attribute &lt;b&gt;tableType&lt;/b&gt;.
     *
     * @param string $tableType
     */
    public function setTableType($tableType)
    {
        $this->tableType = $tableType;
    }
    /**
     * String - value of member attribute &lt;b&gt;columnType&lt;/b&gt;.
     *
     * @return string
     */
    public function getColumnType()
    {
        return $this->columnType;
    }

    /**
     * String - value of member attribute &lt;b&gt;columnType&lt;/b&gt;.
     *
     * @param string $columnType
     */
    public function setColumnType($columnType)
    {
        $this->columnType = $columnType;
    }
    /**
     * String - value of member attribute &lt;b&gt;topologies&lt;/b&gt;.
     *
     * @return string
     */
    public function getTopologies()
    {
        return $this->topologies;
    }

    /**
     * String - value of member attribute &lt;b&gt;topologies&lt;/b&gt;.
     *
     * @param string $topologies
     */
    public function setTopologies($topologies)
    {
        $this->topologies = $topologies;
    }
    /**
     * String - value of member attribute &lt;b&gt;services&lt;/b&gt;.
     *
     * @return string
     */
    public function getServices()
    {
        return $this->services;
    }

    /**
     * String - value of member attribute &lt;b&gt;services&lt;/b&gt;.
     *
     * @param string $services
     */
    public function setServices($services)
    {
        $this->services = $services;
    }
    /**
     * boolean - value of member attribute &lt;b&gt;isEnable&lt;/b&gt;.
     *
     * @return boolean
     */
    public function getIsEnabled()
    {
        return $this->isEnabled;
    }

    /**
     * boolean - value of member attribute &lt;b&gt;isEnable&lt;/b&gt;.
     *
     * @param boolean $isEnabled
     */
    public function setIsEnabled($isEnabled)
    {
        $this->isEnabled = $isEnabled;
    }
    /**
     * boolean - value of member attribute &lt;b&gt;isRecursive&lt;/b&gt;.
     *
     * @return boolean
     */
    public function getIsRecursive()
    {
        return $this->isRecursive;
    }

    /**
     * boolean - value of member attribute &lt;b&gt;isRecursive&lt;/b&gt;.
     *
     * @param boolean $isRecursive
     */
    public function setIsRecursive($isRecursive)
    {
        $this->isRecursive = $isRecursive;
    }
    /**
     * boolean - value of member attribute &lt;b&gt;isAuditEnabled&lt;/b&gt;.
     *
     * @return boolean
     */
    public function getIsAuditEnabled()
    {
        return $this->isAuditEnabled;
    }

    /**
     * boolean - value of member attribute &lt;b&gt;isAuditEnabled&lt;/b&gt;.
     *
     * @param boolean $isAuditEnabled
     */
    public function setIsAuditEnabled($isAuditEnabled)
    {
        $this->isAuditEnabled = $isAuditEnabled;
    }
    /**
     * String - value of member attribute &lt;b&gt;version&lt;/b&gt;.
     *
     * @return string
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * String - value of member attribute &lt;b&gt;version&lt;/b&gt;.
     *
     * @param string $version
     */
    public function setVersion($version)
    {
        $this->version = $version;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getGrantor()
    {
        return $this->grantor;
    }

    /**
     * (no documentation provided)
     *
     * @param string $grantor
     */
    public function setGrantor($grantor)
    {
        $this->grantor = $grantor;
    }
    /**
     * (no documentation provided)
     *
     * @return boolean
     */
    public function getReplacePerm()
    {
        return $this->replacePerm;
    }

    /**
     * (no documentation provided)
     *
     * @param boolean $replacePerm
     */
    public function setReplacePerm($replacePerm)
    {
        $this->replacePerm = $replacePerm;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getPolicyLabel()
    {
        return $this->policyLabel;
    }

    /**
     * (no documentation provided)
     *
     * @param string $policyLabel
     */
    public function setPolicyLabel($policyLabel)
    {
        $this->policyLabel = $policyLabel;
    }

    /**
     * Sets a known child element of VXPolicy from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'policyName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourceName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'repositoryName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->repositoryName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'repositoryType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->repositoryType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'permMapList') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXPermObj($xml);
            if (!isset($this->permMapList)) {
                $this->permMapList = array();
            }
            array_push($this->permMapList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'tables') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tables = $child;
            $happened = true;
        }
        else if (($xml->localName == 'columnFamilies') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->columnFamilies = $child;
            $happened = true;
        }
        else if (($xml->localName == 'columns') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->columns = $child;
            $happened = true;
        }
        else if (($xml->localName == 'databases') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->databases = $child;
            $happened = true;
        }
        else if (($xml->localName == 'udfs') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->udfs = $child;
            $happened = true;
        }
        else if (($xml->localName == 'tableType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tableType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'columnType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->columnType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'topologies') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->topologies = $child;
            $happened = true;
        }
        else if (($xml->localName == 'services') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->services = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isEnabled') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isEnabled = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isRecursive') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isRecursive = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isAuditEnabled') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isAuditEnabled = $child;
            $happened = true;
        }
        else if (($xml->localName == 'version') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->version = $child;
            $happened = true;
        }
        else if (($xml->localName == 'grantor') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->grantor = $child;
            $happened = true;
        }
        else if (($xml->localName == 'replacePerm') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->replacePerm = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policyLabel') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyLabel = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPolicy from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPolicy to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPolicy', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPolicy to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->policyName) {
            $writer->startElementNs(null, 'policyName', null);
            $writer->text($this->policyName);
            $writer->endElement();
        }
        if ($this->resourceName) {
            $writer->startElementNs(null, 'resourceName', null);
            $writer->text($this->resourceName);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->repositoryName) {
            $writer->startElementNs(null, 'repositoryName', null);
            $writer->text($this->repositoryName);
            $writer->endElement();
        }
        if ($this->repositoryType) {
            $writer->startElementNs(null, 'repositoryType', null);
            $writer->text($this->repositoryType);
            $writer->endElement();
        }
        if ($this->permMapList) {
            foreach ($this->permMapList as $i => $x) {
                $writer->startElementNs(null, 'permMapList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->tables) {
            $writer->startElementNs(null, 'tables', null);
            $writer->text($this->tables);
            $writer->endElement();
        }
        if ($this->columnFamilies) {
            $writer->startElementNs(null, 'columnFamilies', null);
            $writer->text($this->columnFamilies);
            $writer->endElement();
        }
        if ($this->columns) {
            $writer->startElementNs(null, 'columns', null);
            $writer->text($this->columns);
            $writer->endElement();
        }
        if ($this->databases) {
            $writer->startElementNs(null, 'databases', null);
            $writer->text($this->databases);
            $writer->endElement();
        }
        if ($this->udfs) {
            $writer->startElementNs(null, 'udfs', null);
            $writer->text($this->udfs);
            $writer->endElement();
        }
        if ($this->tableType) {
            $writer->startElementNs(null, 'tableType', null);
            $writer->text($this->tableType);
            $writer->endElement();
        }
        if ($this->columnType) {
            $writer->startElementNs(null, 'columnType', null);
            $writer->text($this->columnType);
            $writer->endElement();
        }
        if ($this->topologies) {
            $writer->startElementNs(null, 'topologies', null);
            $writer->text($this->topologies);
            $writer->endElement();
        }
        if ($this->services) {
            $writer->startElementNs(null, 'services', null);
            $writer->text($this->services);
            $writer->endElement();
        }
        if ($this->isEnabled) {
            $writer->startElementNs(null, 'isEnabled', null);
            $writer->text($this->isEnabled);
            $writer->endElement();
        }
        if ($this->isRecursive) {
            $writer->startElementNs(null, 'isRecursive', null);
            $writer->text($this->isRecursive);
            $writer->endElement();
        }
        if ($this->isAuditEnabled) {
            $writer->startElementNs(null, 'isAuditEnabled', null);
            $writer->text($this->isAuditEnabled);
            $writer->endElement();
        }
        if ($this->version) {
            $writer->startElementNs(null, 'version', null);
            $writer->text($this->version);
            $writer->endElement();
        }
        if ($this->grantor) {
            $writer->startElementNs(null, 'grantor', null);
            $writer->text($this->grantor);
            $writer->endElement();
        }
        if ($this->replacePerm) {
            $writer->startElementNs(null, 'replacePerm', null);
            $writer->text($this->replacePerm);
            $writer->endElement();
        }
        if ($this->policyLabel) {
            $writer->startElementNs(null, 'policyLabel', null);
            $writer->text($this->policyLabel);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPolicyExportAudit extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;clientIP&lt;/b&gt;.
     *
     * @var string
     */
    private $clientIP;

    /**
     * String - value of member attribute &lt;b&gt;agentId&lt;/b&gt;.
     *
     * @var string
     */
    private $agentId;

    /**
     * Long - value of member attribute &lt;b&gt;requestedEpoch&lt;/b&gt;.
     *
     * @var integer
     */
    private $requestedEpoch;

    /**
     * Date - value of member attribute &lt;b&gt;lastUpdated&lt;/b&gt;.
     *
     * @var integer
     */
    private $lastUpdated;

    /**
     * String - value of member attribute &lt;b&gt;repositoryName&lt;/b&gt;.
     *
     * @var string
     */
    private $repositoryName;

    /**
     * String - value of member attribute &lt;b&gt;exportedJson&lt;/b&gt;.
     *
     * @var string
     */
    private $exportedJson;

    /**
     * int - value of member attribute &lt;b&gt;httpRetCode&lt;/b&gt;.
     *
     * @var integer
     */
    private $httpRetCode;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $syncStatus;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $clusterName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $zoneName;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $policyVersion;

    /**
     * Constructs a VXPolicyExportAudit from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;clientIP&lt;/b&gt;.
     *
     * @return string
     */
    public function getClientIP()
    {
        return $this->clientIP;
    }

    /**
     * String - value of member attribute &lt;b&gt;clientIP&lt;/b&gt;.
     *
     * @param string $clientIP
     */
    public function setClientIP($clientIP)
    {
        $this->clientIP = $clientIP;
    }
    /**
     * String - value of member attribute &lt;b&gt;agentId&lt;/b&gt;.
     *
     * @return string
     */
    public function getAgentId()
    {
        return $this->agentId;
    }

    /**
     * String - value of member attribute &lt;b&gt;agentId&lt;/b&gt;.
     *
     * @param string $agentId
     */
    public function setAgentId($agentId)
    {
        $this->agentId = $agentId;
    }
    /**
     * Long - value of member attribute &lt;b&gt;requestedEpoch&lt;/b&gt;.
     *
     * @return integer
     */
    public function getRequestedEpoch()
    {
        return $this->requestedEpoch;
    }

    /**
     * Long - value of member attribute &lt;b&gt;requestedEpoch&lt;/b&gt;.
     *
     * @param integer $requestedEpoch
     */
    public function setRequestedEpoch($requestedEpoch)
    {
        $this->requestedEpoch = $requestedEpoch;
    }
    /**
     * Date - value of member attribute &lt;b&gt;lastUpdated&lt;/b&gt;.
     *
     * @return integer
     */
    public function getLastUpdated()
    {
        return $this->lastUpdated;
    }

    /**
     * Date - value of member attribute &lt;b&gt;lastUpdated&lt;/b&gt;.
     *
     * @param integer $lastUpdated
     */
    public function setLastUpdated($lastUpdated)
    {
        $this->lastUpdated = $lastUpdated;
    }
    /**
     * String - value of member attribute &lt;b&gt;repositoryName&lt;/b&gt;.
     *
     * @return string
     */
    public function getRepositoryName()
    {
        return $this->repositoryName;
    }

    /**
     * String - value of member attribute &lt;b&gt;repositoryName&lt;/b&gt;.
     *
     * @param string $repositoryName
     */
    public function setRepositoryName($repositoryName)
    {
        $this->repositoryName = $repositoryName;
    }
    /**
     * String - value of member attribute &lt;b&gt;exportedJson&lt;/b&gt;.
     *
     * @return string
     */
    public function getExportedJson()
    {
        return $this->exportedJson;
    }

    /**
     * String - value of member attribute &lt;b&gt;exportedJson&lt;/b&gt;.
     *
     * @param string $exportedJson
     */
    public function setExportedJson($exportedJson)
    {
        $this->exportedJson = $exportedJson;
    }
    /**
     * int - value of member attribute &lt;b&gt;httpRetCode&lt;/b&gt;.
     *
     * @return integer
     */
    public function getHttpRetCode()
    {
        return $this->httpRetCode;
    }

    /**
     * int - value of member attribute &lt;b&gt;httpRetCode&lt;/b&gt;.
     *
     * @param integer $httpRetCode
     */
    public function setHttpRetCode($httpRetCode)
    {
        $this->httpRetCode = $httpRetCode;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSyncStatus()
    {
        return $this->syncStatus;
    }

    /**
     * (no documentation provided)
     *
     * @param string $syncStatus
     */
    public function setSyncStatus($syncStatus)
    {
        $this->syncStatus = $syncStatus;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getClusterName()
    {
        return $this->clusterName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $clusterName
     */
    public function setClusterName($clusterName)
    {
        $this->clusterName = $clusterName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getZoneName()
    {
        return $this->zoneName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $zoneName
     */
    public function setZoneName($zoneName)
    {
        $this->zoneName = $zoneName;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getPolicyVersion()
    {
        return $this->policyVersion;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $policyVersion
     */
    public function setPolicyVersion($policyVersion)
    {
        $this->policyVersion = $policyVersion;
    }

    /**
     * Sets a known child element of VXPolicyExportAudit from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'clientIP') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->clientIP = $child;
            $happened = true;
        }
        else if (($xml->localName == 'agentId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->agentId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'requestedEpoch') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->requestedEpoch = $child;
            $happened = true;
        }
        else if (($xml->localName == 'lastUpdated') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->lastUpdated = $child;
            $happened = true;
        }
        else if (($xml->localName == 'repositoryName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->repositoryName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'exportedJson') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->exportedJson = $child;
            $happened = true;
        }
        else if (($xml->localName == 'httpRetCode') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->httpRetCode = $child;
            $happened = true;
        }
        else if (($xml->localName == 'syncStatus') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->syncStatus = $child;
            $happened = true;
        }
        else if (($xml->localName == 'clusterName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->clusterName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'zoneName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->zoneName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policyVersion') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyVersion = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPolicyExportAudit from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPolicyExportAudit to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPolicyExportAudit', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPolicyExportAudit to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->clientIP) {
            $writer->startElementNs(null, 'clientIP', null);
            $writer->text($this->clientIP);
            $writer->endElement();
        }
        if ($this->agentId) {
            $writer->startElementNs(null, 'agentId', null);
            $writer->text($this->agentId);
            $writer->endElement();
        }
        if ($this->requestedEpoch) {
            $writer->startElementNs(null, 'requestedEpoch', null);
            $writer->text($this->requestedEpoch);
            $writer->endElement();
        }
        if ($this->lastUpdated) {
            $writer->startElementNs(null, 'lastUpdated', null);
            $writer->text($this->lastUpdated);
            $writer->endElement();
        }
        if ($this->repositoryName) {
            $writer->startElementNs(null, 'repositoryName', null);
            $writer->text($this->repositoryName);
            $writer->endElement();
        }
        if ($this->exportedJson) {
            $writer->startElementNs(null, 'exportedJson', null);
            $writer->text($this->exportedJson);
            $writer->endElement();
        }
        if ($this->httpRetCode) {
            $writer->startElementNs(null, 'httpRetCode', null);
            $writer->text($this->httpRetCode);
            $writer->endElement();
        }
        if ($this->syncStatus) {
            $writer->startElementNs(null, 'syncStatus', null);
            $writer->text($this->syncStatus);
            $writer->endElement();
        }
        if ($this->clusterName) {
            $writer->startElementNs(null, 'clusterName', null);
            $writer->text($this->clusterName);
            $writer->endElement();
        }
        if ($this->zoneName) {
            $writer->startElementNs(null, 'zoneName', null);
            $writer->text($this->zoneName);
            $writer->endElement();
        }
        if ($this->policyVersion) {
            $writer->startElementNs(null, 'policyVersion', null);
            $writer->text($this->policyVersion);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPolicyExportAuditList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXPolicyExportAudit[]
     */
    private $vXPolicyExportAudits;

    /**
     * Constructs a VXPolicyExportAuditList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXPolicyExportAudit[]
     */
    public function getVXPolicyExportAudits()
    {
        return $this->vXPolicyExportAudits;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXPolicyExportAudit[] $vXPolicyExportAudits
     */
    public function setVXPolicyExportAudits($vXPolicyExportAudits)
    {
        $this->vXPolicyExportAudits = $vXPolicyExportAudits;
    }

    /**
     * Sets a known child element of VXPolicyExportAuditList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXPolicyExportAudits') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXPolicyExportAudit($xml);
            if (!isset($this->vXPolicyExportAudits)) {
                $this->vXPolicyExportAudits = array();
            }
            array_push($this->vXPolicyExportAudits, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPolicyExportAuditList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPolicyExportAuditList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPolicyExportAuditList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPolicyExportAuditList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXPolicyExportAudits) {
            foreach ($this->vXPolicyExportAudits as $i => $x) {
                $writer->startElementNs(null, 'vXPolicyExportAudits', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPolicyLabelList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXPolicyLabel[]
     */
    private $vxPolicyLabels;

    /**
     * Constructs a VXPolicyLabelList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXPolicyLabel[]
     */
    public function getVxPolicyLabels()
    {
        return $this->vxPolicyLabels;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXPolicyLabel[] $vxPolicyLabels
     */
    public function setVxPolicyLabels($vxPolicyLabels)
    {
        $this->vxPolicyLabels = $vxPolicyLabels;
    }

    /**
     * Sets a known child element of VXPolicyLabelList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vxPolicyLabels') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXPolicyLabel($xml);
            if (!isset($this->vxPolicyLabels)) {
                $this->vxPolicyLabels = array();
            }
            array_push($this->vxPolicyLabels, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPolicyLabelList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPolicyLabelList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPolicyLabelList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPolicyLabelList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vxPolicyLabels) {
            foreach ($this->vxPolicyLabels as $i => $x) {
                $writer->startElementNs(null, 'vxPolicyLabels', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPolicyList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXPolicy[]
     */
    private $vXPolicies;

    /**
     * Constructs a VXPolicyList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXPolicy[]
     */
    public function getVXPolicies()
    {
        return $this->vXPolicies;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXPolicy[] $vXPolicies
     */
    public function setVXPolicies($vXPolicies)
    {
        $this->vXPolicies = $vXPolicies;
    }

    /**
     * Sets a known child element of VXPolicyList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXPolicies') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXPolicy($xml);
            if (!isset($this->vXPolicies)) {
                $this->vXPolicies = array();
            }
            array_push($this->vXPolicies, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPolicyList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPolicyList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPolicyList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPolicyList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXPolicies) {
            foreach ($this->vXPolicies as $i => $x) {
                $writer->startElementNs(null, 'vXPolicies', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPortalUser extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;loginId&lt;/b&gt;.
     *
     * @var string
     */
    private $loginId;

    /**
     * String - value of member attribute &lt;b&gt;password&lt;/b&gt;.
     *
     * @var string
     */
    private $password;

    /**
     * int - value of member attribute &lt;b&gt;status&lt;/b&gt;.
     *
     * @var integer
     */
    private $status;

    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @var string
     */
    private $emailAddress;

    /**
     * String - value of member attribute &lt;b&gt;firstName&lt;/b&gt;.
     *
     * @var string
     */
    private $firstName;

    /**
     * String - value of member attribute &lt;b&gt;lastName&lt;/b&gt;.
     *
     * @var string
     */
    private $lastName;

    /**
     * String - value of member attribute &lt;b&gt;publicScreenName&lt;/b&gt;.
     *
     * @var string
     */
    private $publicScreenName;

    /**
     * int - value of member attribute &lt;b&gt;userSource&lt;/b&gt;.
     *
     * @var integer
     */
    private $userSource;

    /**
     * String - value of member attribute &lt;b&gt;notes&lt;/b&gt;.
     *
     * @var string
     */
    private $notes;

    /**
     * Collection&lt;String&gt; - value of member attribute &lt;b&gt;userRoleList&lt;/b&gt;.
     *
     * @var string[]
     */
    private $userRoleList;

    /**
     * (no documentation provided)
     *
     * @var integer[]
     */
    private $groupIdList;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXUserPermission[]
     */
    private $userPermList;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXGroupPermission[]
     */
    private $groupPermissions;

    /**
     * Constructs a VXPortalUser from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;loginId&lt;/b&gt;.
     *
     * @return string
     */
    public function getLoginId()
    {
        return $this->loginId;
    }

    /**
     * String - value of member attribute &lt;b&gt;loginId&lt;/b&gt;.
     *
     * @param string $loginId
     */
    public function setLoginId($loginId)
    {
        $this->loginId = $loginId;
    }
    /**
     * String - value of member attribute &lt;b&gt;password&lt;/b&gt;.
     *
     * @return string
     */
    public function getPassword()
    {
        return $this->password;
    }

    /**
     * String - value of member attribute &lt;b&gt;password&lt;/b&gt;.
     *
     * @param string $password
     */
    public function setPassword($password)
    {
        $this->password = $password;
    }
    /**
     * int - value of member attribute &lt;b&gt;status&lt;/b&gt;.
     *
     * @return integer
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * int - value of member attribute &lt;b&gt;status&lt;/b&gt;.
     *
     * @param integer $status
     */
    public function setStatus($status)
    {
        $this->status = $status;
    }
    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @return string
     */
    public function getEmailAddress()
    {
        return $this->emailAddress;
    }

    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @param string $emailAddress
     */
    public function setEmailAddress($emailAddress)
    {
        $this->emailAddress = $emailAddress;
    }
    /**
     * String - value of member attribute &lt;b&gt;firstName&lt;/b&gt;.
     *
     * @return string
     */
    public function getFirstName()
    {
        return $this->firstName;
    }

    /**
     * String - value of member attribute &lt;b&gt;firstName&lt;/b&gt;.
     *
     * @param string $firstName
     */
    public function setFirstName($firstName)
    {
        $this->firstName = $firstName;
    }
    /**
     * String - value of member attribute &lt;b&gt;lastName&lt;/b&gt;.
     *
     * @return string
     */
    public function getLastName()
    {
        return $this->lastName;
    }

    /**
     * String - value of member attribute &lt;b&gt;lastName&lt;/b&gt;.
     *
     * @param string $lastName
     */
    public function setLastName($lastName)
    {
        $this->lastName = $lastName;
    }
    /**
     * String - value of member attribute &lt;b&gt;publicScreenName&lt;/b&gt;.
     *
     * @return string
     */
    public function getPublicScreenName()
    {
        return $this->publicScreenName;
    }

    /**
     * String - value of member attribute &lt;b&gt;publicScreenName&lt;/b&gt;.
     *
     * @param string $publicScreenName
     */
    public function setPublicScreenName($publicScreenName)
    {
        $this->publicScreenName = $publicScreenName;
    }
    /**
     * int - value of member attribute &lt;b&gt;userSource&lt;/b&gt;.
     *
     * @return integer
     */
    public function getUserSource()
    {
        return $this->userSource;
    }

    /**
     * int - value of member attribute &lt;b&gt;userSource&lt;/b&gt;.
     *
     * @param integer $userSource
     */
    public function setUserSource($userSource)
    {
        $this->userSource = $userSource;
    }
    /**
     * String - value of member attribute &lt;b&gt;notes&lt;/b&gt;.
     *
     * @return string
     */
    public function getNotes()
    {
        return $this->notes;
    }

    /**
     * String - value of member attribute &lt;b&gt;notes&lt;/b&gt;.
     *
     * @param string $notes
     */
    public function setNotes($notes)
    {
        $this->notes = $notes;
    }
    /**
     * Collection&lt;String&gt; - value of member attribute &lt;b&gt;userRoleList&lt;/b&gt;.
     *
     * @return string[]
     */
    public function getUserRoleList()
    {
        return $this->userRoleList;
    }

    /**
     * Collection&lt;String&gt; - value of member attribute &lt;b&gt;userRoleList&lt;/b&gt;.
     *
     * @param string[] $userRoleList
     */
    public function setUserRoleList($userRoleList)
    {
        $this->userRoleList = $userRoleList;
    }
    /**
     * (no documentation provided)
     *
     * @return integer[]
     */
    public function getGroupIdList()
    {
        return $this->groupIdList;
    }

    /**
     * (no documentation provided)
     *
     * @param integer[] $groupIdList
     */
    public function setGroupIdList($groupIdList)
    {
        $this->groupIdList = $groupIdList;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXUserPermission[]
     */
    public function getUserPermList()
    {
        return $this->userPermList;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXUserPermission[] $userPermList
     */
    public function setUserPermList($userPermList)
    {
        $this->userPermList = $userPermList;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXGroupPermission[]
     */
    public function getGroupPermissions()
    {
        return $this->groupPermissions;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXGroupPermission[] $groupPermissions
     */
    public function setGroupPermissions($groupPermissions)
    {
        $this->groupPermissions = $groupPermissions;
    }

    /**
     * Sets a known child element of VXPortalUser from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'loginId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->loginId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'password') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->password = $child;
            $happened = true;
        }
        else if (($xml->localName == 'status') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->status = $child;
            $happened = true;
        }
        else if (($xml->localName == 'emailAddress') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->emailAddress = $child;
            $happened = true;
        }
        else if (($xml->localName == 'firstName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->firstName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'lastName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->lastName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'publicScreenName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->publicScreenName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userSource') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userSource = $child;
            $happened = true;
        }
        else if (($xml->localName == 'notes') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->notes = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userRoleList') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->userRoleList)) {
                $this->userRoleList = array();
            }
            array_push($this->userRoleList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'groupIdList') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->groupIdList)) {
                $this->groupIdList = array();
            }
            array_push($this->groupIdList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'userPermList') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXUserPermission($xml);
            if (!isset($this->userPermList)) {
                $this->userPermList = array();
            }
            array_push($this->userPermList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'groupPermissions') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXGroupPermission($xml);
            if (!isset($this->groupPermissions)) {
                $this->groupPermissions = array();
            }
            array_push($this->groupPermissions, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPortalUser from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPortalUser to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPortalUser', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPortalUser to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->loginId) {
            $writer->startElementNs(null, 'loginId', null);
            $writer->text($this->loginId);
            $writer->endElement();
        }
        if ($this->password) {
            $writer->startElementNs(null, 'password', null);
            $writer->text($this->password);
            $writer->endElement();
        }
        if ($this->status) {
            $writer->startElementNs(null, 'status', null);
            $writer->text($this->status);
            $writer->endElement();
        }
        if ($this->emailAddress) {
            $writer->startElementNs(null, 'emailAddress', null);
            $writer->text($this->emailAddress);
            $writer->endElement();
        }
        if ($this->firstName) {
            $writer->startElementNs(null, 'firstName', null);
            $writer->text($this->firstName);
            $writer->endElement();
        }
        if ($this->lastName) {
            $writer->startElementNs(null, 'lastName', null);
            $writer->text($this->lastName);
            $writer->endElement();
        }
        if ($this->publicScreenName) {
            $writer->startElementNs(null, 'publicScreenName', null);
            $writer->text($this->publicScreenName);
            $writer->endElement();
        }
        if ($this->userSource) {
            $writer->startElementNs(null, 'userSource', null);
            $writer->text($this->userSource);
            $writer->endElement();
        }
        if ($this->notes) {
            $writer->startElementNs(null, 'notes', null);
            $writer->text($this->notes);
            $writer->endElement();
        }
        if ($this->userRoleList) {
            foreach ($this->userRoleList as $i => $x) {
                $writer->startElementNs(null, 'userRoleList', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->groupIdList) {
            foreach ($this->groupIdList as $i => $x) {
                $writer->startElementNs(null, 'groupIdList', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->userPermList) {
            foreach ($this->userPermList as $i => $x) {
                $writer->startElementNs(null, 'userPermList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->groupPermissions) {
            foreach ($this->groupPermissions as $i => $x) {
                $writer->startElementNs(null, 'groupPermissions', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXRepository extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @var string
     */
    private $name;

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @var string
     */
    private $description;

    /**
     * String - value of member attribute &lt;b&gt;repositoryType&lt;/b&gt;.
     *
     * @var string
     */
    private $repositoryType;

    /**
     * String - value of member attribute &lt;b&gt;config&lt;/b&gt;.
     *
     * @var string
     */
    private $config;

    /**
     * boolean - value of member attribute &lt;b&gt;isActive&lt;/b&gt;.
     *
     * @var boolean
     */
    private $isActive;

    /**
     * String - value of member attribute &lt;b&gt;version&lt;/b&gt;.
     *
     * @var string
     */
    private $version;

    /**
     * Constructs a VXRepository from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * String - value of member attribute &lt;b&gt;repositoryType&lt;/b&gt;.
     *
     * @return string
     */
    public function getRepositoryType()
    {
        return $this->repositoryType;
    }

    /**
     * String - value of member attribute &lt;b&gt;repositoryType&lt;/b&gt;.
     *
     * @param string $repositoryType
     */
    public function setRepositoryType($repositoryType)
    {
        $this->repositoryType = $repositoryType;
    }
    /**
     * String - value of member attribute &lt;b&gt;config&lt;/b&gt;.
     *
     * @return string
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * String - value of member attribute &lt;b&gt;config&lt;/b&gt;.
     *
     * @param string $config
     */
    public function setConfig($config)
    {
        $this->config = $config;
    }
    /**
     * boolean - value of member attribute &lt;b&gt;isActive&lt;/b&gt;.
     *
     * @return boolean
     */
    public function getIsActive()
    {
        return $this->isActive;
    }

    /**
     * boolean - value of member attribute &lt;b&gt;isActive&lt;/b&gt;.
     *
     * @param boolean $isActive
     */
    public function setIsActive($isActive)
    {
        $this->isActive = $isActive;
    }
    /**
     * String - value of member attribute &lt;b&gt;version&lt;/b&gt;.
     *
     * @return string
     */
    public function getVersion()
    {
        return $this->version;
    }

    /**
     * String - value of member attribute &lt;b&gt;version&lt;/b&gt;.
     *
     * @param string $version
     */
    public function setVersion($version)
    {
        $this->version = $version;
    }

    /**
     * Sets a known child element of VXRepository from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'repositoryType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->repositoryType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'config') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->config = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isActive') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isActive = $child;
            $happened = true;
        }
        else if (($xml->localName == 'version') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->version = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXRepository from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXRepository to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXRepository', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXRepository to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->repositoryType) {
            $writer->startElementNs(null, 'repositoryType', null);
            $writer->text($this->repositoryType);
            $writer->endElement();
        }
        if ($this->config) {
            $writer->startElementNs(null, 'config', null);
            $writer->text($this->config);
            $writer->endElement();
        }
        if ($this->isActive) {
            $writer->startElementNs(null, 'isActive', null);
            $writer->text($this->isActive);
            $writer->endElement();
        }
        if ($this->version) {
            $writer->startElementNs(null, 'version', null);
            $writer->text($this->version);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXRepositoryList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXRepository[]
     */
    private $vXRepositories;

    /**
     * Constructs a VXRepositoryList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXRepository[]
     */
    public function getVXRepositories()
    {
        return $this->vXRepositories;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXRepository[] $vXRepositories
     */
    public function setVXRepositories($vXRepositories)
    {
        $this->vXRepositories = $vXRepositories;
    }

    /**
     * Sets a known child element of VXRepositoryList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXRepositories') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXRepository($xml);
            if (!isset($this->vXRepositories)) {
                $this->vXRepositories = array();
            }
            array_push($this->vXRepositories, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXRepositoryList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXRepositoryList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXRepositoryList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXRepositoryList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXRepositories) {
            foreach ($this->vXRepositories as $i => $x) {
                $writer->startElementNs(null, 'vXRepositories', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXResource extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @var string
     */
    private $name;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $policyName;

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @var string
     */
    private $description;

    /**
     * int - value of member attribute &lt;b&gt;resourceType&lt;/b&gt;.
     *
     * @var integer
     */
    private $resourceType;

    /**
     * Long - value of member attribute &lt;b&gt;assetId&lt;/b&gt;.
     *
     * @var integer
     */
    private $assetId;

    /**
     * Long - value of member attribute &lt;b&gt;parentId&lt;/b&gt;.
     *
     * @var integer
     */
    private $parentId;

    /**
     * String - value of member attribute &lt;b&gt;parentPath&lt;/b&gt;.
     *
     * @var string
     */
    private $parentPath;

    /**
     * int - value of member attribute &lt;b&gt;isEncrypt&lt;/b&gt;.
     *
     * @var integer
     */
    private $isEncrypt;

    /**
     * List&lt;VXPermMap&gt; - value of member attribute &lt;b&gt;permMapList&lt;/b&gt;.
     *
     * @var \Org\Apache\Ranger\View\VXPermMap[]
     */
    private $permMapList;

    /**
     * List&lt;VXAuditMap&gt; - value of member attribute &lt;b&gt;auditList&lt;/b&gt;.
     *
     * @var \Org\Apache\Ranger\View\VXAuditMap[]
     */
    private $auditList;

    /**
     * int - value of member attribute &lt;b&gt;isRecursive&lt;/b&gt;.
     *
     * @var integer
     */
    private $isRecursive;

    /**
     * String - value of member attribute &lt;b&gt;resourceGroup&lt;/b&gt;.
     *
     * @var string
     */
    private $resourceGroup;

    /**
     * String - value of member attribute &lt;b&gt;databases&lt;/b&gt;.
     *
     * @var string
     */
    private $databases;

    /**
     * String - value of member attribute &lt;b&gt;tables&lt;/b&gt;.
     *
     * @var string
     */
    private $tables;

    /**
     * String - value of member attribute &lt;b&gt;columnFamilies&lt;/b&gt;.
     *
     * @var string
     */
    private $columnFamilies;

    /**
     * String - value of member attribute &lt;b&gt;columns&lt;/b&gt;.
     *
     * @var string
     */
    private $columns;

    /**
     * String - value of member attribute &lt;b&gt;udfs&lt;/b&gt;.
     *
     * @var string
     */
    private $udfs;

    /**
     * String - value of member attribute &lt;b&gt;assetName&lt;/b&gt;.
     *
     * @var string
     */
    private $assetName;

    /**
     * int - value of member attribute &lt;b&gt;assetType&lt;/b&gt;.
     *
     * @var integer
     */
    private $assetType;

    /**
     * int - value of member attribute &lt;b&gt;resourceStatus&lt;/b&gt;.
     *
     * @var integer
     */
    private $resourceStatus;

    /**
     * int - value of member attribute &lt;b&gt;tableType&lt;/b&gt;.
     *
     * @var integer
     */
    private $tableType;

    /**
     * int - value of member attribute &lt;b&gt;columnType&lt;/b&gt;.
     *
     * @var integer
     */
    private $columnType;

    /**
     * String - value of member attribute &lt;b&gt;topologies&lt;/b&gt;.
     *
     * @var string
     */
    private $topologies;

    /**
     * String - value of member attribute &lt;b&gt;services&lt;/b&gt;.
     *
     * @var string
     */
    private $services;

    /**
     * int - value of member attribute &lt;b&gt;checkParentPermission&lt;/b&gt;.
     *
     * @var integer
     */
    private $checkParentPermission;

    /**
     * String - value of member attribute &lt;b&gt;guid&lt;/b&gt;.
     *
     * @var string
     */
    private $guid;

    /**
     * Constructs a VXResource from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getPolicyName()
    {
        return $this->policyName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $policyName
     */
    public function setPolicyName($policyName)
    {
        $this->policyName = $policyName;
    }
    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * int - value of member attribute &lt;b&gt;resourceType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getResourceType()
    {
        return $this->resourceType;
    }

    /**
     * int - value of member attribute &lt;b&gt;resourceType&lt;/b&gt;.
     *
     * @param integer $resourceType
     */
    public function setResourceType($resourceType)
    {
        $this->resourceType = $resourceType;
    }
    /**
     * Long - value of member attribute &lt;b&gt;assetId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getAssetId()
    {
        return $this->assetId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;assetId&lt;/b&gt;.
     *
     * @param integer $assetId
     */
    public function setAssetId($assetId)
    {
        $this->assetId = $assetId;
    }
    /**
     * Long - value of member attribute &lt;b&gt;parentId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getParentId()
    {
        return $this->parentId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;parentId&lt;/b&gt;.
     *
     * @param integer $parentId
     */
    public function setParentId($parentId)
    {
        $this->parentId = $parentId;
    }
    /**
     * String - value of member attribute &lt;b&gt;parentPath&lt;/b&gt;.
     *
     * @return string
     */
    public function getParentPath()
    {
        return $this->parentPath;
    }

    /**
     * String - value of member attribute &lt;b&gt;parentPath&lt;/b&gt;.
     *
     * @param string $parentPath
     */
    public function setParentPath($parentPath)
    {
        $this->parentPath = $parentPath;
    }
    /**
     * int - value of member attribute &lt;b&gt;isEncrypt&lt;/b&gt;.
     *
     * @return integer
     */
    public function getIsEncrypt()
    {
        return $this->isEncrypt;
    }

    /**
     * int - value of member attribute &lt;b&gt;isEncrypt&lt;/b&gt;.
     *
     * @param integer $isEncrypt
     */
    public function setIsEncrypt($isEncrypt)
    {
        $this->isEncrypt = $isEncrypt;
    }
    /**
     * List&lt;VXPermMap&gt; - value of member attribute &lt;b&gt;permMapList&lt;/b&gt;.
     *
     * @return \Org\Apache\Ranger\View\VXPermMap[]
     */
    public function getPermMapList()
    {
        return $this->permMapList;
    }

    /**
     * List&lt;VXPermMap&gt; - value of member attribute &lt;b&gt;permMapList&lt;/b&gt;.
     *
     * @param \Org\Apache\Ranger\View\VXPermMap[] $permMapList
     */
    public function setPermMapList($permMapList)
    {
        $this->permMapList = $permMapList;
    }
    /**
     * List&lt;VXAuditMap&gt; - value of member attribute &lt;b&gt;auditList&lt;/b&gt;.
     *
     * @return \Org\Apache\Ranger\View\VXAuditMap[]
     */
    public function getAuditList()
    {
        return $this->auditList;
    }

    /**
     * List&lt;VXAuditMap&gt; - value of member attribute &lt;b&gt;auditList&lt;/b&gt;.
     *
     * @param \Org\Apache\Ranger\View\VXAuditMap[] $auditList
     */
    public function setAuditList($auditList)
    {
        $this->auditList = $auditList;
    }
    /**
     * int - value of member attribute &lt;b&gt;isRecursive&lt;/b&gt;.
     *
     * @return integer
     */
    public function getIsRecursive()
    {
        return $this->isRecursive;
    }

    /**
     * int - value of member attribute &lt;b&gt;isRecursive&lt;/b&gt;.
     *
     * @param integer $isRecursive
     */
    public function setIsRecursive($isRecursive)
    {
        $this->isRecursive = $isRecursive;
    }
    /**
     * String - value of member attribute &lt;b&gt;resourceGroup&lt;/b&gt;.
     *
     * @return string
     */
    public function getResourceGroup()
    {
        return $this->resourceGroup;
    }

    /**
     * String - value of member attribute &lt;b&gt;resourceGroup&lt;/b&gt;.
     *
     * @param string $resourceGroup
     */
    public function setResourceGroup($resourceGroup)
    {
        $this->resourceGroup = $resourceGroup;
    }
    /**
     * String - value of member attribute &lt;b&gt;databases&lt;/b&gt;.
     *
     * @return string
     */
    public function getDatabases()
    {
        return $this->databases;
    }

    /**
     * String - value of member attribute &lt;b&gt;databases&lt;/b&gt;.
     *
     * @param string $databases
     */
    public function setDatabases($databases)
    {
        $this->databases = $databases;
    }
    /**
     * String - value of member attribute &lt;b&gt;tables&lt;/b&gt;.
     *
     * @return string
     */
    public function getTables()
    {
        return $this->tables;
    }

    /**
     * String - value of member attribute &lt;b&gt;tables&lt;/b&gt;.
     *
     * @param string $tables
     */
    public function setTables($tables)
    {
        $this->tables = $tables;
    }
    /**
     * String - value of member attribute &lt;b&gt;columnFamilies&lt;/b&gt;.
     *
     * @return string
     */
    public function getColumnFamilies()
    {
        return $this->columnFamilies;
    }

    /**
     * String - value of member attribute &lt;b&gt;columnFamilies&lt;/b&gt;.
     *
     * @param string $columnFamilies
     */
    public function setColumnFamilies($columnFamilies)
    {
        $this->columnFamilies = $columnFamilies;
    }
    /**
     * String - value of member attribute &lt;b&gt;columns&lt;/b&gt;.
     *
     * @return string
     */
    public function getColumns()
    {
        return $this->columns;
    }

    /**
     * String - value of member attribute &lt;b&gt;columns&lt;/b&gt;.
     *
     * @param string $columns
     */
    public function setColumns($columns)
    {
        $this->columns = $columns;
    }
    /**
     * String - value of member attribute &lt;b&gt;udfs&lt;/b&gt;.
     *
     * @return string
     */
    public function getUdfs()
    {
        return $this->udfs;
    }

    /**
     * String - value of member attribute &lt;b&gt;udfs&lt;/b&gt;.
     *
     * @param string $udfs
     */
    public function setUdfs($udfs)
    {
        $this->udfs = $udfs;
    }
    /**
     * String - value of member attribute &lt;b&gt;assetName&lt;/b&gt;.
     *
     * @return string
     */
    public function getAssetName()
    {
        return $this->assetName;
    }

    /**
     * String - value of member attribute &lt;b&gt;assetName&lt;/b&gt;.
     *
     * @param string $assetName
     */
    public function setAssetName($assetName)
    {
        $this->assetName = $assetName;
    }
    /**
     * int - value of member attribute &lt;b&gt;assetType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getAssetType()
    {
        return $this->assetType;
    }

    /**
     * int - value of member attribute &lt;b&gt;assetType&lt;/b&gt;.
     *
     * @param integer $assetType
     */
    public function setAssetType($assetType)
    {
        $this->assetType = $assetType;
    }
    /**
     * int - value of member attribute &lt;b&gt;resourceStatus&lt;/b&gt;.
     *
     * @return integer
     */
    public function getResourceStatus()
    {
        return $this->resourceStatus;
    }

    /**
     * int - value of member attribute &lt;b&gt;resourceStatus&lt;/b&gt;.
     *
     * @param integer $resourceStatus
     */
    public function setResourceStatus($resourceStatus)
    {
        $this->resourceStatus = $resourceStatus;
    }
    /**
     * int - value of member attribute &lt;b&gt;tableType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getTableType()
    {
        return $this->tableType;
    }

    /**
     * int - value of member attribute &lt;b&gt;tableType&lt;/b&gt;.
     *
     * @param integer $tableType
     */
    public function setTableType($tableType)
    {
        $this->tableType = $tableType;
    }
    /**
     * int - value of member attribute &lt;b&gt;columnType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getColumnType()
    {
        return $this->columnType;
    }

    /**
     * int - value of member attribute &lt;b&gt;columnType&lt;/b&gt;.
     *
     * @param integer $columnType
     */
    public function setColumnType($columnType)
    {
        $this->columnType = $columnType;
    }
    /**
     * String - value of member attribute &lt;b&gt;topologies&lt;/b&gt;.
     *
     * @return string
     */
    public function getTopologies()
    {
        return $this->topologies;
    }

    /**
     * String - value of member attribute &lt;b&gt;topologies&lt;/b&gt;.
     *
     * @param string $topologies
     */
    public function setTopologies($topologies)
    {
        $this->topologies = $topologies;
    }
    /**
     * String - value of member attribute &lt;b&gt;services&lt;/b&gt;.
     *
     * @return string
     */
    public function getServices()
    {
        return $this->services;
    }

    /**
     * String - value of member attribute &lt;b&gt;services&lt;/b&gt;.
     *
     * @param string $services
     */
    public function setServices($services)
    {
        $this->services = $services;
    }
    /**
     * int - value of member attribute &lt;b&gt;checkParentPermission&lt;/b&gt;.
     *
     * @return integer
     */
    public function getCheckParentPermission()
    {
        return $this->checkParentPermission;
    }

    /**
     * int - value of member attribute &lt;b&gt;checkParentPermission&lt;/b&gt;.
     *
     * @param integer $checkParentPermission
     */
    public function setCheckParentPermission($checkParentPermission)
    {
        $this->checkParentPermission = $checkParentPermission;
    }
    /**
     * String - value of member attribute &lt;b&gt;guid&lt;/b&gt;.
     *
     * @return string
     */
    public function getGuid()
    {
        return $this->guid;
    }

    /**
     * String - value of member attribute &lt;b&gt;guid&lt;/b&gt;.
     *
     * @param string $guid
     */
    public function setGuid($guid)
    {
        $this->guid = $guid;
    }

    /**
     * Sets a known child element of VXResource from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policyName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourceType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'assetId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->assetId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'parentId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->parentId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'parentPath') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->parentPath = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isEncrypt') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isEncrypt = $child;
            $happened = true;
        }
        else if (($xml->localName == 'permMapList') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXPermMap($xml);
            if (!isset($this->permMapList)) {
                $this->permMapList = array();
            }
            array_push($this->permMapList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'auditList') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXAuditMap($xml);
            if (!isset($this->auditList)) {
                $this->auditList = array();
            }
            array_push($this->auditList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'isRecursive') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isRecursive = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourceGroup') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceGroup = $child;
            $happened = true;
        }
        else if (($xml->localName == 'databases') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->databases = $child;
            $happened = true;
        }
        else if (($xml->localName == 'tables') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tables = $child;
            $happened = true;
        }
        else if (($xml->localName == 'columnFamilies') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->columnFamilies = $child;
            $happened = true;
        }
        else if (($xml->localName == 'columns') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->columns = $child;
            $happened = true;
        }
        else if (($xml->localName == 'udfs') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->udfs = $child;
            $happened = true;
        }
        else if (($xml->localName == 'assetName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->assetName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'assetType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->assetType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourceStatus') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceStatus = $child;
            $happened = true;
        }
        else if (($xml->localName == 'tableType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tableType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'columnType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->columnType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'topologies') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->topologies = $child;
            $happened = true;
        }
        else if (($xml->localName == 'services') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->services = $child;
            $happened = true;
        }
        else if (($xml->localName == 'checkParentPermission') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->checkParentPermission = $child;
            $happened = true;
        }
        else if (($xml->localName == 'guid') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->guid = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXResource from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXResource to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXResource', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXResource to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->policyName) {
            $writer->startElementNs(null, 'policyName', null);
            $writer->text($this->policyName);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->resourceType) {
            $writer->startElementNs(null, 'resourceType', null);
            $writer->text($this->resourceType);
            $writer->endElement();
        }
        if ($this->assetId) {
            $writer->startElementNs(null, 'assetId', null);
            $writer->text($this->assetId);
            $writer->endElement();
        }
        if ($this->parentId) {
            $writer->startElementNs(null, 'parentId', null);
            $writer->text($this->parentId);
            $writer->endElement();
        }
        if ($this->parentPath) {
            $writer->startElementNs(null, 'parentPath', null);
            $writer->text($this->parentPath);
            $writer->endElement();
        }
        if ($this->isEncrypt) {
            $writer->startElementNs(null, 'isEncrypt', null);
            $writer->text($this->isEncrypt);
            $writer->endElement();
        }
        if ($this->permMapList) {
            foreach ($this->permMapList as $i => $x) {
                $writer->startElementNs(null, 'permMapList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->auditList) {
            foreach ($this->auditList as $i => $x) {
                $writer->startElementNs(null, 'auditList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
        if ($this->isRecursive) {
            $writer->startElementNs(null, 'isRecursive', null);
            $writer->text($this->isRecursive);
            $writer->endElement();
        }
        if ($this->resourceGroup) {
            $writer->startElementNs(null, 'resourceGroup', null);
            $writer->text($this->resourceGroup);
            $writer->endElement();
        }
        if ($this->databases) {
            $writer->startElementNs(null, 'databases', null);
            $writer->text($this->databases);
            $writer->endElement();
        }
        if ($this->tables) {
            $writer->startElementNs(null, 'tables', null);
            $writer->text($this->tables);
            $writer->endElement();
        }
        if ($this->columnFamilies) {
            $writer->startElementNs(null, 'columnFamilies', null);
            $writer->text($this->columnFamilies);
            $writer->endElement();
        }
        if ($this->columns) {
            $writer->startElementNs(null, 'columns', null);
            $writer->text($this->columns);
            $writer->endElement();
        }
        if ($this->udfs) {
            $writer->startElementNs(null, 'udfs', null);
            $writer->text($this->udfs);
            $writer->endElement();
        }
        if ($this->assetName) {
            $writer->startElementNs(null, 'assetName', null);
            $writer->text($this->assetName);
            $writer->endElement();
        }
        if ($this->assetType) {
            $writer->startElementNs(null, 'assetType', null);
            $writer->text($this->assetType);
            $writer->endElement();
        }
        if ($this->resourceStatus) {
            $writer->startElementNs(null, 'resourceStatus', null);
            $writer->text($this->resourceStatus);
            $writer->endElement();
        }
        if ($this->tableType) {
            $writer->startElementNs(null, 'tableType', null);
            $writer->text($this->tableType);
            $writer->endElement();
        }
        if ($this->columnType) {
            $writer->startElementNs(null, 'columnType', null);
            $writer->text($this->columnType);
            $writer->endElement();
        }
        if ($this->topologies) {
            $writer->startElementNs(null, 'topologies', null);
            $writer->text($this->topologies);
            $writer->endElement();
        }
        if ($this->services) {
            $writer->startElementNs(null, 'services', null);
            $writer->text($this->services);
            $writer->endElement();
        }
        if ($this->checkParentPermission) {
            $writer->startElementNs(null, 'checkParentPermission', null);
            $writer->text($this->checkParentPermission);
            $writer->endElement();
        }
        if ($this->guid) {
            $writer->startElementNs(null, 'guid', null);
            $writer->text($this->guid);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXStringList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXString[]
     */
    private $vXStrings;

    /**
     * Constructs a VXStringList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXString[]
     */
    public function getVXStrings()
    {
        return $this->vXStrings;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXString[] $vXStrings
     */
    public function setVXStrings($vXStrings)
    {
        $this->vXStrings = $vXStrings;
    }

    /**
     * Sets a known child element of VXStringList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXStrings') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXString($xml);
            if (!isset($this->vXStrings)) {
                $this->vXStrings = array();
            }
            array_push($this->vXStrings, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXStringList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXStringList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXStringList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXStringList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXStrings) {
            foreach ($this->vXStrings as $i => $x) {
                $writer->startElementNs(null, 'vXStrings', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXTrxLogList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXTrxLog[]
     */
    private $vXTrxLogs;

    /**
     * Constructs a VXTrxLogList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXTrxLog[]
     */
    public function getVXTrxLogs()
    {
        return $this->vXTrxLogs;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXTrxLog[] $vXTrxLogs
     */
    public function setVXTrxLogs($vXTrxLogs)
    {
        $this->vXTrxLogs = $vXTrxLogs;
    }

    /**
     * Sets a known child element of VXTrxLogList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXTrxLogs') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXTrxLog($xml);
            if (!isset($this->vXTrxLogs)) {
                $this->vXTrxLogs = array();
            }
            array_push($this->vXTrxLogs, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXTrxLogList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXTrxLogList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXTrxLogList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXTrxLogList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXTrxLogs) {
            foreach ($this->vXTrxLogs as $i => $x) {
                $writer->startElementNs(null, 'vXTrxLogs', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXUgsyncAuditInfo extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $eventTime;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $userName;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $noOfNewUsers;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $noOfModifiedUsers;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $noOfNewGroups;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $noOfModifiedGroups;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $syncSource;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXLdapSyncSourceInfo
     */
    private $ldapSyncSourceInfo;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXFileSyncSourceInfo
     */
    private $fileSyncSourceInfo;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXUnixSyncSourceInfo
     */
    private $unixSyncSourceInfo;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $sessionId;

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $syncSourceInfo;

    /**
     * Constructs a VXUgsyncAuditInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getEventTime()
    {
        return $this->eventTime;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $eventTime
     */
    public function setEventTime($eventTime)
    {
        $this->eventTime = $eventTime;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getUserName()
    {
        return $this->userName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $userName
     */
    public function setUserName($userName)
    {
        $this->userName = $userName;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getNoOfNewUsers()
    {
        return $this->noOfNewUsers;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $noOfNewUsers
     */
    public function setNoOfNewUsers($noOfNewUsers)
    {
        $this->noOfNewUsers = $noOfNewUsers;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getNoOfModifiedUsers()
    {
        return $this->noOfModifiedUsers;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $noOfModifiedUsers
     */
    public function setNoOfModifiedUsers($noOfModifiedUsers)
    {
        $this->noOfModifiedUsers = $noOfModifiedUsers;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getNoOfNewGroups()
    {
        return $this->noOfNewGroups;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $noOfNewGroups
     */
    public function setNoOfNewGroups($noOfNewGroups)
    {
        $this->noOfNewGroups = $noOfNewGroups;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getNoOfModifiedGroups()
    {
        return $this->noOfModifiedGroups;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $noOfModifiedGroups
     */
    public function setNoOfModifiedGroups($noOfModifiedGroups)
    {
        $this->noOfModifiedGroups = $noOfModifiedGroups;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSyncSource()
    {
        return $this->syncSource;
    }

    /**
     * (no documentation provided)
     *
     * @param string $syncSource
     */
    public function setSyncSource($syncSource)
    {
        $this->syncSource = $syncSource;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXLdapSyncSourceInfo
     */
    public function getLdapSyncSourceInfo()
    {
        return $this->ldapSyncSourceInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXLdapSyncSourceInfo $ldapSyncSourceInfo
     */
    public function setLdapSyncSourceInfo($ldapSyncSourceInfo)
    {
        $this->ldapSyncSourceInfo = $ldapSyncSourceInfo;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXFileSyncSourceInfo
     */
    public function getFileSyncSourceInfo()
    {
        return $this->fileSyncSourceInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXFileSyncSourceInfo $fileSyncSourceInfo
     */
    public function setFileSyncSourceInfo($fileSyncSourceInfo)
    {
        $this->fileSyncSourceInfo = $fileSyncSourceInfo;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXUnixSyncSourceInfo
     */
    public function getUnixSyncSourceInfo()
    {
        return $this->unixSyncSourceInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXUnixSyncSourceInfo $unixSyncSourceInfo
     */
    public function setUnixSyncSourceInfo($unixSyncSourceInfo)
    {
        $this->unixSyncSourceInfo = $unixSyncSourceInfo;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getSessionId()
    {
        return $this->sessionId;
    }

    /**
     * (no documentation provided)
     *
     * @param string $sessionId
     */
    public function setSessionId($sessionId)
    {
        $this->sessionId = $sessionId;
    }
    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getSyncSourceInfo()
    {
        return $this->syncSourceInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param array $syncSourceInfo
     */
    public function setSyncSourceInfo($syncSourceInfo)
    {
        $this->syncSourceInfo = $syncSourceInfo;
    }

    /**
     * Sets a known child element of VXUgsyncAuditInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'eventTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->eventTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'noOfNewUsers') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->noOfNewUsers = $child;
            $happened = true;
        }
        else if (($xml->localName == 'noOfModifiedUsers') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->noOfModifiedUsers = $child;
            $happened = true;
        }
        else if (($xml->localName == 'noOfNewGroups') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->noOfNewGroups = $child;
            $happened = true;
        }
        else if (($xml->localName == 'noOfModifiedGroups') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->noOfModifiedGroups = $child;
            $happened = true;
        }
        else if (($xml->localName == 'syncSource') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->syncSource = $child;
            $happened = true;
        }
        else if (($xml->localName == 'ldapSyncSourceInfo') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXLdapSyncSourceInfo($xml);
            $this->ldapSyncSourceInfo = $child;
            $happened = true;
        }
        else if (($xml->localName == 'fileSyncSourceInfo') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXFileSyncSourceInfo($xml);
            $this->fileSyncSourceInfo = $child;
            $happened = true;
        }
        else if (($xml->localName == 'unixSyncSourceInfo') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXUnixSyncSourceInfo($xml);
            $this->unixSyncSourceInfo = $child;
            $happened = true;
        }
        else if (($xml->localName == 'sessionId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->sessionId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'syncSourceInfo') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->syncSourceInfo = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXUgsyncAuditInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXUgsyncAuditInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXUgsyncAuditInfo', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXUgsyncAuditInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->eventTime) {
            $writer->startElementNs(null, 'eventTime', null);
            $writer->text($this->eventTime);
            $writer->endElement();
        }
        if ($this->userName) {
            $writer->startElementNs(null, 'userName', null);
            $writer->text($this->userName);
            $writer->endElement();
        }
        if ($this->noOfNewUsers) {
            $writer->startElementNs(null, 'noOfNewUsers', null);
            $writer->text($this->noOfNewUsers);
            $writer->endElement();
        }
        if ($this->noOfModifiedUsers) {
            $writer->startElementNs(null, 'noOfModifiedUsers', null);
            $writer->text($this->noOfModifiedUsers);
            $writer->endElement();
        }
        if ($this->noOfNewGroups) {
            $writer->startElementNs(null, 'noOfNewGroups', null);
            $writer->text($this->noOfNewGroups);
            $writer->endElement();
        }
        if ($this->noOfModifiedGroups) {
            $writer->startElementNs(null, 'noOfModifiedGroups', null);
            $writer->text($this->noOfModifiedGroups);
            $writer->endElement();
        }
        if ($this->syncSource) {
            $writer->startElementNs(null, 'syncSource', null);
            $writer->text($this->syncSource);
            $writer->endElement();
        }
        if ($this->ldapSyncSourceInfo) {
            $writer->startElementNs(null, 'ldapSyncSourceInfo', null);
            $this->ldapSyncSourceInfo->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->fileSyncSourceInfo) {
            $writer->startElementNs(null, 'fileSyncSourceInfo', null);
            $this->fileSyncSourceInfo->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->unixSyncSourceInfo) {
            $writer->startElementNs(null, 'unixSyncSourceInfo', null);
            $this->unixSyncSourceInfo->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->sessionId) {
            $writer->startElementNs(null, 'sessionId', null);
            $writer->text($this->sessionId);
            $writer->endElement();
        }
        if ($this->syncSourceInfo) {
            $writer->startElementNs(null, 'syncSourceInfo', null);
            $writer->text($this->syncSourceInfo);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXUser extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @var string
     */
    private $name;

    /**
     * String - value of member attribute &lt;b&gt;firstName&lt;/b&gt;.
     *
     * @var string
     */
    private $firstName;

    /**
     * String - value of member attribute &lt;b&gt;lastName&lt;/b&gt;.
     *
     * @var string
     */
    private $lastName;

    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @var string
     */
    private $emailAddress;

    /**
     * String - value of member attribute &lt;b&gt;password&lt;/b&gt;.
     *
     * @var string
     */
    private $password;

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @var string
     */
    private $description;

    /**
     * Long - value of member attribute &lt;b&gt;credStoreId&lt;/b&gt;.
     *
     * @var integer
     */
    private $credStoreId;

    /**
     * Collection&lt;Long&gt; - value of member attribute &lt;b&gt;groupIdList&lt;/b&gt;.
     *
     * @var integer[]
     */
    private $groupIdList;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $isVisible;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $userSource;

    /**
     * Collection&lt;String&gt; - value of member attribute &lt;b&gt;userRoleList&lt;/b&gt;.
     *
     * @var string[]
     */
    private $userRoleList;

    /**
     * (no documentation provided)
     *
     * @var string[]
     */
    private $groupNameList;

    /**
     * Constructs a VXUser from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * String - value of member attribute &lt;b&gt;firstName&lt;/b&gt;.
     *
     * @return string
     */
    public function getFirstName()
    {
        return $this->firstName;
    }

    /**
     * String - value of member attribute &lt;b&gt;firstName&lt;/b&gt;.
     *
     * @param string $firstName
     */
    public function setFirstName($firstName)
    {
        $this->firstName = $firstName;
    }
    /**
     * String - value of member attribute &lt;b&gt;lastName&lt;/b&gt;.
     *
     * @return string
     */
    public function getLastName()
    {
        return $this->lastName;
    }

    /**
     * String - value of member attribute &lt;b&gt;lastName&lt;/b&gt;.
     *
     * @param string $lastName
     */
    public function setLastName($lastName)
    {
        $this->lastName = $lastName;
    }
    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @return string
     */
    public function getEmailAddress()
    {
        return $this->emailAddress;
    }

    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @param string $emailAddress
     */
    public function setEmailAddress($emailAddress)
    {
        $this->emailAddress = $emailAddress;
    }
    /**
     * String - value of member attribute &lt;b&gt;password&lt;/b&gt;.
     *
     * @return string
     */
    public function getPassword()
    {
        return $this->password;
    }

    /**
     * String - value of member attribute &lt;b&gt;password&lt;/b&gt;.
     *
     * @param string $password
     */
    public function setPassword($password)
    {
        $this->password = $password;
    }
    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * Long - value of member attribute &lt;b&gt;credStoreId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getCredStoreId()
    {
        return $this->credStoreId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;credStoreId&lt;/b&gt;.
     *
     * @param integer $credStoreId
     */
    public function setCredStoreId($credStoreId)
    {
        $this->credStoreId = $credStoreId;
    }
    /**
     * Collection&lt;Long&gt; - value of member attribute &lt;b&gt;groupIdList&lt;/b&gt;.
     *
     * @return integer[]
     */
    public function getGroupIdList()
    {
        return $this->groupIdList;
    }

    /**
     * Collection&lt;Long&gt; - value of member attribute &lt;b&gt;groupIdList&lt;/b&gt;.
     *
     * @param integer[] $groupIdList
     */
    public function setGroupIdList($groupIdList)
    {
        $this->groupIdList = $groupIdList;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getIsVisible()
    {
        return $this->isVisible;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $isVisible
     */
    public function setIsVisible($isVisible)
    {
        $this->isVisible = $isVisible;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getUserSource()
    {
        return $this->userSource;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $userSource
     */
    public function setUserSource($userSource)
    {
        $this->userSource = $userSource;
    }
    /**
     * Collection&lt;String&gt; - value of member attribute &lt;b&gt;userRoleList&lt;/b&gt;.
     *
     * @return string[]
     */
    public function getUserRoleList()
    {
        return $this->userRoleList;
    }

    /**
     * Collection&lt;String&gt; - value of member attribute &lt;b&gt;userRoleList&lt;/b&gt;.
     *
     * @param string[] $userRoleList
     */
    public function setUserRoleList($userRoleList)
    {
        $this->userRoleList = $userRoleList;
    }
    /**
     * (no documentation provided)
     *
     * @return string[]
     */
    public function getGroupNameList()
    {
        return $this->groupNameList;
    }

    /**
     * (no documentation provided)
     *
     * @param string[] $groupNameList
     */
    public function setGroupNameList($groupNameList)
    {
        $this->groupNameList = $groupNameList;
    }

    /**
     * Sets a known child element of VXUser from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'firstName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->firstName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'lastName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->lastName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'emailAddress') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->emailAddress = $child;
            $happened = true;
        }
        else if (($xml->localName == 'password') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->password = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'credStoreId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->credStoreId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupIdList') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->groupIdList)) {
                $this->groupIdList = array();
            }
            array_push($this->groupIdList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'isVisible') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isVisible = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userSource') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userSource = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userRoleList') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->userRoleList)) {
                $this->userRoleList = array();
            }
            array_push($this->userRoleList, $child);
            $happened = true;
        }
        else if (($xml->localName == 'groupNameList') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            if (!isset($this->groupNameList)) {
                $this->groupNameList = array();
            }
            array_push($this->groupNameList, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXUser from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXUser to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXUser', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXUser to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->firstName) {
            $writer->startElementNs(null, 'firstName', null);
            $writer->text($this->firstName);
            $writer->endElement();
        }
        if ($this->lastName) {
            $writer->startElementNs(null, 'lastName', null);
            $writer->text($this->lastName);
            $writer->endElement();
        }
        if ($this->emailAddress) {
            $writer->startElementNs(null, 'emailAddress', null);
            $writer->text($this->emailAddress);
            $writer->endElement();
        }
        if ($this->password) {
            $writer->startElementNs(null, 'password', null);
            $writer->text($this->password);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->credStoreId) {
            $writer->startElementNs(null, 'credStoreId', null);
            $writer->text($this->credStoreId);
            $writer->endElement();
        }
        if ($this->groupIdList) {
            foreach ($this->groupIdList as $i => $x) {
                $writer->startElementNs(null, 'groupIdList', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->isVisible) {
            $writer->startElementNs(null, 'isVisible', null);
            $writer->text($this->isVisible);
            $writer->endElement();
        }
        if ($this->userSource) {
            $writer->startElementNs(null, 'userSource', null);
            $writer->text($this->userSource);
            $writer->endElement();
        }
        if ($this->userRoleList) {
            foreach ($this->userRoleList as $i => $x) {
                $writer->startElementNs(null, 'userRoleList', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
        if ($this->groupNameList) {
            foreach ($this->groupNameList as $i => $x) {
                $writer->startElementNs(null, 'groupNameList', null);
                $writer->text($x);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXUserGroupInfo extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXUser
     */
    private $xuserInfo;

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXGroup[]
     */
    private $xgroupInfo;

    /**
     * Constructs a VXUserGroupInfo from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXUser
     */
    public function getXuserInfo()
    {
        return $this->xuserInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXUser $xuserInfo
     */
    public function setXuserInfo($xuserInfo)
    {
        $this->xuserInfo = $xuserInfo;
    }
    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXGroup[]
     */
    public function getXgroupInfo()
    {
        return $this->xgroupInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXGroup[] $xgroupInfo
     */
    public function setXgroupInfo($xgroupInfo)
    {
        $this->xgroupInfo = $xgroupInfo;
    }

    /**
     * Sets a known child element of VXUserGroupInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'xuserInfo') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXUser($xml);
            $this->xuserInfo = $child;
            $happened = true;
        }
        else if (($xml->localName == 'xgroupInfo') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXGroup($xml);
            if (!isset($this->xgroupInfo)) {
                $this->xgroupInfo = array();
            }
            array_push($this->xgroupInfo, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXUserGroupInfo from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXUserGroupInfo to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXUserGroupInfo', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXUserGroupInfo to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->xuserInfo) {
            $writer->startElementNs(null, 'xuserInfo', null);
            $this->xuserInfo->writeXmlContents($writer);
            $writer->endElement();
        }
        if ($this->xgroupInfo) {
            foreach ($this->xgroupInfo as $i => $x) {
                $writer->startElementNs(null, 'xgroupInfo', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXUserList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXUser[]
     */
    private $vXUsers;

    /**
     * Constructs a VXUserList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXUser[]
     */
    public function getVXUsers()
    {
        return $this->vXUsers;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXUser[] $vXUsers
     */
    public function setVXUsers($vXUsers)
    {
        $this->vXUsers = $vXUsers;
    }

    /**
     * Sets a known child element of VXUserList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXUsers') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXUser($xml);
            if (!isset($this->vXUsers)) {
                $this->vXUsers = array();
            }
            array_push($this->vXUsers, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXUserList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXUserList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXUserList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXUserList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXUsers) {
            foreach ($this->vXUsers as $i => $x) {
                $writer->startElementNs(null, 'vXUsers', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXUserPermissionList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXUserPermission[]
     */
    private $vXUserPermission;

    /**
     * Constructs a VXUserPermissionList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXUserPermission[]
     */
    public function getVXUserPermission()
    {
        return $this->vXUserPermission;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXUserPermission[] $vXUserPermission
     */
    public function setVXUserPermission($vXUserPermission)
    {
        $this->vXUserPermission = $vXUserPermission;
    }

    /**
     * Sets a known child element of VXUserPermissionList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXUserPermission') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXUserPermission($xml);
            if (!isset($this->vXUserPermission)) {
                $this->vXUserPermission = array();
            }
            array_push($this->vXUserPermission, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXUserPermissionList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXUserPermissionList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXUserPermissionList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXUserPermissionList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXUserPermission) {
            foreach ($this->vXUserPermission as $i => $x) {
                $writer->startElementNs(null, 'vXUserPermission', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXUserPermission extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * the userId
     *
     * @var integer
     */
    private $userId;

    /**
     * the moduleId
     *
     * @var integer
     */
    private $moduleId;

    /**
     * the isAllowed
     *
     * @var integer
     */
    private $isAllowed;

    /**
     * the userName
     *
     * @var string
     */
    private $userName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $moduleName;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $loginId;

    /**
     * Constructs a VXUserPermission from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * the userId
     *
     * @return integer
     */
    public function getUserId()
    {
        return $this->userId;
    }

    /**
     * the userId
     *
     * @param integer $userId
     */
    public function setUserId($userId)
    {
        $this->userId = $userId;
    }
    /**
     * the moduleId
     *
     * @return integer
     */
    public function getModuleId()
    {
        return $this->moduleId;
    }

    /**
     * the moduleId
     *
     * @param integer $moduleId
     */
    public function setModuleId($moduleId)
    {
        $this->moduleId = $moduleId;
    }
    /**
     * the isAllowed
     *
     * @return integer
     */
    public function getIsAllowed()
    {
        return $this->isAllowed;
    }

    /**
     * the isAllowed
     *
     * @param integer $isAllowed
     */
    public function setIsAllowed($isAllowed)
    {
        $this->isAllowed = $isAllowed;
    }
    /**
     * the userName
     *
     * @return string
     */
    public function getUserName()
    {
        return $this->userName;
    }

    /**
     * the userName
     *
     * @param string $userName
     */
    public function setUserName($userName)
    {
        $this->userName = $userName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getModuleName()
    {
        return $this->moduleName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $moduleName
     */
    public function setModuleName($moduleName)
    {
        $this->moduleName = $moduleName;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getLoginId()
    {
        return $this->loginId;
    }

    /**
     * (no documentation provided)
     *
     * @param string $loginId
     */
    public function setLoginId($loginId)
    {
        $this->loginId = $loginId;
    }

    /**
     * Sets a known child element of VXUserPermission from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'userId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'moduleId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->moduleId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isAllowed') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isAllowed = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'moduleName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->moduleName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'loginId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->loginId = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXUserPermission from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXUserPermission to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXUserPermission', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXUserPermission to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->userId) {
            $writer->startElementNs(null, 'userId', null);
            $writer->text($this->userId);
            $writer->endElement();
        }
        if ($this->moduleId) {
            $writer->startElementNs(null, 'moduleId', null);
            $writer->text($this->moduleId);
            $writer->endElement();
        }
        if ($this->isAllowed) {
            $writer->startElementNs(null, 'isAllowed', null);
            $writer->text($this->isAllowed);
            $writer->endElement();
        }
        if ($this->userName) {
            $writer->startElementNs(null, 'userName', null);
            $writer->text($this->userName);
            $writer->endElement();
        }
        if ($this->moduleName) {
            $writer->startElementNs(null, 'moduleName', null);
            $writer->text($this->moduleName);
            $writer->endElement();
        }
        if ($this->loginId) {
            $writer->startElementNs(null, 'loginId', null);
            $writer->text($this->loginId);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXUgsyncAuditInfoList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXUgsyncAuditInfo[]
     */
    private $vxUgsyncAuditInfoList;

    /**
     * Constructs a VXUgsyncAuditInfoList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXUgsyncAuditInfo[]
     */
    public function getVxUgsyncAuditInfoList()
    {
        return $this->vxUgsyncAuditInfoList;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXUgsyncAuditInfo[] $vxUgsyncAuditInfoList
     */
    public function setVxUgsyncAuditInfoList($vxUgsyncAuditInfoList)
    {
        $this->vxUgsyncAuditInfoList = $vxUgsyncAuditInfoList;
    }

    /**
     * Sets a known child element of VXUgsyncAuditInfoList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vxUgsyncAuditInfoList') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXUgsyncAuditInfo($xml);
            if (!isset($this->vxUgsyncAuditInfoList)) {
                $this->vxUgsyncAuditInfoList = array();
            }
            array_push($this->vxUgsyncAuditInfoList, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXUgsyncAuditInfoList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXUgsyncAuditInfoList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXUgsyncAuditInfoList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXUgsyncAuditInfoList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vxUgsyncAuditInfoList) {
            foreach ($this->vxUgsyncAuditInfoList as $i => $x) {
                $writer->startElementNs(null, 'vxUgsyncAuditInfoList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXTrxLog extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * int - value of member attribute &lt;b&gt;objectClassType&lt;/b&gt;.
     *
     * @var integer
     */
    private $objectClassType;

    /**
     * Long - value of member attribute &lt;b&gt;objectId&lt;/b&gt;.
     *
     * @var integer
     */
    private $objectId;

    /**
     * Long - value of member attribute &lt;b&gt;parentObjectId&lt;/b&gt;.
     *
     * @var integer
     */
    private $parentObjectId;

    /**
     * int - value of member attribute &lt;b&gt;parentObjectClassType&lt;/b&gt;.
     *
     * @var integer
     */
    private $parentObjectClassType;

    /**
     * String - value of member attribute &lt;b&gt;parentObjectName&lt;/b&gt;.
     *
     * @var string
     */
    private $parentObjectName;

    /**
     * String - value of member attribute &lt;b&gt;objectName&lt;/b&gt;.
     *
     * @var string
     */
    private $objectName;

    /**
     * String - value of member attribute &lt;b&gt;attributeName&lt;/b&gt;.
     *
     * @var string
     */
    private $attributeName;

    /**
     * String - value of member attribute &lt;b&gt;previousValue&lt;/b&gt;.
     *
     * @var string
     */
    private $previousValue;

    /**
     * String - value of member attribute &lt;b&gt;newValue&lt;/b&gt;.
     *
     * @var string
     */
    private $newValue;

    /**
     * String - value of member attribute &lt;b&gt;transactionId&lt;/b&gt;.
     *
     * @var string
     */
    private $transactionId;

    /**
     * String - value of member attribute &lt;b&gt;action&lt;/b&gt;.
     *
     * @var string
     */
    private $action;

    /**
     * String - value of member attribute &lt;b&gt;sessionId&lt;/b&gt;.
     *
     * @var string
     */
    private $sessionId;

    /**
     * String - value of member attribute &lt;b&gt;requestId&lt;/b&gt;.
     *
     * @var string
     */
    private $requestId;

    /**
     * String - value of member attribute &lt;b&gt;sessionType&lt;/b&gt;.
     *
     * @var string
     */
    private $sessionType;

    /**
     * Constructs a VXTrxLog from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * int - value of member attribute &lt;b&gt;objectClassType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getObjectClassType()
    {
        return $this->objectClassType;
    }

    /**
     * int - value of member attribute &lt;b&gt;objectClassType&lt;/b&gt;.
     *
     * @param integer $objectClassType
     */
    public function setObjectClassType($objectClassType)
    {
        $this->objectClassType = $objectClassType;
    }
    /**
     * Long - value of member attribute &lt;b&gt;objectId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getObjectId()
    {
        return $this->objectId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;objectId&lt;/b&gt;.
     *
     * @param integer $objectId
     */
    public function setObjectId($objectId)
    {
        $this->objectId = $objectId;
    }
    /**
     * Long - value of member attribute &lt;b&gt;parentObjectId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getParentObjectId()
    {
        return $this->parentObjectId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;parentObjectId&lt;/b&gt;.
     *
     * @param integer $parentObjectId
     */
    public function setParentObjectId($parentObjectId)
    {
        $this->parentObjectId = $parentObjectId;
    }
    /**
     * int - value of member attribute &lt;b&gt;parentObjectClassType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getParentObjectClassType()
    {
        return $this->parentObjectClassType;
    }

    /**
     * int - value of member attribute &lt;b&gt;parentObjectClassType&lt;/b&gt;.
     *
     * @param integer $parentObjectClassType
     */
    public function setParentObjectClassType($parentObjectClassType)
    {
        $this->parentObjectClassType = $parentObjectClassType;
    }
    /**
     * String - value of member attribute &lt;b&gt;parentObjectName&lt;/b&gt;.
     *
     * @return string
     */
    public function getParentObjectName()
    {
        return $this->parentObjectName;
    }

    /**
     * String - value of member attribute &lt;b&gt;parentObjectName&lt;/b&gt;.
     *
     * @param string $parentObjectName
     */
    public function setParentObjectName($parentObjectName)
    {
        $this->parentObjectName = $parentObjectName;
    }
    /**
     * String - value of member attribute &lt;b&gt;objectName&lt;/b&gt;.
     *
     * @return string
     */
    public function getObjectName()
    {
        return $this->objectName;
    }

    /**
     * String - value of member attribute &lt;b&gt;objectName&lt;/b&gt;.
     *
     * @param string $objectName
     */
    public function setObjectName($objectName)
    {
        $this->objectName = $objectName;
    }
    /**
     * String - value of member attribute &lt;b&gt;attributeName&lt;/b&gt;.
     *
     * @return string
     */
    public function getAttributeName()
    {
        return $this->attributeName;
    }

    /**
     * String - value of member attribute &lt;b&gt;attributeName&lt;/b&gt;.
     *
     * @param string $attributeName
     */
    public function setAttributeName($attributeName)
    {
        $this->attributeName = $attributeName;
    }
    /**
     * String - value of member attribute &lt;b&gt;previousValue&lt;/b&gt;.
     *
     * @return string
     */
    public function getPreviousValue()
    {
        return $this->previousValue;
    }

    /**
     * String - value of member attribute &lt;b&gt;previousValue&lt;/b&gt;.
     *
     * @param string $previousValue
     */
    public function setPreviousValue($previousValue)
    {
        $this->previousValue = $previousValue;
    }
    /**
     * String - value of member attribute &lt;b&gt;newValue&lt;/b&gt;.
     *
     * @return string
     */
    public function getNewValue()
    {
        return $this->newValue;
    }

    /**
     * String - value of member attribute &lt;b&gt;newValue&lt;/b&gt;.
     *
     * @param string $newValue
     */
    public function setNewValue($newValue)
    {
        $this->newValue = $newValue;
    }
    /**
     * String - value of member attribute &lt;b&gt;transactionId&lt;/b&gt;.
     *
     * @return string
     */
    public function getTransactionId()
    {
        return $this->transactionId;
    }

    /**
     * String - value of member attribute &lt;b&gt;transactionId&lt;/b&gt;.
     *
     * @param string $transactionId
     */
    public function setTransactionId($transactionId)
    {
        $this->transactionId = $transactionId;
    }
    /**
     * String - value of member attribute &lt;b&gt;action&lt;/b&gt;.
     *
     * @return string
     */
    public function getAction()
    {
        return $this->action;
    }

    /**
     * String - value of member attribute &lt;b&gt;action&lt;/b&gt;.
     *
     * @param string $action
     */
    public function setAction($action)
    {
        $this->action = $action;
    }
    /**
     * String - value of member attribute &lt;b&gt;sessionId&lt;/b&gt;.
     *
     * @return string
     */
    public function getSessionId()
    {
        return $this->sessionId;
    }

    /**
     * String - value of member attribute &lt;b&gt;sessionId&lt;/b&gt;.
     *
     * @param string $sessionId
     */
    public function setSessionId($sessionId)
    {
        $this->sessionId = $sessionId;
    }
    /**
     * String - value of member attribute &lt;b&gt;requestId&lt;/b&gt;.
     *
     * @return string
     */
    public function getRequestId()
    {
        return $this->requestId;
    }

    /**
     * String - value of member attribute &lt;b&gt;requestId&lt;/b&gt;.
     *
     * @param string $requestId
     */
    public function setRequestId($requestId)
    {
        $this->requestId = $requestId;
    }
    /**
     * String - value of member attribute &lt;b&gt;sessionType&lt;/b&gt;.
     *
     * @return string
     */
    public function getSessionType()
    {
        return $this->sessionType;
    }

    /**
     * String - value of member attribute &lt;b&gt;sessionType&lt;/b&gt;.
     *
     * @param string $sessionType
     */
    public function setSessionType($sessionType)
    {
        $this->sessionType = $sessionType;
    }

    /**
     * Sets a known child element of VXTrxLog from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'objectClassType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->objectClassType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'objectId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->objectId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'parentObjectId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->parentObjectId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'parentObjectClassType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->parentObjectClassType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'parentObjectName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->parentObjectName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'objectName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->objectName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'attributeName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->attributeName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'previousValue') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->previousValue = $child;
            $happened = true;
        }
        else if (($xml->localName == 'newValue') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->newValue = $child;
            $happened = true;
        }
        else if (($xml->localName == 'transactionId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->transactionId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'action') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->action = $child;
            $happened = true;
        }
        else if (($xml->localName == 'sessionId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->sessionId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'requestId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->requestId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'sessionType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->sessionType = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXTrxLog from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXTrxLog to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXTrxLog', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXTrxLog to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->objectClassType) {
            $writer->startElementNs(null, 'objectClassType', null);
            $writer->text($this->objectClassType);
            $writer->endElement();
        }
        if ($this->objectId) {
            $writer->startElementNs(null, 'objectId', null);
            $writer->text($this->objectId);
            $writer->endElement();
        }
        if ($this->parentObjectId) {
            $writer->startElementNs(null, 'parentObjectId', null);
            $writer->text($this->parentObjectId);
            $writer->endElement();
        }
        if ($this->parentObjectClassType) {
            $writer->startElementNs(null, 'parentObjectClassType', null);
            $writer->text($this->parentObjectClassType);
            $writer->endElement();
        }
        if ($this->parentObjectName) {
            $writer->startElementNs(null, 'parentObjectName', null);
            $writer->text($this->parentObjectName);
            $writer->endElement();
        }
        if ($this->objectName) {
            $writer->startElementNs(null, 'objectName', null);
            $writer->text($this->objectName);
            $writer->endElement();
        }
        if ($this->attributeName) {
            $writer->startElementNs(null, 'attributeName', null);
            $writer->text($this->attributeName);
            $writer->endElement();
        }
        if ($this->previousValue) {
            $writer->startElementNs(null, 'previousValue', null);
            $writer->text($this->previousValue);
            $writer->endElement();
        }
        if ($this->newValue) {
            $writer->startElementNs(null, 'newValue', null);
            $writer->text($this->newValue);
            $writer->endElement();
        }
        if ($this->transactionId) {
            $writer->startElementNs(null, 'transactionId', null);
            $writer->text($this->transactionId);
            $writer->endElement();
        }
        if ($this->action) {
            $writer->startElementNs(null, 'action', null);
            $writer->text($this->action);
            $writer->endElement();
        }
        if ($this->sessionId) {
            $writer->startElementNs(null, 'sessionId', null);
            $writer->text($this->sessionId);
            $writer->endElement();
        }
        if ($this->requestId) {
            $writer->startElementNs(null, 'requestId', null);
            $writer->text($this->requestId);
            $writer->endElement();
        }
        if ($this->sessionType) {
            $writer->startElementNs(null, 'sessionType', null);
            $writer->text($this->sessionType);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXResourceList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXResource[]
     */
    private $vXResources;

    /**
     * Constructs a VXResourceList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXResource[]
     */
    public function getVXResources()
    {
        return $this->vXResources;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXResource[] $vXResources
     */
    public function setVXResources($vXResources)
    {
        $this->vXResources = $vXResources;
    }

    /**
     * Sets a known child element of VXResourceList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXResources') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXResource($xml);
            if (!isset($this->vXResources)) {
                $this->vXResources = array();
            }
            array_push($this->vXResources, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXResourceList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXResourceList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXResourceList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXResourceList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXResources) {
            foreach ($this->vXResources as $i => $x) {
                $writer->startElementNs(null, 'vXResources', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPortalUserList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXPortalUser[]
     */
    private $vXPortalUsers;

    /**
     * Constructs a VXPortalUserList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXPortalUser[]
     */
    public function getVXPortalUsers()
    {
        return $this->vXPortalUsers;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXPortalUser[] $vXPortalUsers
     */
    public function setVXPortalUsers($vXPortalUsers)
    {
        $this->vXPortalUsers = $vXPortalUsers;
    }

    /**
     * Sets a known child element of VXPortalUserList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXPortalUsers') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXPortalUser($xml);
            if (!isset($this->vXPortalUsers)) {
                $this->vXPortalUsers = array();
            }
            array_push($this->vXPortalUsers, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPortalUserList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPortalUserList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPortalUserList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPortalUserList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXPortalUsers) {
            foreach ($this->vXPortalUsers as $i => $x) {
                $writer->startElementNs(null, 'vXPortalUsers', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPolicyLabel extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $policyLabel;

    /**
     * Constructs a VXPolicyLabel from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getPolicyLabel()
    {
        return $this->policyLabel;
    }

    /**
     * (no documentation provided)
     *
     * @param string $policyLabel
     */
    public function setPolicyLabel($policyLabel)
    {
        $this->policyLabel = $policyLabel;
    }

    /**
     * Sets a known child element of VXPolicyLabel from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'policyLabel') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyLabel = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPolicyLabel from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPolicyLabel to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPolicyLabel', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPolicyLabel to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->policyLabel) {
            $writer->startElementNs(null, 'policyLabel', null);
            $writer->text($this->policyLabel);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXPermObjList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXPermObj[]
     */
    private $vXPermObjs;

    /**
     * Constructs a VXPermObjList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXPermObj[]
     */
    public function getVXPermObjs()
    {
        return $this->vXPermObjs;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXPermObj[] $vXPermObjs
     */
    public function setVXPermObjs($vXPermObjs)
    {
        $this->vXPermObjs = $vXPermObjs;
    }

    /**
     * Sets a known child element of VXPermObjList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXPermObjs') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXPermObj($xml);
            if (!isset($this->vXPermObjs)) {
                $this->vXPermObjs = array();
            }
            array_push($this->vXPermObjs, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXPermObjList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXPermObjList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXPermObjList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXPermObjList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXPermObjs) {
            foreach ($this->vXPermObjs as $i => $x) {
                $writer->startElementNs(null, 'vXPermObjs', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXModuleDefList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXModuleDef[]
     */
    private $vXModuleDef;

    /**
     * Constructs a VXModuleDefList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXModuleDef[]
     */
    public function getVXModuleDef()
    {
        return $this->vXModuleDef;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXModuleDef[] $vXModuleDef
     */
    public function setVXModuleDef($vXModuleDef)
    {
        $this->vXModuleDef = $vXModuleDef;
    }

    /**
     * Sets a known child element of VXModuleDefList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXModuleDef') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXModuleDef($xml);
            if (!isset($this->vXModuleDef)) {
                $this->vXModuleDef = array();
            }
            array_push($this->vXModuleDef, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXModuleDefList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXModuleDefList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXModuleDefList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXModuleDefList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXModuleDef) {
            foreach ($this->vXModuleDef as $i => $x) {
                $writer->startElementNs(null, 'vXModuleDef', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXKmsKeyList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXKmsKey[]
     */
    private $vXKeys;

    /**
     * Constructs a VXKmsKeyList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXKmsKey[]
     */
    public function getVXKeys()
    {
        return $this->vXKeys;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXKmsKey[] $vXKeys
     */
    public function setVXKeys($vXKeys)
    {
        $this->vXKeys = $vXKeys;
    }

    /**
     * Sets a known child element of VXKmsKeyList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXKeys') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXKmsKey($xml);
            if (!isset($this->vXKeys)) {
                $this->vXKeys = array();
            }
            array_push($this->vXKeys, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXKmsKeyList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXKmsKeyList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXKmsKeyList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXKmsKeyList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXKeys) {
            foreach ($this->vXKeys as $i => $x) {
                $writer->startElementNs(null, 'vXKeys', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXGroupUserList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXGroupUser[]
     */
    private $vXGroupUsers;

    /**
     * Constructs a VXGroupUserList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXGroupUser[]
     */
    public function getVXGroupUsers()
    {
        return $this->vXGroupUsers;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXGroupUser[] $vXGroupUsers
     */
    public function setVXGroupUsers($vXGroupUsers)
    {
        $this->vXGroupUsers = $vXGroupUsers;
    }

    /**
     * Sets a known child element of VXGroupUserList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXGroupUsers') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXGroupUser($xml);
            if (!isset($this->vXGroupUsers)) {
                $this->vXGroupUsers = array();
            }
            array_push($this->vXGroupUsers, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXGroupUserList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXGroupUserList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXGroupUserList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXGroupUserList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXGroupUsers) {
            foreach ($this->vXGroupUsers as $i => $x) {
                $writer->startElementNs(null, 'vXGroupUsers', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXGroupPermission extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * the groupId
     *
     * @var integer
     */
    private $groupId;

    /**
     * the groupName
     *
     * @var string
     */
    private $groupName;

    /**
     * the moduleId
     *
     * @var integer
     */
    private $moduleId;

    /**
     * the isAllowed
     *
     * @var integer
     */
    private $isAllowed;

    /**
     * (no documentation provided)
     *
     * @var string
     */
    private $moduleName;

    /**
     * Constructs a VXGroupPermission from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * the groupId
     *
     * @return integer
     */
    public function getGroupId()
    {
        return $this->groupId;
    }

    /**
     * the groupId
     *
     * @param integer $groupId
     */
    public function setGroupId($groupId)
    {
        $this->groupId = $groupId;
    }
    /**
     * the groupName
     *
     * @return string
     */
    public function getGroupName()
    {
        return $this->groupName;
    }

    /**
     * the groupName
     *
     * @param string $groupName
     */
    public function setGroupName($groupName)
    {
        $this->groupName = $groupName;
    }
    /**
     * the moduleId
     *
     * @return integer
     */
    public function getModuleId()
    {
        return $this->moduleId;
    }

    /**
     * the moduleId
     *
     * @param integer $moduleId
     */
    public function setModuleId($moduleId)
    {
        $this->moduleId = $moduleId;
    }
    /**
     * the isAllowed
     *
     * @return integer
     */
    public function getIsAllowed()
    {
        return $this->isAllowed;
    }

    /**
     * the isAllowed
     *
     * @param integer $isAllowed
     */
    public function setIsAllowed($isAllowed)
    {
        $this->isAllowed = $isAllowed;
    }
    /**
     * (no documentation provided)
     *
     * @return string
     */
    public function getModuleName()
    {
        return $this->moduleName;
    }

    /**
     * (no documentation provided)
     *
     * @param string $moduleName
     */
    public function setModuleName($moduleName)
    {
        $this->moduleName = $moduleName;
    }

    /**
     * Sets a known child element of VXGroupPermission from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'groupId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'moduleId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->moduleId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isAllowed') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isAllowed = $child;
            $happened = true;
        }
        else if (($xml->localName == 'moduleName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->moduleName = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXGroupPermission from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXGroupPermission to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXGroupPermission', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXGroupPermission to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->groupId) {
            $writer->startElementNs(null, 'groupId', null);
            $writer->text($this->groupId);
            $writer->endElement();
        }
        if ($this->groupName) {
            $writer->startElementNs(null, 'groupName', null);
            $writer->text($this->groupName);
            $writer->endElement();
        }
        if ($this->moduleId) {
            $writer->startElementNs(null, 'moduleId', null);
            $writer->text($this->moduleId);
            $writer->endElement();
        }
        if ($this->isAllowed) {
            $writer->startElementNs(null, 'isAllowed', null);
            $writer->text($this->isAllowed);
            $writer->endElement();
        }
        if ($this->moduleName) {
            $writer->startElementNs(null, 'moduleName', null);
            $writer->text($this->moduleName);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXAssetList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXAsset[]
     */
    private $vXAssets;

    /**
     * Constructs a VXAssetList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXAsset[]
     */
    public function getVXAssets()
    {
        return $this->vXAssets;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXAsset[] $vXAssets
     */
    public function setVXAssets($vXAssets)
    {
        $this->vXAssets = $vXAssets;
    }

    /**
     * Sets a known child element of VXAssetList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXAssets') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXAsset($xml);
            if (!isset($this->vXAssets)) {
                $this->vXAssets = array();
            }
            array_push($this->vXAssets, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXAssetList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXAssetList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXAssetList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXAssetList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXAssets) {
            foreach ($this->vXAssets as $i => $x) {
                $writer->startElementNs(null, 'vXAssets', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXAuditMap extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * Long - value of member attribute &lt;b&gt;resourceId&lt;/b&gt;.
     *
     * @var integer
     */
    private $resourceId;

    /**
     * Long - value of member attribute &lt;b&gt;groupId&lt;/b&gt;.
     *
     * @var integer
     */
    private $groupId;

    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @var integer
     */
    private $userId;

    /**
     * int - value of member attribute &lt;b&gt;auditType&lt;/b&gt;.
     *
     * @var integer
     */
    private $auditType;

    /**
     * Constructs a VXAuditMap from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * Long - value of member attribute &lt;b&gt;resourceId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getResourceId()
    {
        return $this->resourceId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;resourceId&lt;/b&gt;.
     *
     * @param integer $resourceId
     */
    public function setResourceId($resourceId)
    {
        $this->resourceId = $resourceId;
    }
    /**
     * Long - value of member attribute &lt;b&gt;groupId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getGroupId()
    {
        return $this->groupId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;groupId&lt;/b&gt;.
     *
     * @param integer $groupId
     */
    public function setGroupId($groupId)
    {
        $this->groupId = $groupId;
    }
    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getUserId()
    {
        return $this->userId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @param integer $userId
     */
    public function setUserId($userId)
    {
        $this->userId = $userId;
    }
    /**
     * int - value of member attribute &lt;b&gt;auditType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getAuditType()
    {
        return $this->auditType;
    }

    /**
     * int - value of member attribute &lt;b&gt;auditType&lt;/b&gt;.
     *
     * @param integer $auditType
     */
    public function setAuditType($auditType)
    {
        $this->auditType = $auditType;
    }

    /**
     * Sets a known child element of VXAuditMap from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'resourceId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'auditType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->auditType = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXAuditMap from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXAuditMap to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXAuditMap', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXAuditMap to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->resourceId) {
            $writer->startElementNs(null, 'resourceId', null);
            $writer->text($this->resourceId);
            $writer->endElement();
        }
        if ($this->groupId) {
            $writer->startElementNs(null, 'groupId', null);
            $writer->text($this->groupId);
            $writer->endElement();
        }
        if ($this->userId) {
            $writer->startElementNs(null, 'userId', null);
            $writer->text($this->userId);
            $writer->endElement();
        }
        if ($this->auditType) {
            $writer->startElementNs(null, 'auditType', null);
            $writer->text($this->auditType);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXAuditMapList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXAuditMap[]
     */
    private $vXAuditMaps;

    /**
     * Constructs a VXAuditMapList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXAuditMap[]
     */
    public function getVXAuditMaps()
    {
        return $this->vXAuditMaps;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXAuditMap[] $vXAuditMaps
     */
    public function setVXAuditMaps($vXAuditMaps)
    {
        $this->vXAuditMaps = $vXAuditMaps;
    }

    /**
     * Sets a known child element of VXAuditMapList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXAuditMaps') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXAuditMap($xml);
            if (!isset($this->vXAuditMaps)) {
                $this->vXAuditMaps = array();
            }
            array_push($this->vXAuditMaps, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXAuditMapList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXAuditMapList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXAuditMapList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXAuditMapList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXAuditMaps) {
            foreach ($this->vXAuditMaps as $i => $x) {
                $writer->startElementNs(null, 'vXAuditMaps', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXAuditRecordList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXAuditRecord[]
     */
    private $vXAuditRecords;

    /**
     * Constructs a VXAuditRecordList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXAuditRecord[]
     */
    public function getVXAuditRecords()
    {
        return $this->vXAuditRecords;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXAuditRecord[] $vXAuditRecords
     */
    public function setVXAuditRecords($vXAuditRecords)
    {
        $this->vXAuditRecords = $vXAuditRecords;
    }

    /**
     * Sets a known child element of VXAuditRecordList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXAuditRecords') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXAuditRecord($xml);
            if (!isset($this->vXAuditRecords)) {
                $this->vXAuditRecords = array();
            }
            array_push($this->vXAuditRecords, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXAuditRecordList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXAuditRecordList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXAuditRecordList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXAuditRecordList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXAuditRecords) {
            foreach ($this->vXAuditRecords as $i => $x) {
                $writer->startElementNs(null, 'vXAuditRecords', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXAuthSession extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;loginId&lt;/b&gt;.
     *
     * @var string
     */
    private $loginId;

    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @var integer
     */
    private $userId;

    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @var string
     */
    private $emailAddress;

    /**
     * boolean - value of member attribute &lt;b&gt;isTestUser&lt;/b&gt;.
     *
     * @var boolean
     */
    private $isTestUser;

    /**
     * String - value of member attribute &lt;b&gt;firstName&lt;/b&gt;.
     *
     * @var string
     */
    private $firstName;

    /**
     * String - value of member attribute &lt;b&gt;lastName&lt;/b&gt;.
     *
     * @var string
     */
    private $lastName;

    /**
     * String - value of member attribute &lt;b&gt;publicScreenName&lt;/b&gt;.
     *
     * @var string
     */
    private $publicScreenName;

    /**
     * String - value of member attribute &lt;b&gt;familyScreenName&lt;/b&gt;.
     *
     * @var string
     */
    private $familyScreenName;

    /**
     * Date - value of member attribute &lt;b&gt;authTime&lt;/b&gt;.
     *
     * @var integer
     */
    private $authTime;

    /**
     * int - value of member attribute &lt;b&gt;authStatus&lt;/b&gt;.
     *
     * @var integer
     */
    private $authStatus;

    /**
     * int - value of member attribute &lt;b&gt;authType&lt;/b&gt;.
     *
     * @var integer
     */
    private $authType;

    /**
     * int - value of member attribute &lt;b&gt;authProvider&lt;/b&gt;.
     *
     * @var integer
     */
    private $authProvider;

    /**
     * int - value of member attribute &lt;b&gt;deviceType&lt;/b&gt;.
     *
     * @var integer
     */
    private $deviceType;

    /**
     * String - value of member attribute &lt;b&gt;requestIP&lt;/b&gt;.
     *
     * @var string
     */
    private $requestIP;

    /**
     * String - value of member attribute &lt;b&gt;cityName&lt;/b&gt;.
     *
     * @var string
     */
    private $cityName;

    /**
     * String - value of member attribute &lt;b&gt;stateName&lt;/b&gt;.
     *
     * @var string
     */
    private $stateName;

    /**
     * String - value of member attribute &lt;b&gt;countryName&lt;/b&gt;.
     *
     * @var string
     */
    private $countryName;

    /**
     * String - value of member attribute &lt;b&gt;requestUserAgent&lt;/b&gt;.
     *
     * @var string
     */
    private $requestUserAgent;

    /**
     * Constructs a VXAuthSession from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;loginId&lt;/b&gt;.
     *
     * @return string
     */
    public function getLoginId()
    {
        return $this->loginId;
    }

    /**
     * String - value of member attribute &lt;b&gt;loginId&lt;/b&gt;.
     *
     * @param string $loginId
     */
    public function setLoginId($loginId)
    {
        $this->loginId = $loginId;
    }
    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getUserId()
    {
        return $this->userId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;userId&lt;/b&gt;.
     *
     * @param integer $userId
     */
    public function setUserId($userId)
    {
        $this->userId = $userId;
    }
    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @return string
     */
    public function getEmailAddress()
    {
        return $this->emailAddress;
    }

    /**
     * String - value of member attribute &lt;b&gt;emailAddress&lt;/b&gt;.
     *
     * @param string $emailAddress
     */
    public function setEmailAddress($emailAddress)
    {
        $this->emailAddress = $emailAddress;
    }
    /**
     * boolean - value of member attribute &lt;b&gt;isTestUser&lt;/b&gt;.
     *
     * @return boolean
     */
    public function getIsTestUser()
    {
        return $this->isTestUser;
    }

    /**
     * boolean - value of member attribute &lt;b&gt;isTestUser&lt;/b&gt;.
     *
     * @param boolean $isTestUser
     */
    public function setIsTestUser($isTestUser)
    {
        $this->isTestUser = $isTestUser;
    }
    /**
     * String - value of member attribute &lt;b&gt;firstName&lt;/b&gt;.
     *
     * @return string
     */
    public function getFirstName()
    {
        return $this->firstName;
    }

    /**
     * String - value of member attribute &lt;b&gt;firstName&lt;/b&gt;.
     *
     * @param string $firstName
     */
    public function setFirstName($firstName)
    {
        $this->firstName = $firstName;
    }
    /**
     * String - value of member attribute &lt;b&gt;lastName&lt;/b&gt;.
     *
     * @return string
     */
    public function getLastName()
    {
        return $this->lastName;
    }

    /**
     * String - value of member attribute &lt;b&gt;lastName&lt;/b&gt;.
     *
     * @param string $lastName
     */
    public function setLastName($lastName)
    {
        $this->lastName = $lastName;
    }
    /**
     * String - value of member attribute &lt;b&gt;publicScreenName&lt;/b&gt;.
     *
     * @return string
     */
    public function getPublicScreenName()
    {
        return $this->publicScreenName;
    }

    /**
     * String - value of member attribute &lt;b&gt;publicScreenName&lt;/b&gt;.
     *
     * @param string $publicScreenName
     */
    public function setPublicScreenName($publicScreenName)
    {
        $this->publicScreenName = $publicScreenName;
    }
    /**
     * String - value of member attribute &lt;b&gt;familyScreenName&lt;/b&gt;.
     *
     * @return string
     */
    public function getFamilyScreenName()
    {
        return $this->familyScreenName;
    }

    /**
     * String - value of member attribute &lt;b&gt;familyScreenName&lt;/b&gt;.
     *
     * @param string $familyScreenName
     */
    public function setFamilyScreenName($familyScreenName)
    {
        $this->familyScreenName = $familyScreenName;
    }
    /**
     * Date - value of member attribute &lt;b&gt;authTime&lt;/b&gt;.
     *
     * @return integer
     */
    public function getAuthTime()
    {
        return $this->authTime;
    }

    /**
     * Date - value of member attribute &lt;b&gt;authTime&lt;/b&gt;.
     *
     * @param integer $authTime
     */
    public function setAuthTime($authTime)
    {
        $this->authTime = $authTime;
    }
    /**
     * int - value of member attribute &lt;b&gt;authStatus&lt;/b&gt;.
     *
     * @return integer
     */
    public function getAuthStatus()
    {
        return $this->authStatus;
    }

    /**
     * int - value of member attribute &lt;b&gt;authStatus&lt;/b&gt;.
     *
     * @param integer $authStatus
     */
    public function setAuthStatus($authStatus)
    {
        $this->authStatus = $authStatus;
    }
    /**
     * int - value of member attribute &lt;b&gt;authType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getAuthType()
    {
        return $this->authType;
    }

    /**
     * int - value of member attribute &lt;b&gt;authType&lt;/b&gt;.
     *
     * @param integer $authType
     */
    public function setAuthType($authType)
    {
        $this->authType = $authType;
    }
    /**
     * int - value of member attribute &lt;b&gt;authProvider&lt;/b&gt;.
     *
     * @return integer
     */
    public function getAuthProvider()
    {
        return $this->authProvider;
    }

    /**
     * int - value of member attribute &lt;b&gt;authProvider&lt;/b&gt;.
     *
     * @param integer $authProvider
     */
    public function setAuthProvider($authProvider)
    {
        $this->authProvider = $authProvider;
    }
    /**
     * int - value of member attribute &lt;b&gt;deviceType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getDeviceType()
    {
        return $this->deviceType;
    }

    /**
     * int - value of member attribute &lt;b&gt;deviceType&lt;/b&gt;.
     *
     * @param integer $deviceType
     */
    public function setDeviceType($deviceType)
    {
        $this->deviceType = $deviceType;
    }
    /**
     * String - value of member attribute &lt;b&gt;requestIP&lt;/b&gt;.
     *
     * @return string
     */
    public function getRequestIP()
    {
        return $this->requestIP;
    }

    /**
     * String - value of member attribute &lt;b&gt;requestIP&lt;/b&gt;.
     *
     * @param string $requestIP
     */
    public function setRequestIP($requestIP)
    {
        $this->requestIP = $requestIP;
    }
    /**
     * String - value of member attribute &lt;b&gt;cityName&lt;/b&gt;.
     *
     * @return string
     */
    public function getCityName()
    {
        return $this->cityName;
    }

    /**
     * String - value of member attribute &lt;b&gt;cityName&lt;/b&gt;.
     *
     * @param string $cityName
     */
    public function setCityName($cityName)
    {
        $this->cityName = $cityName;
    }
    /**
     * String - value of member attribute &lt;b&gt;stateName&lt;/b&gt;.
     *
     * @return string
     */
    public function getStateName()
    {
        return $this->stateName;
    }

    /**
     * String - value of member attribute &lt;b&gt;stateName&lt;/b&gt;.
     *
     * @param string $stateName
     */
    public function setStateName($stateName)
    {
        $this->stateName = $stateName;
    }
    /**
     * String - value of member attribute &lt;b&gt;countryName&lt;/b&gt;.
     *
     * @return string
     */
    public function getCountryName()
    {
        return $this->countryName;
    }

    /**
     * String - value of member attribute &lt;b&gt;countryName&lt;/b&gt;.
     *
     * @param string $countryName
     */
    public function setCountryName($countryName)
    {
        $this->countryName = $countryName;
    }
    /**
     * String - value of member attribute &lt;b&gt;requestUserAgent&lt;/b&gt;.
     *
     * @return string
     */
    public function getRequestUserAgent()
    {
        return $this->requestUserAgent;
    }

    /**
     * String - value of member attribute &lt;b&gt;requestUserAgent&lt;/b&gt;.
     *
     * @param string $requestUserAgent
     */
    public function setRequestUserAgent($requestUserAgent)
    {
        $this->requestUserAgent = $requestUserAgent;
    }

    /**
     * Sets a known child element of VXAuthSession from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'loginId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->loginId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'userId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->userId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'emailAddress') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->emailAddress = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isTestUser') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isTestUser = $child;
            $happened = true;
        }
        else if (($xml->localName == 'firstName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->firstName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'lastName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->lastName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'publicScreenName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->publicScreenName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'familyScreenName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->familyScreenName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'authTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->authTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'authStatus') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->authStatus = $child;
            $happened = true;
        }
        else if (($xml->localName == 'authType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->authType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'authProvider') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->authProvider = $child;
            $happened = true;
        }
        else if (($xml->localName == 'deviceType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->deviceType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'requestIP') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->requestIP = $child;
            $happened = true;
        }
        else if (($xml->localName == 'cityName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->cityName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'stateName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->stateName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'countryName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->countryName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'requestUserAgent') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->requestUserAgent = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXAuthSession from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXAuthSession to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXAuthSession', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXAuthSession to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->loginId) {
            $writer->startElementNs(null, 'loginId', null);
            $writer->text($this->loginId);
            $writer->endElement();
        }
        if ($this->userId) {
            $writer->startElementNs(null, 'userId', null);
            $writer->text($this->userId);
            $writer->endElement();
        }
        if ($this->emailAddress) {
            $writer->startElementNs(null, 'emailAddress', null);
            $writer->text($this->emailAddress);
            $writer->endElement();
        }
        if ($this->isTestUser) {
            $writer->startElementNs(null, 'isTestUser', null);
            $writer->text($this->isTestUser);
            $writer->endElement();
        }
        if ($this->firstName) {
            $writer->startElementNs(null, 'firstName', null);
            $writer->text($this->firstName);
            $writer->endElement();
        }
        if ($this->lastName) {
            $writer->startElementNs(null, 'lastName', null);
            $writer->text($this->lastName);
            $writer->endElement();
        }
        if ($this->publicScreenName) {
            $writer->startElementNs(null, 'publicScreenName', null);
            $writer->text($this->publicScreenName);
            $writer->endElement();
        }
        if ($this->familyScreenName) {
            $writer->startElementNs(null, 'familyScreenName', null);
            $writer->text($this->familyScreenName);
            $writer->endElement();
        }
        if ($this->authTime) {
            $writer->startElementNs(null, 'authTime', null);
            $writer->text($this->authTime);
            $writer->endElement();
        }
        if ($this->authStatus) {
            $writer->startElementNs(null, 'authStatus', null);
            $writer->text($this->authStatus);
            $writer->endElement();
        }
        if ($this->authType) {
            $writer->startElementNs(null, 'authType', null);
            $writer->text($this->authType);
            $writer->endElement();
        }
        if ($this->authProvider) {
            $writer->startElementNs(null, 'authProvider', null);
            $writer->text($this->authProvider);
            $writer->endElement();
        }
        if ($this->deviceType) {
            $writer->startElementNs(null, 'deviceType', null);
            $writer->text($this->deviceType);
            $writer->endElement();
        }
        if ($this->requestIP) {
            $writer->startElementNs(null, 'requestIP', null);
            $writer->text($this->requestIP);
            $writer->endElement();
        }
        if ($this->cityName) {
            $writer->startElementNs(null, 'cityName', null);
            $writer->text($this->cityName);
            $writer->endElement();
        }
        if ($this->stateName) {
            $writer->startElementNs(null, 'stateName', null);
            $writer->text($this->stateName);
            $writer->endElement();
        }
        if ($this->countryName) {
            $writer->startElementNs(null, 'countryName', null);
            $writer->text($this->countryName);
            $writer->endElement();
        }
        if ($this->requestUserAgent) {
            $writer->startElementNs(null, 'requestUserAgent', null);
            $writer->text($this->requestUserAgent);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXAuthSessionList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXAuthSession[]
     */
    private $vXAuthSessions;

    /**
     * Constructs a VXAuthSessionList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXAuthSession[]
     */
    public function getVXAuthSessions()
    {
        return $this->vXAuthSessions;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXAuthSession[] $vXAuthSessions
     */
    public function setVXAuthSessions($vXAuthSessions)
    {
        $this->vXAuthSessions = $vXAuthSessions;
    }

    /**
     * Sets a known child element of VXAuthSessionList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXAuthSessions') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXAuthSession($xml);
            if (!isset($this->vXAuthSessions)) {
                $this->vXAuthSessions = array();
            }
            array_push($this->vXAuthSessions, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXAuthSessionList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXAuthSessionList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXAuthSessionList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXAuthSessionList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXAuthSessions) {
            foreach ($this->vXAuthSessions as $i => $x) {
                $writer->startElementNs(null, 'vXAuthSessions', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXCredentialStoreList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXCredentialStore[]
     */
    private $vXCredentialStores;

    /**
     * Constructs a VXCredentialStoreList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXCredentialStore[]
     */
    public function getVXCredentialStores()
    {
        return $this->vXCredentialStores;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXCredentialStore[] $vXCredentialStores
     */
    public function setVXCredentialStores($vXCredentialStores)
    {
        $this->vXCredentialStores = $vXCredentialStores;
    }

    /**
     * Sets a known child element of VXCredentialStoreList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXCredentialStores') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXCredentialStore($xml);
            if (!isset($this->vXCredentialStores)) {
                $this->vXCredentialStores = array();
            }
            array_push($this->vXCredentialStores, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXCredentialStoreList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXCredentialStoreList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXCredentialStoreList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXCredentialStoreList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXCredentialStores) {
            foreach ($this->vXCredentialStores as $i => $x) {
                $writer->startElementNs(null, 'vXCredentialStores', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXGroup extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @var string
     */
    private $name;

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @var string
     */
    private $description;

    /**
     * int - value of member attribute &lt;b&gt;groupType&lt;/b&gt;.
     *
     * @var integer
     */
    private $groupType;

    /**
     * Long - value of member attribute &lt;b&gt;credStoreId&lt;/b&gt;.
     *
     * @var integer
     */
    private $credStoreId;

    /**
     * the isVisible
     *
     * @var integer
     */
    private $isVisible;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $groupSource;

    /**
     * Constructs a VXGroup from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * int - value of member attribute &lt;b&gt;groupType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getGroupType()
    {
        return $this->groupType;
    }

    /**
     * int - value of member attribute &lt;b&gt;groupType&lt;/b&gt;.
     *
     * @param integer $groupType
     */
    public function setGroupType($groupType)
    {
        $this->groupType = $groupType;
    }
    /**
     * Long - value of member attribute &lt;b&gt;credStoreId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getCredStoreId()
    {
        return $this->credStoreId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;credStoreId&lt;/b&gt;.
     *
     * @param integer $credStoreId
     */
    public function setCredStoreId($credStoreId)
    {
        $this->credStoreId = $credStoreId;
    }
    /**
     * the isVisible
     *
     * @return integer
     */
    public function getIsVisible()
    {
        return $this->isVisible;
    }

    /**
     * the isVisible
     *
     * @param integer $isVisible
     */
    public function setIsVisible($isVisible)
    {
        $this->isVisible = $isVisible;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getGroupSource()
    {
        return $this->groupSource;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $groupSource
     */
    public function setGroupSource($groupSource)
    {
        $this->groupSource = $groupSource;
    }

    /**
     * Sets a known child element of VXGroup from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'credStoreId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->credStoreId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'isVisible') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->isVisible = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupSource') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupSource = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXGroup from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXGroup to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXGroup', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXGroup to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->groupType) {
            $writer->startElementNs(null, 'groupType', null);
            $writer->text($this->groupType);
            $writer->endElement();
        }
        if ($this->credStoreId) {
            $writer->startElementNs(null, 'credStoreId', null);
            $writer->text($this->credStoreId);
            $writer->endElement();
        }
        if ($this->isVisible) {
            $writer->startElementNs(null, 'isVisible', null);
            $writer->text($this->isVisible);
            $writer->endElement();
        }
        if ($this->groupSource) {
            $writer->startElementNs(null, 'groupSource', null);
            $writer->text($this->groupSource);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXGroupGroup extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @var string
     */
    private $name;

    /**
     * Long - value of member attribute &lt;b&gt;parentGroupId&lt;/b&gt;.
     *
     * @var integer
     */
    private $parentGroupId;

    /**
     * Long - value of member attribute &lt;b&gt;groupId&lt;/b&gt;.
     *
     * @var integer
     */
    private $groupId;

    /**
     * Constructs a VXGroupGroup from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * Long - value of member attribute &lt;b&gt;parentGroupId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getParentGroupId()
    {
        return $this->parentGroupId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;parentGroupId&lt;/b&gt;.
     *
     * @param integer $parentGroupId
     */
    public function setParentGroupId($parentGroupId)
    {
        $this->parentGroupId = $parentGroupId;
    }
    /**
     * Long - value of member attribute &lt;b&gt;groupId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getGroupId()
    {
        return $this->groupId;
    }

    /**
     * Long - value of member attribute &lt;b&gt;groupId&lt;/b&gt;.
     *
     * @param integer $groupId
     */
    public function setGroupId($groupId)
    {
        $this->groupId = $groupId;
    }

    /**
     * Sets a known child element of VXGroupGroup from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'parentGroupId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->parentGroupId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'groupId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->groupId = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXGroupGroup from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXGroupGroup to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXGroupGroup', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXGroupGroup to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->parentGroupId) {
            $writer->startElementNs(null, 'parentGroupId', null);
            $writer->text($this->parentGroupId);
            $writer->endElement();
        }
        if ($this->groupId) {
            $writer->startElementNs(null, 'groupId', null);
            $writer->text($this->groupId);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXCredentialStore extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @var string
     */
    private $name;

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @var string
     */
    private $description;

    /**
     * Constructs a VXCredentialStore from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }

    /**
     * Sets a known child element of VXCredentialStore from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXCredentialStore from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXCredentialStore to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXCredentialStore', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXCredentialStore to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXAsset extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @var string
     */
    private $name;

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @var string
     */
    private $description;

    /**
     * int - value of member attribute &lt;b&gt;activeStatus&lt;/b&gt;.
     *
     * @var integer
     */
    private $activeStatus;

    /**
     * int - value of member attribute &lt;b&gt;assetType&lt;/b&gt;.
     *
     * @var integer
     */
    private $assetType;

    /**
     * String - value of member attribute &lt;b&gt;config&lt;/b&gt;.
     *
     * @var string
     */
    private $config;

    /**
     * boolean - value of member attribute &lt;b&gt;supportNative&lt;/b&gt;.
     *
     * @var boolean
     */
    private $supportNative;

    /**
     * Constructs a VXAsset from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * String - value of member attribute &lt;b&gt;name&lt;/b&gt;.
     *
     * @param string $name
     */
    public function setName($name)
    {
        $this->name = $name;
    }
    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @return string
     */
    public function getDescription()
    {
        return $this->description;
    }

    /**
     * String - value of member attribute &lt;b&gt;description&lt;/b&gt;.
     *
     * @param string $description
     */
    public function setDescription($description)
    {
        $this->description = $description;
    }
    /**
     * int - value of member attribute &lt;b&gt;activeStatus&lt;/b&gt;.
     *
     * @return integer
     */
    public function getActiveStatus()
    {
        return $this->activeStatus;
    }

    /**
     * int - value of member attribute &lt;b&gt;activeStatus&lt;/b&gt;.
     *
     * @param integer $activeStatus
     */
    public function setActiveStatus($activeStatus)
    {
        $this->activeStatus = $activeStatus;
    }
    /**
     * int - value of member attribute &lt;b&gt;assetType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getAssetType()
    {
        return $this->assetType;
    }

    /**
     * int - value of member attribute &lt;b&gt;assetType&lt;/b&gt;.
     *
     * @param integer $assetType
     */
    public function setAssetType($assetType)
    {
        $this->assetType = $assetType;
    }
    /**
     * String - value of member attribute &lt;b&gt;config&lt;/b&gt;.
     *
     * @return string
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * String - value of member attribute &lt;b&gt;config&lt;/b&gt;.
     *
     * @param string $config
     */
    public function setConfig($config)
    {
        $this->config = $config;
    }
    /**
     * boolean - value of member attribute &lt;b&gt;supportNative&lt;/b&gt;.
     *
     * @return boolean
     */
    public function getSupportNative()
    {
        return $this->supportNative;
    }

    /**
     * boolean - value of member attribute &lt;b&gt;supportNative&lt;/b&gt;.
     *
     * @param boolean $supportNative
     */
    public function setSupportNative($supportNative)
    {
        $this->supportNative = $supportNative;
    }

    /**
     * Sets a known child element of VXAsset from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'name') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->name = $child;
            $happened = true;
        }
        else if (($xml->localName == 'description') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->description = $child;
            $happened = true;
        }
        else if (($xml->localName == 'activeStatus') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->activeStatus = $child;
            $happened = true;
        }
        else if (($xml->localName == 'assetType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->assetType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'config') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->config = $child;
            $happened = true;
        }
        else if (($xml->localName == 'supportNative') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->supportNative = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXAsset from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXAsset to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXAsset', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXAsset to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->name) {
            $writer->startElementNs(null, 'name', null);
            $writer->text($this->name);
            $writer->endElement();
        }
        if ($this->description) {
            $writer->startElementNs(null, 'description', null);
            $writer->text($this->description);
            $writer->endElement();
        }
        if ($this->activeStatus) {
            $writer->startElementNs(null, 'activeStatus', null);
            $writer->text($this->activeStatus);
            $writer->endElement();
        }
        if ($this->assetType) {
            $writer->startElementNs(null, 'assetType', null);
            $writer->text($this->assetType);
            $writer->endElement();
        }
        if ($this->config) {
            $writer->startElementNs(null, 'config', null);
            $writer->text($this->config);
            $writer->endElement();
        }
        if ($this->supportNative) {
            $writer->startElementNs(null, 'supportNative', null);
            $writer->text($this->supportNative);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class RangerServiceList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerService[]
     */
    private $services;

    /**
     * Constructs a RangerServiceList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerService[]
     */
    public function getServices()
    {
        return $this->services;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerService[] $services
     */
    public function setServices($services)
    {
        $this->services = $services;
    }

    /**
     * Sets a known child element of RangerServiceList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'services') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerService($xml);
            if (!isset($this->services)) {
                $this->services = array();
            }
            array_push($this->services, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerServiceList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerServiceList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerServiceList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerServiceList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->services) {
            foreach ($this->services as $i => $x) {
                $writer->startElementNs(null, 'services', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXAccessAudit extends \Org\Apache\Ranger\View\VXDataObject
{

    /**
     * int - value of member attribute &lt;b&gt;auditType&lt;/b&gt;.
     *
     * @var integer
     */
    private $auditType;

    /**
     * int - value of member attribute &lt;b&gt;accessResult&lt;/b&gt;.
     *
     * @var integer
     */
    private $accessResult;

    /**
     * String - value of member attribute &lt;b&gt;accessType&lt;/b&gt;.
     *
     * @var string
     */
    private $accessType;

    /**
     * String - value of member attribute &lt;b&gt;aclEnforcer&lt;/b&gt;.
     *
     * @var string
     */
    private $aclEnforcer;

    /**
     * String - value of member attribute &lt;b&gt;agentId&lt;/b&gt;.
     *
     * @var string
     */
    private $agentId;

    /**
     * String - value of member attribute &lt;b&gt;clientIP&lt;/b&gt;.
     *
     * @var string
     */
    private $clientIP;

    /**
     * String - value of member attribute &lt;b&gt;clientType&lt;/b&gt;.
     *
     * @var string
     */
    private $clientType;

    /**
     * long - value of member attribute &lt;b&gt;policyId&lt;/b&gt;.
     *
     * @var integer
     */
    private $policyId;

    /**
     * String - value of member attribute &lt;b&gt;repoName&lt;/b&gt;.
     *
     * @var string
     */
    private $repoName;

    /**
     * int - value of member attribute &lt;b&gt;repoType&lt;/b&gt;.
     *
     * @var integer
     */
    private $repoType;

    /**
     * the serviceType
     *
     * @var string
     */
    private $serviceType;

    /**
     * String - value of member attribute &lt;b&gt;resultReason&lt;/b&gt;.
     *
     * @var string
     */
    private $resultReason;

    /**
     * String - value of member attribute &lt;b&gt;sessionId&lt;/b&gt;.
     *
     * @var string
     */
    private $sessionId;

    /**
     * Date - value of member attribute &lt;b&gt;eventTime&lt;/b&gt;.
     *
     * @var integer
     */
    private $eventTime;

    /**
     * String - value of member attribute &lt;b&gt;requestUser&lt;/b&gt;.
     *
     * @var string
     */
    private $requestUser;

    /**
     * String - value of member attribute &lt;b&gt;action&lt;/b&gt;.
     *
     * @var string
     */
    private $action;

    /**
     * String - value of member attribute &lt;b&gt;requestData&lt;/b&gt;.
     *
     * @var string
     */
    private $requestData;

    /**
     * String - value of member attribute &lt;b&gt;resourcePath&lt;/b&gt;.
     *
     * @var string
     */
    private $resourcePath;

    /**
     * String - value of member attribute &lt;b&gt;resourceType&lt;/b&gt;.
     *
     * @var string
     */
    private $resourceType;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $sequenceNumber;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $eventCount;

    /**
     * (no documentation provided)
     *
     * @var integer
     */
    private $eventDuration;

    /**
     * the tags
     *
     * @var string
     */
    private $tags;

    /**
     * the clusterName
     *
     * @var string
     */
    private $clusterName;

    /**
     * the zoneName
     *
     * @var string
     */
    private $zoneName;

    /**
     * the policyVersion
     *
     * @var integer
     */
    private $policyVersion;

    /**
     * Constructs a VXAccessAudit from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * int - value of member attribute &lt;b&gt;auditType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getAuditType()
    {
        return $this->auditType;
    }

    /**
     * int - value of member attribute &lt;b&gt;auditType&lt;/b&gt;.
     *
     * @param integer $auditType
     */
    public function setAuditType($auditType)
    {
        $this->auditType = $auditType;
    }
    /**
     * int - value of member attribute &lt;b&gt;accessResult&lt;/b&gt;.
     *
     * @return integer
     */
    public function getAccessResult()
    {
        return $this->accessResult;
    }

    /**
     * int - value of member attribute &lt;b&gt;accessResult&lt;/b&gt;.
     *
     * @param integer $accessResult
     */
    public function setAccessResult($accessResult)
    {
        $this->accessResult = $accessResult;
    }
    /**
     * String - value of member attribute &lt;b&gt;accessType&lt;/b&gt;.
     *
     * @return string
     */
    public function getAccessType()
    {
        return $this->accessType;
    }

    /**
     * String - value of member attribute &lt;b&gt;accessType&lt;/b&gt;.
     *
     * @param string $accessType
     */
    public function setAccessType($accessType)
    {
        $this->accessType = $accessType;
    }
    /**
     * String - value of member attribute &lt;b&gt;aclEnforcer&lt;/b&gt;.
     *
     * @return string
     */
    public function getAclEnforcer()
    {
        return $this->aclEnforcer;
    }

    /**
     * String - value of member attribute &lt;b&gt;aclEnforcer&lt;/b&gt;.
     *
     * @param string $aclEnforcer
     */
    public function setAclEnforcer($aclEnforcer)
    {
        $this->aclEnforcer = $aclEnforcer;
    }
    /**
     * String - value of member attribute &lt;b&gt;agentId&lt;/b&gt;.
     *
     * @return string
     */
    public function getAgentId()
    {
        return $this->agentId;
    }

    /**
     * String - value of member attribute &lt;b&gt;agentId&lt;/b&gt;.
     *
     * @param string $agentId
     */
    public function setAgentId($agentId)
    {
        $this->agentId = $agentId;
    }
    /**
     * String - value of member attribute &lt;b&gt;clientIP&lt;/b&gt;.
     *
     * @return string
     */
    public function getClientIP()
    {
        return $this->clientIP;
    }

    /**
     * String - value of member attribute &lt;b&gt;clientIP&lt;/b&gt;.
     *
     * @param string $clientIP
     */
    public function setClientIP($clientIP)
    {
        $this->clientIP = $clientIP;
    }
    /**
     * String - value of member attribute &lt;b&gt;clientType&lt;/b&gt;.
     *
     * @return string
     */
    public function getClientType()
    {
        return $this->clientType;
    }

    /**
     * String - value of member attribute &lt;b&gt;clientType&lt;/b&gt;.
     *
     * @param string $clientType
     */
    public function setClientType($clientType)
    {
        $this->clientType = $clientType;
    }
    /**
     * long - value of member attribute &lt;b&gt;policyId&lt;/b&gt;.
     *
     * @return integer
     */
    public function getPolicyId()
    {
        return $this->policyId;
    }

    /**
     * long - value of member attribute &lt;b&gt;policyId&lt;/b&gt;.
     *
     * @param integer $policyId
     */
    public function setPolicyId($policyId)
    {
        $this->policyId = $policyId;
    }
    /**
     * String - value of member attribute &lt;b&gt;repoName&lt;/b&gt;.
     *
     * @return string
     */
    public function getRepoName()
    {
        return $this->repoName;
    }

    /**
     * String - value of member attribute &lt;b&gt;repoName&lt;/b&gt;.
     *
     * @param string $repoName
     */
    public function setRepoName($repoName)
    {
        $this->repoName = $repoName;
    }
    /**
     * int - value of member attribute &lt;b&gt;repoType&lt;/b&gt;.
     *
     * @return integer
     */
    public function getRepoType()
    {
        return $this->repoType;
    }

    /**
     * int - value of member attribute &lt;b&gt;repoType&lt;/b&gt;.
     *
     * @param integer $repoType
     */
    public function setRepoType($repoType)
    {
        $this->repoType = $repoType;
    }
    /**
     * the serviceType
     *
     * @return string
     */
    public function getServiceType()
    {
        return $this->serviceType;
    }

    /**
     * the serviceType
     *
     * @param string $serviceType
     */
    public function setServiceType($serviceType)
    {
        $this->serviceType = $serviceType;
    }
    /**
     * String - value of member attribute &lt;b&gt;resultReason&lt;/b&gt;.
     *
     * @return string
     */
    public function getResultReason()
    {
        return $this->resultReason;
    }

    /**
     * String - value of member attribute &lt;b&gt;resultReason&lt;/b&gt;.
     *
     * @param string $resultReason
     */
    public function setResultReason($resultReason)
    {
        $this->resultReason = $resultReason;
    }
    /**
     * String - value of member attribute &lt;b&gt;sessionId&lt;/b&gt;.
     *
     * @return string
     */
    public function getSessionId()
    {
        return $this->sessionId;
    }

    /**
     * String - value of member attribute &lt;b&gt;sessionId&lt;/b&gt;.
     *
     * @param string $sessionId
     */
    public function setSessionId($sessionId)
    {
        $this->sessionId = $sessionId;
    }
    /**
     * Date - value of member attribute &lt;b&gt;eventTime&lt;/b&gt;.
     *
     * @return integer
     */
    public function getEventTime()
    {
        return $this->eventTime;
    }

    /**
     * Date - value of member attribute &lt;b&gt;eventTime&lt;/b&gt;.
     *
     * @param integer $eventTime
     */
    public function setEventTime($eventTime)
    {
        $this->eventTime = $eventTime;
    }
    /**
     * String - value of member attribute &lt;b&gt;requestUser&lt;/b&gt;.
     *
     * @return string
     */
    public function getRequestUser()
    {
        return $this->requestUser;
    }

    /**
     * String - value of member attribute &lt;b&gt;requestUser&lt;/b&gt;.
     *
     * @param string $requestUser
     */
    public function setRequestUser($requestUser)
    {
        $this->requestUser = $requestUser;
    }
    /**
     * String - value of member attribute &lt;b&gt;action&lt;/b&gt;.
     *
     * @return string
     */
    public function getAction()
    {
        return $this->action;
    }

    /**
     * String - value of member attribute &lt;b&gt;action&lt;/b&gt;.
     *
     * @param string $action
     */
    public function setAction($action)
    {
        $this->action = $action;
    }
    /**
     * String - value of member attribute &lt;b&gt;requestData&lt;/b&gt;.
     *
     * @return string
     */
    public function getRequestData()
    {
        return $this->requestData;
    }

    /**
     * String - value of member attribute &lt;b&gt;requestData&lt;/b&gt;.
     *
     * @param string $requestData
     */
    public function setRequestData($requestData)
    {
        $this->requestData = $requestData;
    }
    /**
     * String - value of member attribute &lt;b&gt;resourcePath&lt;/b&gt;.
     *
     * @return string
     */
    public function getResourcePath()
    {
        return $this->resourcePath;
    }

    /**
     * String - value of member attribute &lt;b&gt;resourcePath&lt;/b&gt;.
     *
     * @param string $resourcePath
     */
    public function setResourcePath($resourcePath)
    {
        $this->resourcePath = $resourcePath;
    }
    /**
     * String - value of member attribute &lt;b&gt;resourceType&lt;/b&gt;.
     *
     * @return string
     */
    public function getResourceType()
    {
        return $this->resourceType;
    }

    /**
     * String - value of member attribute &lt;b&gt;resourceType&lt;/b&gt;.
     *
     * @param string $resourceType
     */
    public function setResourceType($resourceType)
    {
        $this->resourceType = $resourceType;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getSequenceNumber()
    {
        return $this->sequenceNumber;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $sequenceNumber
     */
    public function setSequenceNumber($sequenceNumber)
    {
        $this->sequenceNumber = $sequenceNumber;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getEventCount()
    {
        return $this->eventCount;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $eventCount
     */
    public function setEventCount($eventCount)
    {
        $this->eventCount = $eventCount;
    }
    /**
     * (no documentation provided)
     *
     * @return integer
     */
    public function getEventDuration()
    {
        return $this->eventDuration;
    }

    /**
     * (no documentation provided)
     *
     * @param integer $eventDuration
     */
    public function setEventDuration($eventDuration)
    {
        $this->eventDuration = $eventDuration;
    }
    /**
     * the tags
     *
     * @return string
     */
    public function getTags()
    {
        return $this->tags;
    }

    /**
     * the tags
     *
     * @param string $tags
     */
    public function setTags($tags)
    {
        $this->tags = $tags;
    }
    /**
     * the clusterName
     *
     * @return string
     */
    public function getClusterName()
    {
        return $this->clusterName;
    }

    /**
     * the clusterName
     *
     * @param string $clusterName
     */
    public function setClusterName($clusterName)
    {
        $this->clusterName = $clusterName;
    }
    /**
     * the zoneName
     *
     * @return string
     */
    public function getZoneName()
    {
        return $this->zoneName;
    }

    /**
     * the zoneName
     *
     * @param string $zoneName
     */
    public function setZoneName($zoneName)
    {
        $this->zoneName = $zoneName;
    }
    /**
     * the policyVersion
     *
     * @return integer
     */
    public function getPolicyVersion()
    {
        return $this->policyVersion;
    }

    /**
     * the policyVersion
     *
     * @param integer $policyVersion
     */
    public function setPolicyVersion($policyVersion)
    {
        $this->policyVersion = $policyVersion;
    }

    /**
     * Sets a known child element of VXAccessAudit from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'auditType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->auditType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'accessResult') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->accessResult = $child;
            $happened = true;
        }
        else if (($xml->localName == 'accessType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->accessType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'aclEnforcer') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->aclEnforcer = $child;
            $happened = true;
        }
        else if (($xml->localName == 'agentId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->agentId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'clientIP') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->clientIP = $child;
            $happened = true;
        }
        else if (($xml->localName == 'clientType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->clientType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policyId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'repoName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->repoName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'repoType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->repoType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'serviceType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->serviceType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resultReason') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resultReason = $child;
            $happened = true;
        }
        else if (($xml->localName == 'sessionId') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->sessionId = $child;
            $happened = true;
        }
        else if (($xml->localName == 'eventTime') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->eventTime = $child;
            $happened = true;
        }
        else if (($xml->localName == 'requestUser') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->requestUser = $child;
            $happened = true;
        }
        else if (($xml->localName == 'action') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->action = $child;
            $happened = true;
        }
        else if (($xml->localName == 'requestData') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->requestData = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourcePath') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourcePath = $child;
            $happened = true;
        }
        else if (($xml->localName == 'resourceType') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->resourceType = $child;
            $happened = true;
        }
        else if (($xml->localName == 'sequenceNumber') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->sequenceNumber = $child;
            $happened = true;
        }
        else if (($xml->localName == 'eventCount') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->eventCount = $child;
            $happened = true;
        }
        else if (($xml->localName == 'eventDuration') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->eventDuration = $child;
            $happened = true;
        }
        else if (($xml->localName == 'tags') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->tags = $child;
            $happened = true;
        }
        else if (($xml->localName == 'clusterName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->clusterName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'zoneName') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->zoneName = $child;
            $happened = true;
        }
        else if (($xml->localName == 'policyVersion') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->policyVersion = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXAccessAudit from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXAccessAudit to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXAccessAudit', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXAccessAudit to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->auditType) {
            $writer->startElementNs(null, 'auditType', null);
            $writer->text($this->auditType);
            $writer->endElement();
        }
        if ($this->accessResult) {
            $writer->startElementNs(null, 'accessResult', null);
            $writer->text($this->accessResult);
            $writer->endElement();
        }
        if ($this->accessType) {
            $writer->startElementNs(null, 'accessType', null);
            $writer->text($this->accessType);
            $writer->endElement();
        }
        if ($this->aclEnforcer) {
            $writer->startElementNs(null, 'aclEnforcer', null);
            $writer->text($this->aclEnforcer);
            $writer->endElement();
        }
        if ($this->agentId) {
            $writer->startElementNs(null, 'agentId', null);
            $writer->text($this->agentId);
            $writer->endElement();
        }
        if ($this->clientIP) {
            $writer->startElementNs(null, 'clientIP', null);
            $writer->text($this->clientIP);
            $writer->endElement();
        }
        if ($this->clientType) {
            $writer->startElementNs(null, 'clientType', null);
            $writer->text($this->clientType);
            $writer->endElement();
        }
        if ($this->policyId) {
            $writer->startElementNs(null, 'policyId', null);
            $writer->text($this->policyId);
            $writer->endElement();
        }
        if ($this->repoName) {
            $writer->startElementNs(null, 'repoName', null);
            $writer->text($this->repoName);
            $writer->endElement();
        }
        if ($this->repoType) {
            $writer->startElementNs(null, 'repoType', null);
            $writer->text($this->repoType);
            $writer->endElement();
        }
        if ($this->serviceType) {
            $writer->startElementNs(null, 'serviceType', null);
            $writer->text($this->serviceType);
            $writer->endElement();
        }
        if ($this->resultReason) {
            $writer->startElementNs(null, 'resultReason', null);
            $writer->text($this->resultReason);
            $writer->endElement();
        }
        if ($this->sessionId) {
            $writer->startElementNs(null, 'sessionId', null);
            $writer->text($this->sessionId);
            $writer->endElement();
        }
        if ($this->eventTime) {
            $writer->startElementNs(null, 'eventTime', null);
            $writer->text($this->eventTime);
            $writer->endElement();
        }
        if ($this->requestUser) {
            $writer->startElementNs(null, 'requestUser', null);
            $writer->text($this->requestUser);
            $writer->endElement();
        }
        if ($this->action) {
            $writer->startElementNs(null, 'action', null);
            $writer->text($this->action);
            $writer->endElement();
        }
        if ($this->requestData) {
            $writer->startElementNs(null, 'requestData', null);
            $writer->text($this->requestData);
            $writer->endElement();
        }
        if ($this->resourcePath) {
            $writer->startElementNs(null, 'resourcePath', null);
            $writer->text($this->resourcePath);
            $writer->endElement();
        }
        if ($this->resourceType) {
            $writer->startElementNs(null, 'resourceType', null);
            $writer->text($this->resourceType);
            $writer->endElement();
        }
        if ($this->sequenceNumber) {
            $writer->startElementNs(null, 'sequenceNumber', null);
            $writer->text($this->sequenceNumber);
            $writer->endElement();
        }
        if ($this->eventCount) {
            $writer->startElementNs(null, 'eventCount', null);
            $writer->text($this->eventCount);
            $writer->endElement();
        }
        if ($this->eventDuration) {
            $writer->startElementNs(null, 'eventDuration', null);
            $writer->text($this->eventDuration);
            $writer->endElement();
        }
        if ($this->tags) {
            $writer->startElementNs(null, 'tags', null);
            $writer->text($this->tags);
            $writer->endElement();
        }
        if ($this->clusterName) {
            $writer->startElementNs(null, 'clusterName', null);
            $writer->text($this->clusterName);
            $writer->endElement();
        }
        if ($this->zoneName) {
            $writer->startElementNs(null, 'zoneName', null);
            $writer->text($this->zoneName);
            $writer->endElement();
        }
        if ($this->policyVersion) {
            $writer->startElementNs(null, 'policyVersion', null);
            $writer->text($this->policyVersion);
            $writer->endElement();
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class VXAccessAuditList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\View\VXAccessAudit[]
     */
    private $vXAccessAudits;

    /**
     * Constructs a VXAccessAuditList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\View\VXAccessAudit[]
     */
    public function getVXAccessAudits()
    {
        return $this->vXAccessAudits;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\View\VXAccessAudit[] $vXAccessAudits
     */
    public function setVXAccessAudits($vXAccessAudits)
    {
        $this->vXAccessAudits = $vXAccessAudits;
    }

    /**
     * Sets a known child element of VXAccessAuditList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'vXAccessAudits') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\View\VXAccessAudit($xml);
            if (!isset($this->vXAccessAudits)) {
                $this->vXAccessAudits = array();
            }
            array_push($this->vXAccessAudits, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of VXAccessAuditList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this VXAccessAuditList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'VXAccessAuditList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this VXAccessAuditList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->vXAccessAudits) {
            foreach ($this->vXAccessAudits as $i => $x) {
                $writer->startElementNs(null, 'vXAccessAudits', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class RangerPolicyList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPolicy[]
     */
    private $policies;

    /**
     * Constructs a RangerPolicyList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPolicy[]
     */
    public function getPolicies()
    {
        return $this->policies;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPolicy[] $policies
     */
    public function setPolicies($policies)
    {
        $this->policies = $policies;
    }

    /**
     * Sets a known child element of RangerPolicyList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'policies') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPolicy($xml);
            if (!isset($this->policies)) {
                $this->policies = array();
            }
            array_push($this->policies, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPolicyList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerPolicyList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPolicyList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPolicyList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->policies) {
            foreach ($this->policies as $i => $x) {
                $writer->startElementNs(null, 'policies', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class RangerServiceDefList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerServiceDef[]
     */
    private $serviceDefs;

    /**
     * Constructs a RangerServiceDefList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerServiceDef[]
     */
    public function getServiceDefs()
    {
        return $this->serviceDefs;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerServiceDef[] $serviceDefs
     */
    public function setServiceDefs($serviceDefs)
    {
        $this->serviceDefs = $serviceDefs;
    }

    /**
     * Sets a known child element of RangerServiceDefList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'serviceDefs') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerServiceDef($xml);
            if (!isset($this->serviceDefs)) {
                $this->serviceDefs = array();
            }
            array_push($this->serviceDefs, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerServiceDefList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerServiceDefList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerServiceDefList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerServiceDefList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->serviceDefs) {
            foreach ($this->serviceDefs as $i => $x) {
                $writer->startElementNs(null, 'serviceDefs', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class RangerPluginInfoList extends \Org\Apache\Ranger\Common\View\VList
{

    /**
     * (no documentation provided)
     *
     * @var \Org\Apache\Ranger\Plugin\Model\RangerPluginInfo[]
     */
    private $pluginInfoList;

    /**
     * Constructs a RangerPluginInfoList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return \Org\Apache\Ranger\Plugin\Model\RangerPluginInfo[]
     */
    public function getPluginInfoList()
    {
        return $this->pluginInfoList;
    }

    /**
     * (no documentation provided)
     *
     * @param \Org\Apache\Ranger\Plugin\Model\RangerPluginInfo[] $pluginInfoList
     */
    public function setPluginInfoList($pluginInfoList)
    {
        $this->pluginInfoList = $pluginInfoList;
    }

    /**
     * Sets a known child element of RangerPluginInfoList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'pluginInfoList') && (empty($xml->namespaceURI))) {
            $child = new \Org\Apache\Ranger\Plugin\Model\RangerPluginInfo($xml);
            if (!isset($this->pluginInfoList)) {
                $this->pluginInfoList = array();
            }
            array_push($this->pluginInfoList, $child);
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerPluginInfoList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerPluginInfoList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerPluginInfoList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerPluginInfoList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->pluginInfoList) {
            foreach ($this->pluginInfoList as $i => $x) {
                $writer->startElementNs(null, 'pluginInfoList', null);
                $x->writeXmlContents($writer);
                $writer->endElement();
            }
        }
    }
}

namespace Org\Apache\Ranger\View;

/**
 * (no documentation provided)
 */
class RangerExportPolicyList extends \Org\Apache\Ranger\View\RangerPolicyList
{

    /**
     * (no documentation provided)
     *
     * @var array
     */
    private $metaDataInfo;

    /**
     * Constructs a RangerExportPolicyList from an XMLReader
     *
     * @param \XMLReader $reader The reader.
     */
    public function __construct($reader = null)
    {
        $success = true;
        while ($success && $reader->nodeType != \XMLReader::ELEMENT) {
            $success = $reader->read();
        }
        if ($reader->nodeType != \XMLReader::ELEMENT) {
            throw new \Exception("Unable to read XML: no start element found.");
        }

        $this->initFromReader($reader);
    }

    /**
     * (no documentation provided)
     *
     * @return array
     */
    public function getMetaDataInfo()
    {
        return $this->metaDataInfo;
    }

    /**
     * (no documentation provided)
     *
     * @param array $metaDataInfo
     */
    public function setMetaDataInfo($metaDataInfo)
    {
        $this->metaDataInfo = $metaDataInfo;
    }

    /**
     * Sets a known child element of RangerExportPolicyList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether a child element was set.
     */
    protected function setKnownChildElement($xml) {
        $happened = parent::setKnownChildElement($xml);
        if ($happened) {
          return true;
        }
        else if (($xml->localName == 'metaDataInfo') && (empty($xml->namespaceURI))) {
            $child = '';
            while ($xml->read() && $xml->hasValue) {
                $child = $child . $xml->value;
            }
            $this->metaDataInfo = $child;
            $happened = true;
        }
        return $happened;
    }

    /**
     * Sets a known attribute of RangerExportPolicyList from an XML reader.
     *
     * @param \XMLReader $xml The reader.
     * @return bool Whether an attribute was set.
     */
    protected function setKnownAttribute($xml) {
        if (parent::setKnownAttribute($xml)) {
            return true;
        }

        return false;
    }

    /**
     * Writes this RangerExportPolicyList to an XML writer.
     *
     * @param \XMLWriter $writer The XML writer.
     * @param bool $includeNamespaces Whether to write out the namespaces in the element.
     */
    public function toXml($writer, $includeNamespaces = true)
    {
        $writer->startElementNS(null, 'rangerExportPolicyList', null);
        $this->writeXmlContents($writer);
        $writer->endElement();
    }

    /**
     * Writes the contents of this RangerExportPolicyList to an XML writer. The startElement is expected to be already provided.
     *
     * @param \XMLWriter $writer The XML writer.
     */
    public function writeXmlContents($writer)
    {
        parent::writeXmlContents($writer);
        if ($this->metaDataInfo) {
            $writer->startElementNs(null, 'metaDataInfo', null);
            $writer->text($this->metaDataInfo);
            $writer->endElement();
        }
    }
}
